/* DesktopIntegration.c generated by valac 0.44.0, the Vala compiler
 * generated from DesktopIntegration.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define TYPE_SORTED_LIST (sorted_list_get_type ())
#define SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SORTED_LIST, SortedList))
#define SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SORTED_LIST, SortedListClass))
#define IS_SORTED_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SORTED_LIST))
#define IS_SORTED_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SORTED_LIST))
#define SORTED_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SORTED_LIST, SortedListClass))

typedef struct _SortedList SortedList;
typedef struct _SortedListClass SortedListClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);

GAppInfo* desktop_integration_get_default_app_for_mime_types (gchar** mime_types,
                                                              gint mime_types_length1,
                                                              GeeArrayList* preferred_apps);
GType sorted_list_get_type (void) G_GNUC_CONST;
SortedList* desktop_integration_get_apps_for_mime_types (gchar** mime_types,
                                                         gint mime_types_length1);
gint64 desktop_integration_app_info_comparator (void* a,
                                                void* b);
static gint64 _desktop_integration_app_info_comparator_comparator (void* a,
                                                            void* b,
                                                            gpointer self);
SortedList* sorted_list_new (GType g_type,
                             GBoxedCopyFunc g_dup_func,
                             GDestroyNotify g_destroy_func,
                             Comparator cmp,
                             gpointer cmp_target);
SortedList* sorted_list_construct (GType object_type,
                                   GType g_type,
                                   GBoxedCopyFunc g_dup_func,
                                   GDestroyNotify g_destroy_func,
                                   Comparator cmp,
                                   gpointer cmp_target);
#define RESOURCES_APP_DIRECT_ROLE _ ("Photo Viewer")
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
gchar* desktop_integration_get_app_open_command (GAppInfo* app_info);

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/DesktopIntegration.vala"
	return self ? g_object_ref (self) : NULL;
#line 77 "DesktopIntegration.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 96 "DesktopIntegration.c"
}

GAppInfo*
desktop_integration_get_default_app_for_mime_types (gchar** mime_types,
                                                    gint mime_types_length1,
                                                    GeeArrayList* preferred_apps)
{
	GAppInfo* result = NULL;
	SortedList* external_apps = NULL;
	SortedList* _tmp0_;
#line 22 "../src/DesktopIntegration.vala"
	g_return_val_if_fail (preferred_apps != NULL, NULL);
#line 24 "../src/DesktopIntegration.vala"
	_tmp0_ = desktop_integration_get_apps_for_mime_types (mime_types, (gint) mime_types_length1);
#line 24 "../src/DesktopIntegration.vala"
	external_apps = _tmp0_;
#line 113 "DesktopIntegration.c"
	{
		GeeArrayList* _preferred_app_list = NULL;
		GeeArrayList* _tmp1_;
		gint _preferred_app_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _preferred_app_index = 0;
#line 26 "../src/DesktopIntegration.vala"
		_tmp1_ = _g_object_ref0 (preferred_apps);
#line 26 "../src/DesktopIntegration.vala"
		_preferred_app_list = _tmp1_;
#line 26 "../src/DesktopIntegration.vala"
		_tmp2_ = _preferred_app_list;
#line 26 "../src/DesktopIntegration.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 26 "../src/DesktopIntegration.vala"
		_tmp4_ = _tmp3_;
#line 26 "../src/DesktopIntegration.vala"
		_preferred_app_size = _tmp4_;
#line 26 "../src/DesktopIntegration.vala"
		_preferred_app_index = -1;
#line 26 "../src/DesktopIntegration.vala"
		while (TRUE) {
#line 138 "DesktopIntegration.c"
			gchar* preferred_app = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
#line 26 "../src/DesktopIntegration.vala"
			_preferred_app_index = _preferred_app_index + 1;
#line 26 "../src/DesktopIntegration.vala"
			if (!(_preferred_app_index < _preferred_app_size)) {
#line 26 "../src/DesktopIntegration.vala"
				break;
#line 148 "DesktopIntegration.c"
			}
#line 26 "../src/DesktopIntegration.vala"
			_tmp5_ = _preferred_app_list;
#line 26 "../src/DesktopIntegration.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _preferred_app_index);
#line 26 "../src/DesktopIntegration.vala"
			preferred_app = (gchar*) _tmp6_;
#line 156 "DesktopIntegration.c"
			{
				GeeIterator* _external_app_it = NULL;
				SortedList* _tmp7_;
				GeeIterator* _tmp8_;
#line 27 "../src/DesktopIntegration.vala"
				_tmp7_ = external_apps;
#line 27 "../src/DesktopIntegration.vala"
				_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 27 "../src/DesktopIntegration.vala"
				_external_app_it = _tmp8_;
#line 27 "../src/DesktopIntegration.vala"
				while (TRUE) {
#line 169 "DesktopIntegration.c"
					GeeIterator* _tmp9_;
					GAppInfo* external_app = NULL;
					GeeIterator* _tmp10_;
					gpointer _tmp11_;
					GAppInfo* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
#line 27 "../src/DesktopIntegration.vala"
					_tmp9_ = _external_app_it;
#line 27 "../src/DesktopIntegration.vala"
					if (!gee_iterator_next (_tmp9_)) {
#line 27 "../src/DesktopIntegration.vala"
						break;
#line 183 "DesktopIntegration.c"
					}
#line 27 "../src/DesktopIntegration.vala"
					_tmp10_ = _external_app_it;
#line 27 "../src/DesktopIntegration.vala"
					_tmp11_ = gee_iterator_get (_tmp10_);
#line 27 "../src/DesktopIntegration.vala"
					external_app = (GAppInfo*) _tmp11_;
#line 28 "../src/DesktopIntegration.vala"
					_tmp12_ = external_app;
#line 28 "../src/DesktopIntegration.vala"
					_tmp13_ = g_app_info_get_name (_tmp12_);
#line 28 "../src/DesktopIntegration.vala"
					_tmp14_ = preferred_app;
#line 28 "../src/DesktopIntegration.vala"
					if (string_contains (_tmp13_, _tmp14_)) {
#line 29 "../src/DesktopIntegration.vala"
						result = external_app;
#line 29 "../src/DesktopIntegration.vala"
						_g_object_unref0 (_external_app_it);
#line 29 "../src/DesktopIntegration.vala"
						_g_free0 (preferred_app);
#line 29 "../src/DesktopIntegration.vala"
						_g_object_unref0 (_preferred_app_list);
#line 29 "../src/DesktopIntegration.vala"
						_g_object_unref0 (external_apps);
#line 29 "../src/DesktopIntegration.vala"
						return result;
#line 211 "DesktopIntegration.c"
					}
#line 27 "../src/DesktopIntegration.vala"
					_g_object_unref0 (external_app);
#line 215 "DesktopIntegration.c"
				}
#line 27 "../src/DesktopIntegration.vala"
				_g_object_unref0 (_external_app_it);
#line 219 "DesktopIntegration.c"
			}
#line 26 "../src/DesktopIntegration.vala"
			_g_free0 (preferred_app);
#line 223 "DesktopIntegration.c"
		}
#line 26 "../src/DesktopIntegration.vala"
		_g_object_unref0 (_preferred_app_list);
#line 227 "DesktopIntegration.c"
	}
#line 33 "../src/DesktopIntegration.vala"
	result = NULL;
#line 33 "../src/DesktopIntegration.vala"
	_g_object_unref0 (external_apps);
#line 33 "../src/DesktopIntegration.vala"
	return result;
#line 235 "DesktopIntegration.c"
}

gint64
desktop_integration_app_info_comparator (void* a,
                                         void* b)
{
	gint64 result = 0LL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint64 _tmp6_;
#line 38 "../src/DesktopIntegration.vala"
	_tmp0_ = g_app_info_get_name (G_TYPE_CHECK_INSTANCE_CAST (a, g_app_info_get_type (), GAppInfo));
#line 38 "../src/DesktopIntegration.vala"
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) -1);
#line 38 "../src/DesktopIntegration.vala"
	_tmp2_ = _tmp1_;
#line 38 "../src/DesktopIntegration.vala"
	_tmp3_ = g_app_info_get_name (G_TYPE_CHECK_INSTANCE_CAST (b, g_app_info_get_type (), GAppInfo));
#line 38 "../src/DesktopIntegration.vala"
	_tmp4_ = g_utf8_strdown (_tmp3_, (gssize) -1);
#line 38 "../src/DesktopIntegration.vala"
	_tmp5_ = _tmp4_;
#line 38 "../src/DesktopIntegration.vala"
	_tmp6_ = (gint64) g_utf8_collate (_tmp2_, _tmp5_);
#line 38 "../src/DesktopIntegration.vala"
	_g_free0 (_tmp5_);
#line 38 "../src/DesktopIntegration.vala"
	_g_free0 (_tmp2_);
#line 38 "../src/DesktopIntegration.vala"
	result = _tmp6_;
#line 38 "../src/DesktopIntegration.vala"
	return result;
#line 272 "DesktopIntegration.c"
}

static gint64
_desktop_integration_app_info_comparator_comparator (void* a,
                                                     void* b,
                                                     gpointer self)
{
	gint64 result;
	result = desktop_integration_app_info_comparator (a, b);
#line 42 "../src/DesktopIntegration.vala"
	return result;
#line 284 "DesktopIntegration.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 54 "../src/DesktopIntegration.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 292 "DesktopIntegration.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 54 "../src/DesktopIntegration.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 300 "DesktopIntegration.c"
}

SortedList*
desktop_integration_get_apps_for_mime_types (gchar** mime_types,
                                             gint mime_types_length1)
{
	SortedList* result = NULL;
	SortedList* external_apps = NULL;
	SortedList* _tmp0_;
#line 42 "../src/DesktopIntegration.vala"
	_tmp0_ = sorted_list_new (g_app_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _desktop_integration_app_info_comparator_comparator, NULL);
#line 42 "../src/DesktopIntegration.vala"
	external_apps = _tmp0_;
#line 44 "../src/DesktopIntegration.vala"
	if (mime_types_length1 == 0) {
#line 45 "../src/DesktopIntegration.vala"
		result = external_apps;
#line 45 "../src/DesktopIntegration.vala"
		return result;
#line 320 "DesktopIntegration.c"
	}
	{
		gchar** mime_type_collection = NULL;
		gint mime_type_collection_length1 = 0;
		gint _mime_type_collection_size_ = 0;
		gint mime_type_it = 0;
#line 49 "../src/DesktopIntegration.vala"
		mime_type_collection = mime_types;
#line 49 "../src/DesktopIntegration.vala"
		mime_type_collection_length1 = mime_types_length1;
#line 49 "../src/DesktopIntegration.vala"
		for (mime_type_it = 0; mime_type_it < mime_types_length1; mime_type_it = mime_type_it + 1) {
#line 333 "DesktopIntegration.c"
			gchar* _tmp1_;
			gchar* mime_type = NULL;
#line 49 "../src/DesktopIntegration.vala"
			_tmp1_ = g_strdup (mime_type_collection[mime_type_it]);
#line 49 "../src/DesktopIntegration.vala"
			mime_type = _tmp1_;
#line 340 "DesktopIntegration.c"
			{
				gchar* content_type = NULL;
				const gchar* _tmp2_;
				gchar* _tmp3_;
				const gchar* _tmp4_;
				const gchar* _tmp5_;
				GList* _tmp6_;
#line 50 "../src/DesktopIntegration.vala"
				_tmp2_ = mime_type;
#line 50 "../src/DesktopIntegration.vala"
				_tmp3_ = g_content_type_from_mime_type (_tmp2_);
#line 50 "../src/DesktopIntegration.vala"
				content_type = _tmp3_;
#line 51 "../src/DesktopIntegration.vala"
				_tmp4_ = content_type;
#line 51 "../src/DesktopIntegration.vala"
				if (_tmp4_ == NULL) {
#line 52 "../src/DesktopIntegration.vala"
					_g_free0 (content_type);
#line 52 "../src/DesktopIntegration.vala"
					_g_free0 (mime_type);
#line 52 "../src/DesktopIntegration.vala"
					break;
#line 364 "DesktopIntegration.c"
				}
#line 54 "../src/DesktopIntegration.vala"
				_tmp5_ = content_type;
#line 54 "../src/DesktopIntegration.vala"
				_tmp6_ = g_app_info_get_all_for_type (_tmp5_);
#line 370 "DesktopIntegration.c"
				{
					GList* external_app_collection = NULL;
					GList* external_app_it = NULL;
#line 54 "../src/DesktopIntegration.vala"
					external_app_collection = _tmp6_;
#line 54 "../src/DesktopIntegration.vala"
					for (external_app_it = external_app_collection; external_app_it != NULL; external_app_it = external_app_it->next) {
#line 378 "DesktopIntegration.c"
						GAppInfo* _tmp7_;
						GAppInfo* external_app = NULL;
#line 54 "../src/DesktopIntegration.vala"
						_tmp7_ = _g_object_ref0 ((GAppInfo*) external_app_it->data);
#line 54 "../src/DesktopIntegration.vala"
						external_app = _tmp7_;
#line 385 "DesktopIntegration.c"
						{
							gboolean already_contains = FALSE;
							gboolean _tmp17_ = FALSE;
#line 56 "../src/DesktopIntegration.vala"
							already_contains = FALSE;
#line 391 "DesktopIntegration.c"
							{
								GeeIterator* _app_it = NULL;
								SortedList* _tmp8_;
								GeeIterator* _tmp9_;
#line 58 "../src/DesktopIntegration.vala"
								_tmp8_ = external_apps;
#line 58 "../src/DesktopIntegration.vala"
								_tmp9_ = gee_iterable_iterator ((GeeIterable*) _tmp8_);
#line 58 "../src/DesktopIntegration.vala"
								_app_it = _tmp9_;
#line 58 "../src/DesktopIntegration.vala"
								while (TRUE) {
#line 404 "DesktopIntegration.c"
									GeeIterator* _tmp10_;
									GAppInfo* app = NULL;
									GeeIterator* _tmp11_;
									gpointer _tmp12_;
									GAppInfo* _tmp13_;
									const gchar* _tmp14_;
									GAppInfo* _tmp15_;
									const gchar* _tmp16_;
#line 58 "../src/DesktopIntegration.vala"
									_tmp10_ = _app_it;
#line 58 "../src/DesktopIntegration.vala"
									if (!gee_iterator_next (_tmp10_)) {
#line 58 "../src/DesktopIntegration.vala"
										break;
#line 419 "DesktopIntegration.c"
									}
#line 58 "../src/DesktopIntegration.vala"
									_tmp11_ = _app_it;
#line 58 "../src/DesktopIntegration.vala"
									_tmp12_ = gee_iterator_get (_tmp11_);
#line 58 "../src/DesktopIntegration.vala"
									app = (GAppInfo*) _tmp12_;
#line 59 "../src/DesktopIntegration.vala"
									_tmp13_ = app;
#line 59 "../src/DesktopIntegration.vala"
									_tmp14_ = g_app_info_get_name (_tmp13_);
#line 59 "../src/DesktopIntegration.vala"
									_tmp15_ = external_app;
#line 59 "../src/DesktopIntegration.vala"
									_tmp16_ = g_app_info_get_name (_tmp15_);
#line 59 "../src/DesktopIntegration.vala"
									if (g_strcmp0 (_tmp14_, _tmp16_) == 0) {
#line 60 "../src/DesktopIntegration.vala"
										already_contains = TRUE;
#line 61 "../src/DesktopIntegration.vala"
										_g_object_unref0 (app);
#line 61 "../src/DesktopIntegration.vala"
										break;
#line 443 "DesktopIntegration.c"
									}
#line 58 "../src/DesktopIntegration.vala"
									_g_object_unref0 (app);
#line 447 "DesktopIntegration.c"
								}
#line 58 "../src/DesktopIntegration.vala"
								_g_object_unref0 (_app_it);
#line 451 "DesktopIntegration.c"
							}
#line 66 "../src/DesktopIntegration.vala"
							if (!already_contains) {
#line 455 "DesktopIntegration.c"
								GAppInfo* _tmp18_;
								const gchar* _tmp19_;
#line 66 "../src/DesktopIntegration.vala"
								_tmp18_ = external_app;
#line 66 "../src/DesktopIntegration.vala"
								_tmp19_ = g_app_info_get_name (_tmp18_);
#line 66 "../src/DesktopIntegration.vala"
								_tmp17_ = !string_contains (_tmp19_, _ (RESOURCES_APP_DIRECT_ROLE));
#line 464 "DesktopIntegration.c"
							} else {
#line 66 "../src/DesktopIntegration.vala"
								_tmp17_ = FALSE;
#line 468 "DesktopIntegration.c"
							}
#line 66 "../src/DesktopIntegration.vala"
							if (_tmp17_) {
#line 472 "DesktopIntegration.c"
								SortedList* _tmp20_;
								GAppInfo* _tmp21_;
#line 67 "../src/DesktopIntegration.vala"
								_tmp20_ = external_apps;
#line 67 "../src/DesktopIntegration.vala"
								_tmp21_ = external_app;
#line 67 "../src/DesktopIntegration.vala"
								gee_collection_add ((GeeCollection*) _tmp20_, _tmp21_);
#line 481 "DesktopIntegration.c"
							}
#line 54 "../src/DesktopIntegration.vala"
							_g_object_unref0 (external_app);
#line 485 "DesktopIntegration.c"
						}
					}
#line 54 "../src/DesktopIntegration.vala"
					(external_app_collection == NULL) ? NULL : (external_app_collection = (_g_list_free__g_object_unref0_ (external_app_collection), NULL));
#line 490 "DesktopIntegration.c"
				}
#line 49 "../src/DesktopIntegration.vala"
				_g_free0 (content_type);
#line 49 "../src/DesktopIntegration.vala"
				_g_free0 (mime_type);
#line 496 "DesktopIntegration.c"
			}
		}
	}
#line 71 "../src/DesktopIntegration.vala"
	result = external_apps;
#line 71 "../src/DesktopIntegration.vala"
	return result;
#line 504 "DesktopIntegration.c"
}

gchar*
desktop_integration_get_app_open_command (GAppInfo* app_info)
{
	gchar* result = NULL;
	gchar* str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	gchar* _tmp6_;
#line 74 "../src/DesktopIntegration.vala"
	g_return_val_if_fail (app_info != NULL, NULL);
#line 75 "../src/DesktopIntegration.vala"
	_tmp0_ = g_app_info_get_commandline (app_info);
#line 75 "../src/DesktopIntegration.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 75 "../src/DesktopIntegration.vala"
	str = _tmp1_;
#line 77 "../src/DesktopIntegration.vala"
	_tmp3_ = str;
#line 77 "../src/DesktopIntegration.vala"
	if (_tmp3_ != NULL) {
#line 529 "DesktopIntegration.c"
		const gchar* _tmp4_;
#line 77 "../src/DesktopIntegration.vala"
		_tmp4_ = str;
#line 77 "../src/DesktopIntegration.vala"
		_tmp2_ = _tmp4_;
#line 535 "DesktopIntegration.c"
	} else {
		const gchar* _tmp5_;
#line 77 "../src/DesktopIntegration.vala"
		_tmp5_ = g_app_info_get_executable (app_info);
#line 77 "../src/DesktopIntegration.vala"
		_tmp2_ = _tmp5_;
#line 542 "DesktopIntegration.c"
	}
#line 77 "../src/DesktopIntegration.vala"
	_tmp6_ = g_strdup (_tmp2_);
#line 77 "../src/DesktopIntegration.vala"
	result = _tmp6_;
#line 77 "../src/DesktopIntegration.vala"
	_g_free0 (str);
#line 77 "../src/DesktopIntegration.vala"
	return result;
#line 552 "DesktopIntegration.c"
}

