/* PageWindow.c generated by valac 0.44.0, the Vala compiler
 * generated from PageWindow.vala, do not modify */

/*
* Copyright (c) 2018 elementary, Inc. (https://elementary.io),
                2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* PageWindow is a Gtk.Window with essential functions for hosting a Page.  There may be more than*/
/* one PageWindow in the system, and closing one does not imply exiting the application.*/
/**/
/* PageWindow offers support for hosting a single Page; multiple Pages must be handled by the*/
/* subclass.  A subclass should set current_page to the user-visible Page for it to receive*/
/* various notifications.  It is the responsibility of the subclass to notify Pages when they're*/
/* switched to and from, and other aspects of the Page interface.*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>

#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;
typedef struct _PageWindowPrivate PageWindowPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;
enum  {
	PAGE_WINDOW_0_PROPERTY,
	PAGE_WINDOW_NUM_PROPERTIES
};
static GParamSpec* page_window_properties[PAGE_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _PageWindow {
	GtkApplicationWindow parent_instance;
	PageWindowPrivate * priv;
	GtkUIManager* ui;
};

struct _PageWindowClass {
	GtkApplicationWindowClass parent_class;
	void (*switched_pages) (PageWindow* self, Page* old_page, Page* new_page);
	void (*set_current_page) (PageWindow* self, Page* page);
	void (*clear_current_page) (PageWindow* self);
};

struct _PageWindowPrivate {
	Page* current_page;
	gint busy_counter;
};

static gint PageWindow_private_offset;
static gpointer page_window_parent_class = NULL;

GType page_window_get_type (void) G_GNUC_CONST;
GType page_get_type (void) G_GNUC_CONST;
void page_window_switched_pages (PageWindow* self,
                                 Page* old_page,
                                 Page* new_page);
static void page_window_real_switched_pages (PageWindow* self,
                                      Page* old_page,
                                      Page* new_page);
Page* page_window_get_current_page (PageWindow* self);
void page_window_set_current_page (PageWindow* self,
                                   Page* page);
static void page_window_real_set_current_page (PageWindow* self,
                                        Page* page);
void page_clear_container (Page* self);
void page_set_container (Page* self,
                         GtkWindow* container);
void page_window_clear_current_page (PageWindow* self);
static void page_window_real_clear_current_page (PageWindow* self);
static gboolean page_window_real_key_press_event (GtkWidget* base,
                                           GdkEventKey* event);
gboolean page_notify_app_key_pressed (Page* self,
                                      GdkEventKey* event);
static gboolean page_window_real_key_release_event (GtkWidget* base,
                                             GdkEventKey* event);
gboolean page_notify_app_key_released (Page* self,
                                       GdkEventKey* event);
static gboolean page_window_real_focus_in_event (GtkWidget* base,
                                          GdkEventFocus* event);
gboolean page_notify_app_focus_in (Page* self,
                                   GdkEventFocus* event);
static gboolean page_window_real_focus_out_event (GtkWidget* base,
                                           GdkEventFocus* event);
gboolean page_notify_app_focus_out (Page* self,
                                    GdkEventFocus* event);
static gboolean page_window_real_configure_event (GtkWidget* base,
                                           GdkEventConfigure* event);
gboolean page_notify_configure_event (Page* self,
                                      GdkEventConfigure* event);
void page_window_set_busy_cursor (PageWindow* self);
void spin_event_loop (void);
void page_window_set_normal_cursor (PageWindow* self);
PageWindow* page_window_construct (GType object_type);
static GObject * page_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void page_window_finalize (GObject * obj);

static inline gpointer
page_window_get_instance_private (PageWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PageWindow_private_offset);
}

static void
page_window_real_switched_pages (PageWindow* self,
                                 Page* old_page,
                                 Page* new_page)
{
}

void
page_window_switched_pages (PageWindow* self,
                            Page* old_page,
                            Page* new_page)
{
#line 34 "../src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/PageWindow.vala"
	PAGE_WINDOW_GET_CLASS (self)->switched_pages (self, old_page, new_page);
#line 154 "PageWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 49 "../src/PageWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 162 "PageWindow.c"
}

Page*
page_window_get_current_page (PageWindow* self)
{
	Page* result = NULL;
	Page* _tmp0_;
	Page* _tmp1_;
#line 48 "../src/PageWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 49 "../src/PageWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 49 "../src/PageWindow.vala"
	result = _tmp1_;
#line 49 "../src/PageWindow.vala"
	return result;
#line 181 "PageWindow.c"
}

static void
page_window_real_set_current_page (PageWindow* self,
                                   Page* page)
{
	Page* _tmp0_;
	Page* old_page = NULL;
	Page* _tmp2_;
	Page* _tmp3_;
	Page* _tmp4_;
	Page* _tmp5_;
#line 52 "../src/PageWindow.vala"
	g_return_if_fail (page != NULL);
#line 53 "../src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 53 "../src/PageWindow.vala"
	if (_tmp0_ != NULL) {
#line 200 "PageWindow.c"
		Page* _tmp1_;
#line 54 "../src/PageWindow.vala"
		_tmp1_ = self->priv->current_page;
#line 54 "../src/PageWindow.vala"
		page_clear_container (_tmp1_);
#line 206 "PageWindow.c"
	}
#line 56 "../src/PageWindow.vala"
	_tmp2_ = self->priv->current_page;
#line 56 "../src/PageWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 56 "../src/PageWindow.vala"
	old_page = _tmp3_;
#line 57 "../src/PageWindow.vala"
	_tmp4_ = _g_object_ref0 (page);
#line 57 "../src/PageWindow.vala"
	_g_object_unref0 (self->priv->current_page);
#line 57 "../src/PageWindow.vala"
	self->priv->current_page = _tmp4_;
#line 58 "../src/PageWindow.vala"
	_tmp5_ = self->priv->current_page;
#line 58 "../src/PageWindow.vala"
	page_set_container (_tmp5_, (GtkWindow*) self);
#line 60 "../src/PageWindow.vala"
	page_window_switched_pages (self, old_page, page);
#line 52 "../src/PageWindow.vala"
	_g_object_unref0 (old_page);
#line 228 "PageWindow.c"
}

void
page_window_set_current_page (PageWindow* self,
                              Page* page)
{
#line 52 "../src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/PageWindow.vala"
	PAGE_WINDOW_GET_CLASS (self)->set_current_page (self, page);
#line 239 "PageWindow.c"
}

static void
page_window_real_clear_current_page (PageWindow* self)
{
	Page* _tmp0_;
	Page* old_page = NULL;
	Page* _tmp2_;
	Page* _tmp3_;
#line 64 "../src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 64 "../src/PageWindow.vala"
	if (_tmp0_ != NULL) {
#line 253 "PageWindow.c"
		Page* _tmp1_;
#line 65 "../src/PageWindow.vala"
		_tmp1_ = self->priv->current_page;
#line 65 "../src/PageWindow.vala"
		page_clear_container (_tmp1_);
#line 259 "PageWindow.c"
	}
#line 67 "../src/PageWindow.vala"
	_tmp2_ = self->priv->current_page;
#line 67 "../src/PageWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 67 "../src/PageWindow.vala"
	old_page = _tmp3_;
#line 68 "../src/PageWindow.vala"
	_g_object_unref0 (self->priv->current_page);
#line 68 "../src/PageWindow.vala"
	self->priv->current_page = NULL;
#line 70 "../src/PageWindow.vala"
	page_window_switched_pages (self, old_page, NULL);
#line 63 "../src/PageWindow.vala"
	_g_object_unref0 (old_page);
#line 275 "PageWindow.c"
}

void
page_window_clear_current_page (PageWindow* self)
{
#line 63 "../src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/PageWindow.vala"
	PAGE_WINDOW_GET_CLASS (self)->clear_current_page (self);
#line 285 "PageWindow.c"
}

static gboolean
page_window_real_key_press_event (GtkWidget* base,
                                  GdkEventKey* event)
{
	PageWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkWidget* _tmp1_;
	gboolean _tmp4_ = FALSE;
	Page* _tmp5_;
	gboolean _tmp7_ = FALSE;
#line 73 "../src/PageWindow.vala"
	self = (PageWindow*) base;
#line 73 "../src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 74 "../src/PageWindow.vala"
	_tmp1_ = gtk_window_get_focus ((GtkWindow*) self);
#line 74 "../src/PageWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_entry_get_type ())) {
#line 307 "PageWindow.c"
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 74 "../src/PageWindow.vala"
		_tmp2_ = gtk_window_get_focus ((GtkWindow*) self);
#line 74 "../src/PageWindow.vala"
		g_signal_emit_by_name (_tmp2_, "key-press-event", event, &_tmp3_);
#line 74 "../src/PageWindow.vala"
		_tmp0_ = _tmp3_;
#line 316 "PageWindow.c"
	} else {
#line 74 "../src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 320 "PageWindow.c"
	}
#line 74 "../src/PageWindow.vala"
	if (_tmp0_) {
#line 75 "../src/PageWindow.vala"
		result = TRUE;
#line 75 "../src/PageWindow.vala"
		return result;
#line 328 "PageWindow.c"
	}
#line 77 "../src/PageWindow.vala"
	_tmp5_ = self->priv->current_page;
#line 77 "../src/PageWindow.vala"
	if (_tmp5_ != NULL) {
#line 334 "PageWindow.c"
		Page* _tmp6_;
#line 77 "../src/PageWindow.vala"
		_tmp6_ = self->priv->current_page;
#line 77 "../src/PageWindow.vala"
		_tmp4_ = page_notify_app_key_pressed (_tmp6_, event);
#line 340 "PageWindow.c"
	} else {
#line 77 "../src/PageWindow.vala"
		_tmp4_ = FALSE;
#line 344 "PageWindow.c"
	}
#line 77 "../src/PageWindow.vala"
	if (_tmp4_) {
#line 78 "../src/PageWindow.vala"
		result = TRUE;
#line 78 "../src/PageWindow.vala"
		return result;
#line 352 "PageWindow.c"
	}
#line 80 "../src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->key_press_event != NULL) {
#line 80 "../src/PageWindow.vala"
		_tmp7_ = GTK_WIDGET_CLASS (page_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), event);
#line 358 "PageWindow.c"
	} else {
#line 80 "../src/PageWindow.vala"
		_tmp7_ = FALSE;
#line 362 "PageWindow.c"
	}
#line 80 "../src/PageWindow.vala"
	result = _tmp7_;
#line 80 "../src/PageWindow.vala"
	return result;
#line 368 "PageWindow.c"
}

static gboolean
page_window_real_key_release_event (GtkWidget* base,
                                    GdkEventKey* event)
{
	PageWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkWidget* _tmp1_;
	gboolean _tmp4_ = FALSE;
	Page* _tmp5_;
	gboolean _tmp7_ = FALSE;
#line 83 "../src/PageWindow.vala"
	self = (PageWindow*) base;
#line 83 "../src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 84 "../src/PageWindow.vala"
	_tmp1_ = gtk_window_get_focus ((GtkWindow*) self);
#line 84 "../src/PageWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_entry_get_type ())) {
#line 390 "PageWindow.c"
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 84 "../src/PageWindow.vala"
		_tmp2_ = gtk_window_get_focus ((GtkWindow*) self);
#line 84 "../src/PageWindow.vala"
		g_signal_emit_by_name (_tmp2_, "key-release-event", event, &_tmp3_);
#line 84 "../src/PageWindow.vala"
		_tmp0_ = _tmp3_;
#line 399 "PageWindow.c"
	} else {
#line 84 "../src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 403 "PageWindow.c"
	}
#line 84 "../src/PageWindow.vala"
	if (_tmp0_) {
#line 85 "../src/PageWindow.vala"
		result = TRUE;
#line 85 "../src/PageWindow.vala"
		return result;
#line 411 "PageWindow.c"
	}
#line 87 "../src/PageWindow.vala"
	_tmp5_ = self->priv->current_page;
#line 87 "../src/PageWindow.vala"
	if (_tmp5_ != NULL) {
#line 417 "PageWindow.c"
		Page* _tmp6_;
#line 87 "../src/PageWindow.vala"
		_tmp6_ = self->priv->current_page;
#line 87 "../src/PageWindow.vala"
		_tmp4_ = page_notify_app_key_released (_tmp6_, event);
#line 423 "PageWindow.c"
	} else {
#line 87 "../src/PageWindow.vala"
		_tmp4_ = FALSE;
#line 427 "PageWindow.c"
	}
#line 87 "../src/PageWindow.vala"
	if (_tmp4_) {
#line 88 "../src/PageWindow.vala"
		result = TRUE;
#line 88 "../src/PageWindow.vala"
		return result;
#line 435 "PageWindow.c"
	}
#line 90 "../src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->key_release_event != NULL) {
#line 90 "../src/PageWindow.vala"
		_tmp7_ = GTK_WIDGET_CLASS (page_window_parent_class)->key_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), event);
#line 441 "PageWindow.c"
	} else {
#line 90 "../src/PageWindow.vala"
		_tmp7_ = FALSE;
#line 445 "PageWindow.c"
	}
#line 90 "../src/PageWindow.vala"
	result = _tmp7_;
#line 90 "../src/PageWindow.vala"
	return result;
#line 451 "PageWindow.c"
}

static gboolean
page_window_real_focus_in_event (GtkWidget* base,
                                 GdkEventFocus* event)
{
	PageWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp3_ = FALSE;
#line 93 "../src/PageWindow.vala"
	self = (PageWindow*) base;
#line 93 "../src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 94 "../src/PageWindow.vala"
	_tmp1_ = self->priv->current_page;
#line 94 "../src/PageWindow.vala"
	if (_tmp1_ != NULL) {
#line 471 "PageWindow.c"
		Page* _tmp2_;
#line 94 "../src/PageWindow.vala"
		_tmp2_ = self->priv->current_page;
#line 94 "../src/PageWindow.vala"
		_tmp0_ = page_notify_app_focus_in (_tmp2_, event);
#line 477 "PageWindow.c"
	} else {
#line 94 "../src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 481 "PageWindow.c"
	}
#line 94 "../src/PageWindow.vala"
	if (_tmp0_) {
#line 95 "../src/PageWindow.vala"
		result = TRUE;
#line 95 "../src/PageWindow.vala"
		return result;
#line 489 "PageWindow.c"
	}
#line 97 "../src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->focus_in_event != NULL) {
#line 97 "../src/PageWindow.vala"
		_tmp3_ = GTK_WIDGET_CLASS (page_window_parent_class)->focus_in_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), event);
#line 495 "PageWindow.c"
	} else {
#line 97 "../src/PageWindow.vala"
		_tmp3_ = FALSE;
#line 499 "PageWindow.c"
	}
#line 97 "../src/PageWindow.vala"
	result = _tmp3_;
#line 97 "../src/PageWindow.vala"
	return result;
#line 505 "PageWindow.c"
}

static gboolean
page_window_real_focus_out_event (GtkWidget* base,
                                  GdkEventFocus* event)
{
	PageWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp3_ = FALSE;
#line 100 "../src/PageWindow.vala"
	self = (PageWindow*) base;
#line 100 "../src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 101 "../src/PageWindow.vala"
	_tmp1_ = self->priv->current_page;
#line 101 "../src/PageWindow.vala"
	if (_tmp1_ != NULL) {
#line 525 "PageWindow.c"
		Page* _tmp2_;
#line 101 "../src/PageWindow.vala"
		_tmp2_ = self->priv->current_page;
#line 101 "../src/PageWindow.vala"
		_tmp0_ = page_notify_app_focus_out (_tmp2_, event);
#line 531 "PageWindow.c"
	} else {
#line 101 "../src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 535 "PageWindow.c"
	}
#line 101 "../src/PageWindow.vala"
	if (_tmp0_) {
#line 102 "../src/PageWindow.vala"
		result = TRUE;
#line 102 "../src/PageWindow.vala"
		return result;
#line 543 "PageWindow.c"
	}
#line 104 "../src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->focus_out_event != NULL) {
#line 104 "../src/PageWindow.vala"
		_tmp3_ = GTK_WIDGET_CLASS (page_window_parent_class)->focus_out_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), event);
#line 549 "PageWindow.c"
	} else {
#line 104 "../src/PageWindow.vala"
		_tmp3_ = FALSE;
#line 553 "PageWindow.c"
	}
#line 104 "../src/PageWindow.vala"
	result = _tmp3_;
#line 104 "../src/PageWindow.vala"
	return result;
#line 559 "PageWindow.c"
}

static gboolean
page_window_real_configure_event (GtkWidget* base,
                                  GdkEventConfigure* event)
{
	PageWindow * self;
	gboolean result = FALSE;
	Page* _tmp0_;
	gboolean _tmp2_ = FALSE;
#line 107 "../src/PageWindow.vala"
	self = (PageWindow*) base;
#line 107 "../src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 108 "../src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 108 "../src/PageWindow.vala"
	if (_tmp0_ != NULL) {
#line 578 "PageWindow.c"
		Page* _tmp1_;
#line 109 "../src/PageWindow.vala"
		_tmp1_ = self->priv->current_page;
#line 109 "../src/PageWindow.vala"
		if (page_notify_configure_event (_tmp1_, event)) {
#line 110 "../src/PageWindow.vala"
			result = TRUE;
#line 110 "../src/PageWindow.vala"
			return result;
#line 588 "PageWindow.c"
		}
	}
#line 113 "../src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->configure_event != NULL) {
#line 113 "../src/PageWindow.vala"
		_tmp2_ = GTK_WIDGET_CLASS (page_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), event);
#line 595 "PageWindow.c"
	} else {
#line 113 "../src/PageWindow.vala"
		_tmp2_ = FALSE;
#line 599 "PageWindow.c"
	}
#line 113 "../src/PageWindow.vala"
	result = _tmp2_;
#line 113 "../src/PageWindow.vala"
	return result;
#line 605 "PageWindow.c"
}

void
page_window_set_busy_cursor (PageWindow* self)
{
	gint _tmp0_;
	GdkWindow* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkCursor* _tmp4_;
#line 116 "../src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/PageWindow.vala"
	_tmp0_ = self->priv->busy_counter;
#line 117 "../src/PageWindow.vala"
	self->priv->busy_counter = _tmp0_ + 1;
#line 117 "../src/PageWindow.vala"
	if (_tmp0_ > 0) {
#line 118 "../src/PageWindow.vala"
		return;
#line 626 "PageWindow.c"
	}
#line 120 "../src/PageWindow.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
#line 120 "../src/PageWindow.vala"
	_tmp2_ = gdk_display_get_default ();
#line 120 "../src/PageWindow.vala"
	_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_WATCH);
#line 120 "../src/PageWindow.vala"
	_tmp4_ = _tmp3_;
#line 120 "../src/PageWindow.vala"
	gdk_window_set_cursor (_tmp1_, _tmp4_);
#line 120 "../src/PageWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 121 "../src/PageWindow.vala"
	spin_event_loop ();
#line 642 "PageWindow.c"
}

void
page_window_set_normal_cursor (PageWindow* self)
{
	GdkWindow* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkCursor* _tmp2_;
	GdkCursor* _tmp3_;
#line 124 "../src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/PageWindow.vala"
	if (self->priv->busy_counter <= 0) {
#line 126 "../src/PageWindow.vala"
		self->priv->busy_counter = 0;
#line 127 "../src/PageWindow.vala"
		return;
#line 660 "PageWindow.c"
	} else {
#line 128 "../src/PageWindow.vala"
		self->priv->busy_counter = self->priv->busy_counter - 1;
#line 128 "../src/PageWindow.vala"
		if (self->priv->busy_counter > 0) {
#line 129 "../src/PageWindow.vala"
			return;
#line 668 "PageWindow.c"
		}
	}
#line 132 "../src/PageWindow.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 132 "../src/PageWindow.vala"
	_tmp1_ = gdk_display_get_default ();
#line 132 "../src/PageWindow.vala"
	_tmp2_ = gdk_cursor_new_for_display (_tmp1_, GDK_LEFT_PTR);
#line 132 "../src/PageWindow.vala"
	_tmp3_ = _tmp2_;
#line 132 "../src/PageWindow.vala"
	gdk_window_set_cursor (_tmp0_, _tmp3_);
#line 132 "../src/PageWindow.vala"
	_g_object_unref0 (_tmp3_);
#line 133 "../src/PageWindow.vala"
	spin_event_loop ();
#line 685 "PageWindow.c"
}

PageWindow*
page_window_construct (GType object_type)
{
	PageWindow * self = NULL;
#line 28 "../src/PageWindow.vala"
	self = (PageWindow*) g_object_new (object_type, NULL);
#line 28 "../src/PageWindow.vala"
	return self;
#line 696 "PageWindow.c"
}

static GObject *
page_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PageWindow * self;
	GtkUIManager* _tmp0_;
#line 37 "../src/PageWindow.vala"
	parent_class = G_OBJECT_CLASS (page_window_parent_class);
#line 37 "../src/PageWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/PageWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_WINDOW, PageWindow);
#line 39 "../src/PageWindow.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) ((GDK_KEY_PRESS_MASK | GDK_KEY_RELEASE_MASK) | GDK_STRUCTURE_MASK));
#line 45 "../src/PageWindow.vala"
	_tmp0_ = gtk_ui_manager_new ();
#line 45 "../src/PageWindow.vala"
	_g_object_unref0 (self->ui);
#line 45 "../src/PageWindow.vala"
	self->ui = _tmp0_;
#line 37 "../src/PageWindow.vala"
	return obj;
#line 724 "PageWindow.c"
}

static void
page_window_class_init (PageWindowClass * klass,
                        gpointer klass_data)
{
#line 28 "../src/PageWindow.vala"
	page_window_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/PageWindow.vala"
	g_type_class_adjust_private_offset (klass, &PageWindow_private_offset);
#line 28 "../src/PageWindow.vala"
	((PageWindowClass *) klass)->switched_pages = (void (*) (PageWindow*, Page*, Page*)) page_window_real_switched_pages;
#line 28 "../src/PageWindow.vala"
	((PageWindowClass *) klass)->set_current_page = (void (*) (PageWindow*, Page*)) page_window_real_set_current_page;
#line 28 "../src/PageWindow.vala"
	((PageWindowClass *) klass)->clear_current_page = (void (*) (PageWindow*)) page_window_real_clear_current_page;
#line 28 "../src/PageWindow.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) page_window_real_key_press_event;
#line 28 "../src/PageWindow.vala"
	((GtkWidgetClass *) klass)->key_release_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) page_window_real_key_release_event;
#line 28 "../src/PageWindow.vala"
	((GtkWidgetClass *) klass)->focus_in_event = (gboolean (*) (GtkWidget*, GdkEventFocus*)) page_window_real_focus_in_event;
#line 28 "../src/PageWindow.vala"
	((GtkWidgetClass *) klass)->focus_out_event = (gboolean (*) (GtkWidget*, GdkEventFocus*)) page_window_real_focus_out_event;
#line 28 "../src/PageWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) page_window_real_configure_event;
#line 28 "../src/PageWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = page_window_constructor;
#line 28 "../src/PageWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = page_window_finalize;
#line 755 "PageWindow.c"
}

static void
page_window_instance_init (PageWindow * self,
                           gpointer klass)
{
#line 28 "../src/PageWindow.vala"
	self->priv = page_window_get_instance_private (self);
#line 31 "../src/PageWindow.vala"
	self->priv->current_page = NULL;
#line 32 "../src/PageWindow.vala"
	self->priv->busy_counter = 0;
#line 768 "PageWindow.c"
}

static void
page_window_finalize (GObject * obj)
{
	PageWindow * self;
#line 28 "../src/PageWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_WINDOW, PageWindow);
#line 29 "../src/PageWindow.vala"
	_g_object_unref0 (self->ui);
#line 31 "../src/PageWindow.vala"
	_g_object_unref0 (self->priv->current_page);
#line 28 "../src/PageWindow.vala"
	G_OBJECT_CLASS (page_window_parent_class)->finalize (obj);
#line 783 "PageWindow.c"
}

GType
page_window_get_type (void)
{
	static volatile gsize page_window_type_id__volatile = 0;
	if (g_once_init_enter (&page_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PageWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageWindow), 0, (GInstanceInitFunc) page_window_instance_init, NULL };
		GType page_window_type_id;
		page_window_type_id = g_type_register_static (gtk_application_window_get_type (), "PageWindow", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		PageWindow_private_offset = g_type_add_instance_private (page_window_type_id, sizeof (PageWindowPrivate));
		g_once_init_leave (&page_window_type_id__volatile, page_window_type_id);
	}
	return page_window_type_id__volatile;
}

