/* DatabaseTable.c generated by valac 0.44.0, the Vala compiler
 * generated from DatabaseTable.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sqlite3.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _sqlite3_close0(var) ((var == NULL) ? NULL : (var = (sqlite3_close (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
typedef struct _ParamSpecDatabaseTable ParamSpecDatabaseTable;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _ParamSpecDatabaseTable {
	GParamSpec parent_instance;
};

static gpointer database_table_parent_class = NULL;
extern sqlite3* database_table_db;
sqlite3* database_table_db = NULL;
static gint database_table_in_transaction;
static gint database_table_in_transaction = 0;

GQuark database_error_quark (void);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
#define DATABASE_TABLE_SCHEMA_VERSION 21
static void database_table_prepare_db (const gchar* filename);
void app_window_panic (const gchar* msg);
#define DB_IN_MEMORY_NAME ":memory:"
void database_table_init (const gchar* filename);
void database_table_warning (const gchar* op,
                             gint res);
void database_table_terminate (void);
void database_table_fatal (const gchar* op,
                           gint res);
void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
void database_table_throw_error (const gchar* method,
                                 gint res,
                                 GError** error);
sqlite3_stmt* database_table_create_stmt (DatabaseTable* self,
                                          const gchar* data);
static void database_table_assert_test (gboolean condition,
                                 const gchar* data);
void database_table_bind_null (sqlite3_stmt* stmt,
                               gint column);
void database_table_bind_text (sqlite3_stmt* stmt,
                               gint column,
                               const gchar* data);
void database_table_bind_int (sqlite3_stmt* stmt,
                              gint column,
                              gint data);
void database_table_bind_int64 (sqlite3_stmt* stmt,
                                gint column,
                                gint64 data);
void database_table_bind_double (sqlite3_stmt* stmt,
                                 gint column,
                                 gdouble data);
gboolean database_table_exists_by_id (DatabaseTable* self,
                                      gint64 id);
gboolean database_table_select_by_id (DatabaseTable* self,
                                      gint64 id,
                                      const gchar* columns,
                                      sqlite3_stmt* * stmt);
static void database_table_prepare_update_by_id (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          sqlite3_stmt* * stmt);
static gboolean database_table_execute_update_by_id (DatabaseTable* self,
                                              sqlite3_stmt* stmt);
gboolean database_table_update_text_by_id (DatabaseTable* self,
                                           gint64 id,
                                           const gchar* column,
                                           const gchar* text);
void database_table_update_text_by_id_2 (DatabaseTable* self,
                                         gint64 id,
                                         const gchar* column,
                                         const gchar* text,
                                         GError** error);
gboolean database_table_update_int_by_id (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint value);
void database_table_update_int_by_id_2 (DatabaseTable* self,
                                        gint64 id,
                                        const gchar* column,
                                        gint value,
                                        GError** error);
gboolean database_table_update_int64_by_id (DatabaseTable* self,
                                            gint64 id,
                                            const gchar* column,
                                            gint64 value);
void database_table_update_int64_by_id_2 (DatabaseTable* self,
                                          gint64 id,
                                          const gchar* column,
                                          gint64 value,
                                          GError** error);
void database_table_delete_by_id (DatabaseTable* self,
                                  gint64 id,
                                  GError** error);
gboolean database_table_has_column (const gchar* table_name,
                                    const gchar* column_name);
gboolean database_table_has_table (const gchar* table_name);
gboolean database_table_add_column (const gchar* table_name,
                                    const gchar* column_name,
                                    const gchar* column_constraints);
gboolean database_table_ensure_column (const gchar* table_name,
                                       const gchar* column_name,
                                       const gchar* column_constraints,
                                       const gchar* upgrade_msg);
gint database_table_get_row_count (DatabaseTable* self);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
DatabaseTable* database_table_construct (GType object_type);
static void database_table_finalize (DatabaseTable * obj);

GQuark
database_error_quark (void)
{
	return g_quark_from_static_string ("database-error-quark");
}

static void
database_table_prepare_db (const gchar* filename)
{
	gint res = 0;
	sqlite3* _tmp0_ = NULL;
	gint _tmp1_;
	GError* _inner_error0_ = NULL;
#line 45 "../src/db/DatabaseTable.vala"
	g_return_if_fail (filename != NULL);
#line 47 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_open_v2 (filename, &_tmp0_, SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE, NULL);
#line 47 "../src/db/DatabaseTable.vala"
	_sqlite3_close0 (database_table_db);
#line 47 "../src/db/DatabaseTable.vala"
	database_table_db = _tmp0_;
#line 47 "../src/db/DatabaseTable.vala"
	res = _tmp1_;
#line 49 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_OK) {
#line 217 "DatabaseTable.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 50 "../src/db/DatabaseTable.vala"
		_tmp2_ = g_strdup_printf (_ ("Unable to open/create photo database %s: error code %d"), filename, res);
#line 50 "../src/db/DatabaseTable.vala"
		_tmp3_ = _tmp2_;
#line 50 "../src/db/DatabaseTable.vala"
		app_window_panic (_tmp3_);
#line 50 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp3_);
#line 228 "DatabaseTable.c"
	}
#line 54 "../src/db/DatabaseTable.vala"
	if (g_strcmp0 (filename, DB_IN_MEMORY_NAME) != 0) {
#line 232 "DatabaseTable.c"
		{
			GFile* file_db = NULL;
			GFile* _tmp4_;
			GFileInfo* info = NULL;
			GFile* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
#line 56 "../src/db/DatabaseTable.vala"
			_tmp4_ = g_file_new_for_path (filename);
#line 56 "../src/db/DatabaseTable.vala"
			file_db = _tmp4_;
#line 57 "../src/db/DatabaseTable.vala"
			_tmp5_ = file_db;
#line 57 "../src/db/DatabaseTable.vala"
			_tmp6_ = g_file_query_info (_tmp5_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
#line 57 "../src/db/DatabaseTable.vala"
			info = _tmp6_;
#line 57 "../src/db/DatabaseTable.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 57 "../src/db/DatabaseTable.vala"
				_g_object_unref0 (file_db);
#line 254 "DatabaseTable.c"
				goto __catch354_g_error;
			}
#line 58 "../src/db/DatabaseTable.vala"
			_tmp7_ = info;
#line 58 "../src/db/DatabaseTable.vala"
			if (!g_file_info_get_attribute_boolean (_tmp7_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE)) {
#line 261 "DatabaseTable.c"
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 59 "../src/db/DatabaseTable.vala"
				_tmp8_ = g_strdup_printf (_ ("Unable to write to photo database file:\n %s"), filename);
#line 59 "../src/db/DatabaseTable.vala"
				_tmp9_ = _tmp8_;
#line 59 "../src/db/DatabaseTable.vala"
				app_window_panic (_tmp9_);
#line 59 "../src/db/DatabaseTable.vala"
				_g_free0 (_tmp9_);
#line 272 "DatabaseTable.c"
			}
#line 55 "../src/db/DatabaseTable.vala"
			_g_object_unref0 (info);
#line 55 "../src/db/DatabaseTable.vala"
			_g_object_unref0 (file_db);
#line 278 "DatabaseTable.c"
		}
		goto __finally354;
		__catch354_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 55 "../src/db/DatabaseTable.vala"
			e = _inner_error0_;
#line 55 "../src/db/DatabaseTable.vala"
			_inner_error0_ = NULL;
#line 61 "../src/db/DatabaseTable.vala"
			_tmp10_ = e;
#line 61 "../src/db/DatabaseTable.vala"
			_tmp11_ = _tmp10_->message;
#line 61 "../src/db/DatabaseTable.vala"
			_tmp12_ = g_strdup_printf (_ ("Error accessing database file:\n %s\n\nError was: \n%s"), filename, _tmp11_);
#line 61 "../src/db/DatabaseTable.vala"
			_tmp13_ = _tmp12_;
#line 61 "../src/db/DatabaseTable.vala"
			app_window_panic (_tmp13_);
#line 61 "../src/db/DatabaseTable.vala"
			_g_free0 (_tmp13_);
#line 55 "../src/db/DatabaseTable.vala"
			_g_error_free0 (e);
#line 306 "DatabaseTable.c"
		}
		__finally354:
#line 55 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 55 "../src/db/DatabaseTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 55 "../src/db/DatabaseTable.vala"
			g_clear_error (&_inner_error0_);
#line 55 "../src/db/DatabaseTable.vala"
			return;
#line 317 "DatabaseTable.c"
		}
	}
}

static gint
_sqlite3_exec (sqlite3* self,
               const gchar* sql,
               sqlite3_callback callback,
               gpointer callback_target,
               gchar* * errmsg)
{
	gchar* _vala_errmsg = NULL;
	gint result = 0;
	const gchar* sqlite_errmsg = NULL;
	gint ec = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_;
	const gchar* _tmp4_;
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "sqlite3.vapi"
	g_return_val_if_fail (sql != NULL, 0);
#line 36 "sqlite3.vapi"
	_tmp1_ = sqlite3_exec (self, sql, callback, callback_target, (char**) (&_tmp0_));
#line 36 "sqlite3.vapi"
	sqlite_errmsg = _tmp0_;
#line 36 "sqlite3.vapi"
	ec = _tmp1_;
#line 37 "sqlite3.vapi"
	if ((&_vala_errmsg) != NULL) {
#line 348 "DatabaseTable.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 38 "sqlite3.vapi"
		_tmp2_ = sqlite_errmsg;
#line 38 "sqlite3.vapi"
		_tmp3_ = g_strdup (_tmp2_);
#line 38 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 38 "sqlite3.vapi"
		_vala_errmsg = _tmp3_;
#line 359 "DatabaseTable.c"
	}
#line 40 "sqlite3.vapi"
	_tmp4_ = sqlite_errmsg;
#line 40 "sqlite3.vapi"
	sqlite3_free ((void*) _tmp4_);
#line 41 "sqlite3.vapi"
	result = ec;
#line 41 "sqlite3.vapi"
	if (errmsg) {
#line 41 "sqlite3.vapi"
		*errmsg = _vala_errmsg;
#line 371 "DatabaseTable.c"
	} else {
#line 41 "sqlite3.vapi"
		_g_free0 (_vala_errmsg);
#line 375 "DatabaseTable.c"
	}
#line 41 "sqlite3.vapi"
	return result;
#line 379 "DatabaseTable.c"
}

void
database_table_init (const gchar* filename)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
	sqlite3* _tmp12_;
#line 67 "../src/db/DatabaseTable.vala"
	g_return_if_fail (filename != NULL);
#line 69 "../src/db/DatabaseTable.vala"
	database_table_prepare_db (filename);
#line 70 "../src/db/DatabaseTable.vala"
	g_info ("DatabaseTable.vala:70: Loading database: %s", filename);
#line 74 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 74 "../src/db/DatabaseTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS VersionTable (" "id INTEGER PRIMARY KEY, " "schema_version INTEGER, " "app_version TEXT, " "user_data TEXT NULL" ")", -1, &_tmp1_, NULL);
#line 74 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 74 "../src/db/DatabaseTable.vala"
	stmt = _tmp1_;
#line 74 "../src/db/DatabaseTable.vala"
	res = _tmp2_;
#line 82 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_OK) {
#line 409 "DatabaseTable.c"
		gchar* backup_path = NULL;
		gchar* _tmp3_;
		gchar* cmdline = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
#line 83 "../src/db/DatabaseTable.vala"
		_sqlite3_close0 (database_table_db);
#line 83 "../src/db/DatabaseTable.vala"
		database_table_db = NULL;
#line 85 "../src/db/DatabaseTable.vala"
		_tmp3_ = g_strconcat (filename, ".bak", NULL);
#line 85 "../src/db/DatabaseTable.vala"
		backup_path = _tmp3_;
#line 86 "../src/db/DatabaseTable.vala"
		_tmp4_ = backup_path;
#line 86 "../src/db/DatabaseTable.vala"
		_tmp5_ = g_strconcat ("cp ", _tmp4_, NULL);
#line 86 "../src/db/DatabaseTable.vala"
		_tmp6_ = _tmp5_;
#line 86 "../src/db/DatabaseTable.vala"
		_tmp7_ = g_strconcat (_tmp6_, " ", NULL);
#line 86 "../src/db/DatabaseTable.vala"
		_tmp8_ = _tmp7_;
#line 86 "../src/db/DatabaseTable.vala"
		_tmp9_ = g_strconcat (_tmp8_, filename, NULL);
#line 86 "../src/db/DatabaseTable.vala"
		_tmp10_ = _tmp9_;
#line 86 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp8_);
#line 86 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp6_);
#line 86 "../src/db/DatabaseTable.vala"
		cmdline = _tmp10_;
#line 87 "../src/db/DatabaseTable.vala"
		_tmp11_ = cmdline;
#line 87 "../src/db/DatabaseTable.vala"
		system (_tmp11_);
#line 89 "../src/db/DatabaseTable.vala"
		database_table_prepare_db (filename);
#line 82 "../src/db/DatabaseTable.vala"
		_g_free0 (cmdline);
#line 82 "../src/db/DatabaseTable.vala"
		_g_free0 (backup_path);
#line 459 "DatabaseTable.c"
	}
#line 94 "../src/db/DatabaseTable.vala"
	_tmp12_ = database_table_db;
#line 94 "../src/db/DatabaseTable.vala"
	res = _sqlite3_exec (_tmp12_, "PRAGMA synchronous=OFF", NULL, NULL, NULL);
#line 95 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_OK) {
#line 96 "../src/db/DatabaseTable.vala"
		database_table_warning ("Unable to disable synchronous mode", res);
#line 469 "DatabaseTable.c"
	}
#line 67 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 473 "DatabaseTable.c"
}

void
database_table_terminate (void)
{
#line 101 "../src/db/DatabaseTable.vala"
	_sqlite3_close0 (database_table_db);
#line 101 "../src/db/DatabaseTable.vala"
	database_table_db = NULL;
#line 483 "DatabaseTable.c"
}

void
database_table_fatal (const gchar* op,
                      gint res)
{
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
#line 105 "../src/db/DatabaseTable.vala"
	g_return_if_fail (op != NULL);
#line 106 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 106 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 106 "../src/db/DatabaseTable.vala"
	g_error ("DatabaseTable.vala:106: %s: [%d] %s", op, res, _tmp1_);
#line 500 "DatabaseTable.c"
}

void
database_table_warning (const gchar* op,
                        gint res)
{
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
#line 110 "../src/db/DatabaseTable.vala"
	g_return_if_fail (op != NULL);
#line 111 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 111 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 111 "../src/db/DatabaseTable.vala"
	g_warning ("DatabaseTable.vala:111: %s: [%d] %s", op, res, _tmp1_);
#line 517 "DatabaseTable.c"
}

void
database_table_set_table_name (DatabaseTable* self,
                               const gchar* table_name)
{
	gchar* _tmp0_;
#line 114 "../src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/db/DatabaseTable.vala"
	g_return_if_fail (table_name != NULL);
#line 115 "../src/db/DatabaseTable.vala"
	_tmp0_ = g_strdup (table_name);
#line 115 "../src/db/DatabaseTable.vala"
	_g_free0 (self->table_name);
#line 115 "../src/db/DatabaseTable.vala"
	self->table_name = _tmp0_;
#line 535 "DatabaseTable.c"
}

void
database_table_throw_error (const gchar* method,
                            gint res,
                            GError** error)
{
	gchar* msg = NULL;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 120 "../src/db/DatabaseTable.vala"
	g_return_if_fail (method != NULL);
#line 121 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 121 "../src/db/DatabaseTable.vala"
	_tmp1_ = sqlite3_errmsg (_tmp0_);
#line 121 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("(%s) [%d] - %s", method, res, _tmp1_);
#line 121 "../src/db/DatabaseTable.vala"
	msg = _tmp2_;
#line 123 "../src/db/DatabaseTable.vala"
	switch (res) {
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_OK:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_DONE:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_ROW:
#line 566 "DatabaseTable.c"
		{
#line 127 "../src/db/DatabaseTable.vala"
			_g_free0 (msg);
#line 127 "../src/db/DatabaseTable.vala"
			return;
#line 572 "DatabaseTable.c"
		}
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_PERM:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_BUSY:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_READONLY:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_IOERR:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_CORRUPT:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_CANTOPEN:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_NOLFS:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_AUTH:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_FORMAT:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_NOTADB:
#line 594 "DatabaseTable.c"
		{
			const gchar* _tmp3_;
			GError* _tmp4_;
#line 139 "../src/db/DatabaseTable.vala"
			_tmp3_ = msg;
#line 139 "../src/db/DatabaseTable.vala"
			_tmp4_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_BACKING, _tmp3_);
#line 139 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp4_;
#line 139 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 139 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 139 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 139 "../src/db/DatabaseTable.vala"
				return;
#line 612 "DatabaseTable.c"
			} else {
#line 139 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 139 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 139 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 139 "../src/db/DatabaseTable.vala"
				return;
#line 622 "DatabaseTable.c"
			}
		}
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_NOMEM:
#line 627 "DatabaseTable.c"
		{
			const gchar* _tmp5_;
			GError* _tmp6_;
#line 142 "../src/db/DatabaseTable.vala"
			_tmp5_ = msg;
#line 142 "../src/db/DatabaseTable.vala"
			_tmp6_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_MEMORY, _tmp5_);
#line 142 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp6_;
#line 142 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 142 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 142 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 142 "../src/db/DatabaseTable.vala"
				return;
#line 645 "DatabaseTable.c"
			} else {
#line 142 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 142 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 142 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 142 "../src/db/DatabaseTable.vala"
				return;
#line 655 "DatabaseTable.c"
			}
		}
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_ABORT:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_LOCKED:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_INTERRUPT:
#line 664 "DatabaseTable.c"
		{
			const gchar* _tmp7_;
			GError* _tmp8_;
#line 147 "../src/db/DatabaseTable.vala"
			_tmp7_ = msg;
#line 147 "../src/db/DatabaseTable.vala"
			_tmp8_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ABORT, _tmp7_);
#line 147 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp8_;
#line 147 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 147 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 147 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 147 "../src/db/DatabaseTable.vala"
				return;
#line 682 "DatabaseTable.c"
			} else {
#line 147 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 147 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 147 "../src/db/DatabaseTable.vala"
				return;
#line 692 "DatabaseTable.c"
			}
		}
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_FULL:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_EMPTY:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_TOOBIG:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_CONSTRAINT:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_RANGE:
#line 705 "DatabaseTable.c"
		{
			const gchar* _tmp9_;
			GError* _tmp10_;
#line 154 "../src/db/DatabaseTable.vala"
			_tmp9_ = msg;
#line 154 "../src/db/DatabaseTable.vala"
			_tmp10_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_LIMITS, _tmp9_);
#line 154 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp10_;
#line 154 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 154 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 154 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 154 "../src/db/DatabaseTable.vala"
				return;
#line 723 "DatabaseTable.c"
			} else {
#line 154 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 154 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 154 "../src/db/DatabaseTable.vala"
				return;
#line 733 "DatabaseTable.c"
			}
		}
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_SCHEMA:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_MISMATCH:
#line 740 "DatabaseTable.c"
		{
			const gchar* _tmp11_;
			GError* _tmp12_;
#line 158 "../src/db/DatabaseTable.vala"
			_tmp11_ = msg;
#line 158 "../src/db/DatabaseTable.vala"
			_tmp12_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_TYPESPEC, _tmp11_);
#line 158 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp12_;
#line 158 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 158 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 158 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 158 "../src/db/DatabaseTable.vala"
				return;
#line 758 "DatabaseTable.c"
			} else {
#line 158 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 158 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 158 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 158 "../src/db/DatabaseTable.vala"
				return;
#line 768 "DatabaseTable.c"
			}
		}
		default:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_ERROR:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_INTERNAL:
#line 123 "../src/db/DatabaseTable.vala"
		case SQLITE_MISUSE:
#line 778 "DatabaseTable.c"
		{
			const gchar* _tmp13_;
			GError* _tmp14_;
#line 164 "../src/db/DatabaseTable.vala"
			_tmp13_ = msg;
#line 164 "../src/db/DatabaseTable.vala"
			_tmp14_ = g_error_new_literal (DATABASE_ERROR, DATABASE_ERROR_ERROR, _tmp13_);
#line 164 "../src/db/DatabaseTable.vala"
			_inner_error0_ = _tmp14_;
#line 164 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 164 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 164 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 164 "../src/db/DatabaseTable.vala"
				return;
#line 796 "DatabaseTable.c"
			} else {
#line 164 "../src/db/DatabaseTable.vala"
				_g_free0 (msg);
#line 164 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 164 "../src/db/DatabaseTable.vala"
				return;
#line 806 "DatabaseTable.c"
			}
		}
	}
#line 120 "../src/db/DatabaseTable.vala"
	_g_free0 (msg);
#line 812 "DatabaseTable.c"
}

sqlite3_stmt*
database_table_create_stmt (DatabaseTable* self,
                            const gchar* data)
{
	sqlite3_stmt* result = NULL;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_;
#line 168 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 168 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (data != NULL, NULL);
#line 169 "../src/db/DatabaseTable.vala"
	g_debug ("DatabaseTable.vala:169: Running statement: %s\n", data);
#line 172 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 172 "../src/db/DatabaseTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, data, -1, &_tmp1_, NULL);
#line 172 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 172 "../src/db/DatabaseTable.vala"
	stmt = _tmp1_;
#line 172 "../src/db/DatabaseTable.vala"
	res = _tmp2_;
#line 173 "../src/db/DatabaseTable.vala"
	database_table_assert_test (res == SQLITE_OK, data);
#line 175 "../src/db/DatabaseTable.vala"
	result = stmt;
#line 175 "../src/db/DatabaseTable.vala"
	return result;
#line 847 "DatabaseTable.c"
}

void
database_table_bind_null (sqlite3_stmt* stmt,
                          gint column)
{
	gint res = 0;
#line 178 "../src/db/DatabaseTable.vala"
	g_return_if_fail (stmt != NULL);
#line 179 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_null (stmt, column);
#line 180 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 861 "DatabaseTable.c"
}

void
database_table_bind_text (sqlite3_stmt* stmt,
                          gint column,
                          const gchar* data)
{
	gint res = 0;
	gchar* _tmp0_;
	GDestroyNotify _tmp1_;
#line 183 "../src/db/DatabaseTable.vala"
	g_return_if_fail (stmt != NULL);
#line 184 "../src/db/DatabaseTable.vala"
	if (data == NULL) {
#line 185 "../src/db/DatabaseTable.vala"
		database_table_bind_null (stmt, column);
#line 878 "DatabaseTable.c"
	}
#line 188 "../src/db/DatabaseTable.vala"
	_tmp0_ = g_strdup (data);
#line 188 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_free;
#line 188 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_text (stmt, column, _tmp0_, -1, _tmp1_);
#line 189 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 888 "DatabaseTable.c"
}

void
database_table_bind_int (sqlite3_stmt* stmt,
                         gint column,
                         gint data)
{
	gint res = 0;
#line 192 "../src/db/DatabaseTable.vala"
	g_return_if_fail (stmt != NULL);
#line 193 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int (stmt, column, data);
#line 194 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 903 "DatabaseTable.c"
}

void
database_table_bind_int64 (sqlite3_stmt* stmt,
                           gint column,
                           gint64 data)
{
	gint res = 0;
#line 197 "../src/db/DatabaseTable.vala"
	g_return_if_fail (stmt != NULL);
#line 198 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (stmt, column, data);
#line 199 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 918 "DatabaseTable.c"
}

void
database_table_bind_double (sqlite3_stmt* stmt,
                            gint column,
                            gdouble data)
{
	gint res = 0;
#line 202 "../src/db/DatabaseTable.vala"
	g_return_if_fail (stmt != NULL);
#line 203 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_double (stmt, column, data);
#line 204 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 933 "DatabaseTable.c"
}

static void
database_table_assert_test (gboolean condition,
                            const gchar* data)
{
#line 207 "../src/db/DatabaseTable.vala"
	g_return_if_fail (data != NULL);
#line 208 "../src/db/DatabaseTable.vala"
	if (!condition) {
#line 209 "../src/db/DatabaseTable.vala"
		g_error ("DatabaseTable.vala:209: SQL statement failed: %s\n", data);
#line 946 "DatabaseTable.c"
	}
}

gboolean
database_table_exists_by_id (DatabaseTable* self,
                             gint64 id)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	gboolean _tmp9_ = FALSE;
#line 213 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 215 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 215 "../src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 215 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("SELECT id FROM %s WHERE id=?", _tmp1_);
#line 215 "../src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 215 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 215 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 215 "../src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 215 "../src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 215 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 215 "../src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 216 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 218 "../src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 218 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 1, id);
#line 219 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 221 "../src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 221 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp8_);
#line 222 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_ROW) {
#line 222 "../src/db/DatabaseTable.vala"
		_tmp9_ = res != SQLITE_DONE;
#line 1005 "DatabaseTable.c"
	} else {
#line 222 "../src/db/DatabaseTable.vala"
		_tmp9_ = FALSE;
#line 1009 "DatabaseTable.c"
	}
#line 222 "../src/db/DatabaseTable.vala"
	if (_tmp9_) {
#line 1013 "DatabaseTable.c"
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 223 "../src/db/DatabaseTable.vala"
		_tmp10_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
#line 223 "../src/db/DatabaseTable.vala"
		_tmp11_ = _tmp10_;
#line 223 "../src/db/DatabaseTable.vala"
		_tmp12_ = self->table_name;
#line 223 "../src/db/DatabaseTable.vala"
		_tmp13_ = g_strdup_printf ("exists_by_id [%s] %s", _tmp11_, _tmp12_);
#line 223 "../src/db/DatabaseTable.vala"
		_tmp14_ = _tmp13_;
#line 223 "../src/db/DatabaseTable.vala"
		database_table_fatal (_tmp14_, res);
#line 223 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp14_);
#line 223 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp11_);
#line 1035 "DatabaseTable.c"
	}
#line 225 "../src/db/DatabaseTable.vala"
	result = res == SQLITE_ROW;
#line 225 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 225 "../src/db/DatabaseTable.vala"
	return result;
#line 1043 "DatabaseTable.c"
}

gboolean
database_table_select_by_id (DatabaseTable* self,
                             gint64 id,
                             const gchar* columns,
                             sqlite3_stmt* * stmt)
{
	sqlite3_stmt* _vala_stmt = NULL;
	gboolean result = FALSE;
	gchar* sql = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint res = 0;
	sqlite3* _tmp2_;
	const gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
	sqlite3_stmt* _tmp7_;
	gboolean _tmp8_ = FALSE;
#line 228 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 228 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (columns != NULL, FALSE);
#line 229 "../src/db/DatabaseTable.vala"
	_tmp0_ = self->table_name;
#line 229 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("SELECT %s FROM %s WHERE id=?", columns, _tmp0_);
#line 229 "../src/db/DatabaseTable.vala"
	sql = _tmp1_;
#line 231 "../src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 231 "../src/db/DatabaseTable.vala"
	_tmp3_ = sql;
#line 231 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp2_, _tmp3_, -1, &_tmp4_, NULL);
#line 231 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (_vala_stmt);
#line 231 "../src/db/DatabaseTable.vala"
	_vala_stmt = _tmp4_;
#line 231 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 232 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 234 "../src/db/DatabaseTable.vala"
	_tmp6_ = _vala_stmt;
#line 234 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp6_, 1, id);
#line 235 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 237 "../src/db/DatabaseTable.vala"
	_tmp7_ = _vala_stmt;
#line 237 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp7_);
#line 238 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_ROW) {
#line 238 "../src/db/DatabaseTable.vala"
		_tmp8_ = res != SQLITE_DONE;
#line 1103 "DatabaseTable.c"
	} else {
#line 238 "../src/db/DatabaseTable.vala"
		_tmp8_ = FALSE;
#line 1107 "DatabaseTable.c"
	}
#line 238 "../src/db/DatabaseTable.vala"
	if (_tmp8_) {
#line 1111 "DatabaseTable.c"
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 239 "../src/db/DatabaseTable.vala"
		_tmp9_ = g_strdup_printf ("%" G_GINT64_FORMAT, id);
#line 239 "../src/db/DatabaseTable.vala"
		_tmp10_ = _tmp9_;
#line 239 "../src/db/DatabaseTable.vala"
		_tmp11_ = self->table_name;
#line 239 "../src/db/DatabaseTable.vala"
		_tmp12_ = g_strdup_printf ("select_by_id [%s] %s %s", _tmp10_, _tmp11_, columns);
#line 239 "../src/db/DatabaseTable.vala"
		_tmp13_ = _tmp12_;
#line 239 "../src/db/DatabaseTable.vala"
		database_table_fatal (_tmp13_, res);
#line 239 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp13_);
#line 239 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp10_);
#line 1133 "DatabaseTable.c"
	}
#line 241 "../src/db/DatabaseTable.vala"
	result = res == SQLITE_ROW;
#line 241 "../src/db/DatabaseTable.vala"
	_g_free0 (sql);
#line 241 "../src/db/DatabaseTable.vala"
	if (stmt) {
#line 241 "../src/db/DatabaseTable.vala"
		*stmt = _vala_stmt;
#line 1143 "DatabaseTable.c"
	} else {
#line 241 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (_vala_stmt);
#line 1147 "DatabaseTable.c"
	}
#line 241 "../src/db/DatabaseTable.vala"
	return result;
#line 1151 "DatabaseTable.c"
}

static void
database_table_prepare_update_by_id (DatabaseTable* self,
                                     gint64 id,
                                     const gchar* column,
                                     sqlite3_stmt* * stmt)
{
	sqlite3_stmt* _vala_stmt = NULL;
	gchar* sql = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint res = 0;
	sqlite3* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
#line 245 "../src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 246 "../src/db/DatabaseTable.vala"
	_tmp0_ = self->table_name;
#line 246 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("UPDATE %s SET %s=? WHERE id=?", _tmp0_, column);
#line 246 "../src/db/DatabaseTable.vala"
	sql = _tmp1_;
#line 248 "../src/db/DatabaseTable.vala"
	_tmp2_ = database_table_db;
#line 248 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp2_, sql, -1, &_tmp3_, NULL);
#line 248 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (_vala_stmt);
#line 248 "../src/db/DatabaseTable.vala"
	_vala_stmt = _tmp3_;
#line 248 "../src/db/DatabaseTable.vala"
	res = _tmp4_;
#line 249 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 251 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_vala_stmt, 2, id);
#line 252 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 245 "../src/db/DatabaseTable.vala"
	_g_free0 (sql);
#line 245 "../src/db/DatabaseTable.vala"
	if (stmt) {
#line 245 "../src/db/DatabaseTable.vala"
		*stmt = _vala_stmt;
#line 1200 "DatabaseTable.c"
	} else {
#line 245 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (_vala_stmt);
#line 1204 "DatabaseTable.c"
	}
}

static gboolean
database_table_execute_update_by_id (DatabaseTable* self,
                                     sqlite3_stmt* stmt)
{
	gboolean result = FALSE;
	gint res = 0;
#line 255 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 255 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (stmt != NULL, FALSE);
#line 256 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (stmt);
#line 257 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 258 "../src/db/DatabaseTable.vala"
		database_table_fatal ("execute_update_by_id", res);
#line 260 "../src/db/DatabaseTable.vala"
		result = FALSE;
#line 260 "../src/db/DatabaseTable.vala"
		return result;
#line 1228 "DatabaseTable.c"
	}
#line 263 "../src/db/DatabaseTable.vala"
	result = TRUE;
#line 263 "../src/db/DatabaseTable.vala"
	return result;
#line 1234 "DatabaseTable.c"
}

gboolean
database_table_update_text_by_id (DatabaseTable* self,
                                  gint64 id,
                                  const gchar* column,
                                  const gchar* text)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	gchar* _tmp1_;
	GDestroyNotify _tmp2_;
#line 266 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 266 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 266 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 268 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 268 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 268 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 270 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup (text);
#line 270 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_free;
#line 270 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_text (stmt, 1, _tmp1_, -1, _tmp2_);
#line 271 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 273 "../src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 273 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 273 "../src/db/DatabaseTable.vala"
	return result;
#line 1275 "DatabaseTable.c"
}

void
database_table_update_text_by_id_2 (DatabaseTable* self,
                                    gint64 id,
                                    const gchar* column,
                                    const gchar* text,
                                    GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	gchar* _tmp2_;
	GDestroyNotify _tmp3_;
	sqlite3_stmt* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 276 "../src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 276 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 276 "../src/db/DatabaseTable.vala"
	g_return_if_fail (text != NULL);
#line 278 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 278 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 278 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 280 "../src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 280 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup (text);
#line 280 "../src/db/DatabaseTable.vala"
	_tmp3_ = g_free;
#line 280 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_text (_tmp1_, 1, _tmp2_, -1, _tmp3_);
#line 281 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 283 "../src/db/DatabaseTable.vala"
	_tmp4_ = stmt;
#line 283 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp4_);
#line 284 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1321 "DatabaseTable.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 285 "../src/db/DatabaseTable.vala"
		_tmp5_ = self->table_name;
#line 285 "../src/db/DatabaseTable.vala"
		_tmp6_ = g_strdup_printf ("DatabaseTable.update_text_by_id_2 %s.%s", _tmp5_, column);
#line 285 "../src/db/DatabaseTable.vala"
		_tmp7_ = _tmp6_;
#line 285 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp7_, res, &_inner_error0_);
#line 285 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp7_);
#line 285 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 285 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 285 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 285 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 285 "../src/db/DatabaseTable.vala"
				return;
#line 1345 "DatabaseTable.c"
			} else {
#line 285 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 285 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 285 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 285 "../src/db/DatabaseTable.vala"
				return;
#line 1355 "DatabaseTable.c"
			}
		}
	}
#line 276 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1361 "DatabaseTable.c"
}

gboolean
database_table_update_int_by_id (DatabaseTable* self,
                                 gint64 id,
                                 const gchar* column,
                                 gint value)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
#line 288 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 288 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 290 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 290 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 290 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 292 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int (stmt, 1, value);
#line 293 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 295 "../src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 295 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 295 "../src/db/DatabaseTable.vala"
	return result;
#line 1394 "DatabaseTable.c"
}

void
database_table_update_int_by_id_2 (DatabaseTable* self,
                                   gint64 id,
                                   const gchar* column,
                                   gint value,
                                   GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 298 "../src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 300 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 300 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 300 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 302 "../src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 302 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int (_tmp1_, 1, value);
#line 303 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 305 "../src/db/DatabaseTable.vala"
	_tmp2_ = stmt;
#line 305 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp2_);
#line 306 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1432 "DatabaseTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 307 "../src/db/DatabaseTable.vala"
		_tmp3_ = self->table_name;
#line 307 "../src/db/DatabaseTable.vala"
		_tmp4_ = g_strdup_printf ("DatabaseTable.update_int_by_id_2 %s.%s", _tmp3_, column);
#line 307 "../src/db/DatabaseTable.vala"
		_tmp5_ = _tmp4_;
#line 307 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp5_, res, &_inner_error0_);
#line 307 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp5_);
#line 307 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 307 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 307 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 307 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 307 "../src/db/DatabaseTable.vala"
				return;
#line 1456 "DatabaseTable.c"
			} else {
#line 307 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 307 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 307 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 307 "../src/db/DatabaseTable.vala"
				return;
#line 1466 "DatabaseTable.c"
			}
		}
	}
#line 298 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1472 "DatabaseTable.c"
}

gboolean
database_table_update_int64_by_id (DatabaseTable* self,
                                   gint64 id,
                                   const gchar* column,
                                   gint64 value)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
#line 310 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 310 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column != NULL, FALSE);
#line 312 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 312 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 312 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 314 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (stmt, 1, value);
#line 315 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 317 "../src/db/DatabaseTable.vala"
	result = database_table_execute_update_by_id (self, stmt);
#line 317 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 317 "../src/db/DatabaseTable.vala"
	return result;
#line 1505 "DatabaseTable.c"
}

void
database_table_update_int64_by_id_2 (DatabaseTable* self,
                                     gint64 id,
                                     const gchar* column,
                                     gint64 value,
                                     GError** error)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 320 "../src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 320 "../src/db/DatabaseTable.vala"
	g_return_if_fail (column != NULL);
#line 322 "../src/db/DatabaseTable.vala"
	database_table_prepare_update_by_id (self, id, column, &_tmp0_);
#line 322 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 322 "../src/db/DatabaseTable.vala"
	stmt = _tmp0_;
#line 324 "../src/db/DatabaseTable.vala"
	_tmp1_ = stmt;
#line 324 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp1_, 1, value);
#line 325 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 327 "../src/db/DatabaseTable.vala"
	_tmp2_ = stmt;
#line 327 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp2_);
#line 328 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1543 "DatabaseTable.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 329 "../src/db/DatabaseTable.vala"
		_tmp3_ = self->table_name;
#line 329 "../src/db/DatabaseTable.vala"
		_tmp4_ = g_strdup_printf ("DatabaseTable.update_int64_by_id_2 %s.%s", _tmp3_, column);
#line 329 "../src/db/DatabaseTable.vala"
		_tmp5_ = _tmp4_;
#line 329 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp5_, res, &_inner_error0_);
#line 329 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp5_);
#line 329 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 329 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 329 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 329 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 329 "../src/db/DatabaseTable.vala"
				return;
#line 1567 "DatabaseTable.c"
			} else {
#line 329 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 329 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 329 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 329 "../src/db/DatabaseTable.vala"
				return;
#line 1577 "DatabaseTable.c"
			}
		}
	}
#line 320 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1583 "DatabaseTable.c"
}

void
database_table_delete_by_id (DatabaseTable* self,
                             gint64 id,
                             GError** error)
{
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 332 "../src/db/DatabaseTable.vala"
	g_return_if_fail (self != NULL);
#line 334 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 334 "../src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 334 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("DELETE FROM %s WHERE id=?", _tmp1_);
#line 334 "../src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 334 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 334 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 334 "../src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 334 "../src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 334 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 334 "../src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 335 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 337 "../src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 337 "../src/db/DatabaseTable.vala"
	res = sqlite3_bind_int64 (_tmp7_, 1, id);
#line 338 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 340 "../src/db/DatabaseTable.vala"
	_tmp8_ = stmt;
#line 340 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp8_);
#line 341 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1639 "DatabaseTable.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 342 "../src/db/DatabaseTable.vala"
		_tmp9_ = self->table_name;
#line 342 "../src/db/DatabaseTable.vala"
		_tmp10_ = g_strdup_printf ("%s.remove", _tmp9_);
#line 342 "../src/db/DatabaseTable.vala"
		_tmp11_ = _tmp10_;
#line 342 "../src/db/DatabaseTable.vala"
		database_table_throw_error (_tmp11_, res, &_inner_error0_);
#line 342 "../src/db/DatabaseTable.vala"
		_g_free0 (_tmp11_);
#line 342 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 342 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 342 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 342 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 342 "../src/db/DatabaseTable.vala"
				return;
#line 1663 "DatabaseTable.c"
			} else {
#line 342 "../src/db/DatabaseTable.vala"
				_sqlite3_finalize0 (stmt);
#line 342 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 342 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 342 "../src/db/DatabaseTable.vala"
				return;
#line 1673 "DatabaseTable.c"
			}
		}
	}
#line 332 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1679 "DatabaseTable.c"
}

gboolean
database_table_has_column (const gchar* table_name,
                           const gchar* column_name)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
#line 345 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 345 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 347 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 347 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("PRAGMA table_info(%s)", table_name);
#line 347 "../src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 347 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 347 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 347 "../src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 347 "../src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 347 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 347 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 348 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 1719 "DatabaseTable.c"
	{
		gboolean _tmp6_ = FALSE;
#line 350 "../src/db/DatabaseTable.vala"
		_tmp6_ = TRUE;
#line 350 "../src/db/DatabaseTable.vala"
		while (TRUE) {
#line 1726 "DatabaseTable.c"
			sqlite3_stmt* _tmp7_;
#line 350 "../src/db/DatabaseTable.vala"
			if (!_tmp6_) {
#line 1730 "DatabaseTable.c"
			}
#line 350 "../src/db/DatabaseTable.vala"
			_tmp6_ = FALSE;
#line 351 "../src/db/DatabaseTable.vala"
			_tmp7_ = stmt;
#line 351 "../src/db/DatabaseTable.vala"
			res = sqlite3_step (_tmp7_);
#line 352 "../src/db/DatabaseTable.vala"
			if (res == SQLITE_DONE) {
#line 353 "../src/db/DatabaseTable.vala"
				break;
#line 1742 "DatabaseTable.c"
			} else {
#line 354 "../src/db/DatabaseTable.vala"
				if (res != SQLITE_ROW) {
#line 1746 "DatabaseTable.c"
					gchar* _tmp8_;
					gchar* _tmp9_;
#line 355 "../src/db/DatabaseTable.vala"
					_tmp8_ = g_strdup_printf ("has_column %s", table_name);
#line 355 "../src/db/DatabaseTable.vala"
					_tmp9_ = _tmp8_;
#line 355 "../src/db/DatabaseTable.vala"
					database_table_fatal (_tmp9_, res);
#line 355 "../src/db/DatabaseTable.vala"
					_g_free0 (_tmp9_);
#line 357 "../src/db/DatabaseTable.vala"
					break;
#line 1759 "DatabaseTable.c"
				} else {
					gchar* column = NULL;
					sqlite3_stmt* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					gboolean _tmp13_ = FALSE;
					const gchar* _tmp14_;
#line 359 "../src/db/DatabaseTable.vala"
					_tmp10_ = stmt;
#line 359 "../src/db/DatabaseTable.vala"
					_tmp11_ = (const gchar*) sqlite3_column_text (_tmp10_, 1);
#line 359 "../src/db/DatabaseTable.vala"
					_tmp12_ = g_strdup (_tmp11_);
#line 359 "../src/db/DatabaseTable.vala"
					column = _tmp12_;
#line 360 "../src/db/DatabaseTable.vala"
					_tmp14_ = column;
#line 360 "../src/db/DatabaseTable.vala"
					if (_tmp14_ != NULL) {
#line 1779 "DatabaseTable.c"
						const gchar* _tmp15_;
#line 360 "../src/db/DatabaseTable.vala"
						_tmp15_ = column;
#line 360 "../src/db/DatabaseTable.vala"
						_tmp13_ = g_strcmp0 (_tmp15_, column_name) == 0;
#line 1785 "DatabaseTable.c"
					} else {
#line 360 "../src/db/DatabaseTable.vala"
						_tmp13_ = FALSE;
#line 1789 "DatabaseTable.c"
					}
#line 360 "../src/db/DatabaseTable.vala"
					if (_tmp13_) {
#line 361 "../src/db/DatabaseTable.vala"
						result = TRUE;
#line 361 "../src/db/DatabaseTable.vala"
						_g_free0 (column);
#line 361 "../src/db/DatabaseTable.vala"
						_sqlite3_finalize0 (stmt);
#line 361 "../src/db/DatabaseTable.vala"
						return result;
#line 1801 "DatabaseTable.c"
					}
#line 354 "../src/db/DatabaseTable.vala"
					_g_free0 (column);
#line 1805 "DatabaseTable.c"
				}
			}
		}
	}
#line 365 "../src/db/DatabaseTable.vala"
	result = FALSE;
#line 365 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 365 "../src/db/DatabaseTable.vala"
	return result;
#line 1816 "DatabaseTable.c"
}

gboolean
database_table_has_table (const gchar* table_name)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
#line 368 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 370 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 370 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("PRAGMA table_info(%s)", table_name);
#line 370 "../src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 370 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 370 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 370 "../src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 370 "../src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 370 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 370 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 371 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 373 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (stmt);
#line 375 "../src/db/DatabaseTable.vala"
	result = res != SQLITE_DONE;
#line 375 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 375 "../src/db/DatabaseTable.vala"
	return result;
#line 1861 "DatabaseTable.c"
}

gboolean
database_table_add_column (const gchar* table_name,
                           const gchar* column_name,
                           const gchar* column_constraints)
{
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint _tmp5_;
	sqlite3_stmt* _tmp6_;
#line 378 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 378 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 378 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_constraints != NULL, FALSE);
#line 380 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 380 "../src/db/DatabaseTable.vala"
	_tmp1_ = g_strdup_printf ("ALTER TABLE %s ADD COLUMN %s %s", table_name, column_name, column_constraints);
#line 380 "../src/db/DatabaseTable.vala"
	_tmp2_ = _tmp1_;
#line 380 "../src/db/DatabaseTable.vala"
	_tmp4_ = sqlite3_prepare_v2 (_tmp0_, _tmp2_, -1, &_tmp3_, NULL);
#line 380 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 380 "../src/db/DatabaseTable.vala"
	stmt = _tmp3_;
#line 380 "../src/db/DatabaseTable.vala"
	_tmp5_ = _tmp4_;
#line 380 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp2_);
#line 380 "../src/db/DatabaseTable.vala"
	res = _tmp5_;
#line 382 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 384 "../src/db/DatabaseTable.vala"
	_tmp6_ = stmt;
#line 384 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp6_);
#line 385 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 1911 "DatabaseTable.c"
		sqlite3* _tmp7_;
		const gchar* _tmp8_;
#line 386 "../src/db/DatabaseTable.vala"
		_tmp7_ = database_table_db;
#line 386 "../src/db/DatabaseTable.vala"
		_tmp8_ = sqlite3_errmsg (_tmp7_);
#line 386 "../src/db/DatabaseTable.vala"
		g_critical ("DatabaseTable.vala:386: Unable to add column %s %s %s: (%d) %s", table_name, column_name, column_constraints, res, _tmp8_);
#line 389 "../src/db/DatabaseTable.vala"
		result = FALSE;
#line 389 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (stmt);
#line 389 "../src/db/DatabaseTable.vala"
		return result;
#line 1926 "DatabaseTable.c"
	}
#line 392 "../src/db/DatabaseTable.vala"
	result = TRUE;
#line 392 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 392 "../src/db/DatabaseTable.vala"
	return result;
#line 1934 "DatabaseTable.c"
}

gboolean
database_table_ensure_column (const gchar* table_name,
                              const gchar* column_name,
                              const gchar* column_constraints,
                              const gchar* upgrade_msg)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 398 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (table_name != NULL, FALSE);
#line 398 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_name != NULL, FALSE);
#line 398 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (column_constraints != NULL, FALSE);
#line 398 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (upgrade_msg != NULL, FALSE);
#line 400 "../src/db/DatabaseTable.vala"
	if (!database_table_has_table (table_name)) {
#line 400 "../src/db/DatabaseTable.vala"
		_tmp0_ = TRUE;
#line 1957 "DatabaseTable.c"
	} else {
#line 400 "../src/db/DatabaseTable.vala"
		_tmp0_ = database_table_has_column (table_name, column_name);
#line 1961 "DatabaseTable.c"
	}
#line 400 "../src/db/DatabaseTable.vala"
	if (_tmp0_) {
#line 401 "../src/db/DatabaseTable.vala"
		result = TRUE;
#line 401 "../src/db/DatabaseTable.vala"
		return result;
#line 1969 "DatabaseTable.c"
	}
#line 403 "../src/db/DatabaseTable.vala"
	g_message ("DatabaseTable.vala:403: %s", upgrade_msg);
#line 405 "../src/db/DatabaseTable.vala"
	result = database_table_add_column (table_name, column_name, column_constraints);
#line 405 "../src/db/DatabaseTable.vala"
	return result;
#line 1977 "DatabaseTable.c"
}

gint
database_table_get_row_count (DatabaseTable* self)
{
	gint result = 0;
	sqlite3_stmt* stmt = NULL;
	gint res = 0;
	sqlite3* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	sqlite3_stmt* _tmp11_;
#line 408 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 410 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 410 "../src/db/DatabaseTable.vala"
	_tmp1_ = self->table_name;
#line 410 "../src/db/DatabaseTable.vala"
	_tmp2_ = g_strdup_printf ("SELECT COUNT(id) AS RowCount FROM %s", _tmp1_);
#line 410 "../src/db/DatabaseTable.vala"
	_tmp3_ = _tmp2_;
#line 410 "../src/db/DatabaseTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp0_, _tmp3_, -1, &_tmp4_, NULL);
#line 410 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 410 "../src/db/DatabaseTable.vala"
	stmt = _tmp4_;
#line 410 "../src/db/DatabaseTable.vala"
	_tmp6_ = _tmp5_;
#line 410 "../src/db/DatabaseTable.vala"
	_g_free0 (_tmp3_);
#line 410 "../src/db/DatabaseTable.vala"
	res = _tmp6_;
#line 411 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 413 "../src/db/DatabaseTable.vala"
	_tmp7_ = stmt;
#line 413 "../src/db/DatabaseTable.vala"
	res = sqlite3_step (_tmp7_);
#line 414 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_ROW) {
#line 2025 "DatabaseTable.c"
		const gchar* _tmp8_;
		sqlite3* _tmp9_;
		const gchar* _tmp10_;
#line 415 "../src/db/DatabaseTable.vala"
		_tmp8_ = self->table_name;
#line 415 "../src/db/DatabaseTable.vala"
		_tmp9_ = database_table_db;
#line 415 "../src/db/DatabaseTable.vala"
		_tmp10_ = sqlite3_errmsg (_tmp9_);
#line 415 "../src/db/DatabaseTable.vala"
		g_critical ("DatabaseTable.vala:415: Unable to retrieve row count on %s: (%d) %s", _tmp8_, res, _tmp10_);
#line 417 "../src/db/DatabaseTable.vala"
		result = 0;
#line 417 "../src/db/DatabaseTable.vala"
		_sqlite3_finalize0 (stmt);
#line 417 "../src/db/DatabaseTable.vala"
		return result;
#line 2043 "DatabaseTable.c"
	}
#line 420 "../src/db/DatabaseTable.vala"
	_tmp11_ = stmt;
#line 420 "../src/db/DatabaseTable.vala"
	result = sqlite3_column_int (_tmp11_, 0);
#line 420 "../src/db/DatabaseTable.vala"
	_sqlite3_finalize0 (stmt);
#line 420 "../src/db/DatabaseTable.vala"
	return result;
#line 2053 "DatabaseTable.c"
}

void
database_table_begin_transaction (void)
{
	gint _tmp0_;
	gint res = 0;
	sqlite3* _tmp1_;
#line 425 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_in_transaction;
#line 425 "../src/db/DatabaseTable.vala"
	database_table_in_transaction = _tmp0_ + 1;
#line 425 "../src/db/DatabaseTable.vala"
	if (_tmp0_ != 0) {
#line 426 "../src/db/DatabaseTable.vala"
		return;
#line 2070 "DatabaseTable.c"
	}
#line 428 "../src/db/DatabaseTable.vala"
	_tmp1_ = database_table_db;
#line 428 "../src/db/DatabaseTable.vala"
	res = _sqlite3_exec (_tmp1_, "BEGIN TRANSACTION", NULL, NULL, NULL);
#line 429 "../src/db/DatabaseTable.vala"
	_vala_assert (res == SQLITE_OK, "res == Sqlite.OK");
#line 2078 "DatabaseTable.c"
}

void
database_table_commit_transaction (GError** error)
{
	gint res = 0;
	sqlite3* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 434 "../src/db/DatabaseTable.vala"
	_vala_assert (database_table_in_transaction > 0, "in_transaction > 0");
#line 435 "../src/db/DatabaseTable.vala"
	database_table_in_transaction = database_table_in_transaction - 1;
#line 435 "../src/db/DatabaseTable.vala"
	if (database_table_in_transaction != 0) {
#line 436 "../src/db/DatabaseTable.vala"
		return;
#line 2095 "DatabaseTable.c"
	}
#line 438 "../src/db/DatabaseTable.vala"
	_tmp0_ = database_table_db;
#line 438 "../src/db/DatabaseTable.vala"
	res = _sqlite3_exec (_tmp0_, "COMMIT TRANSACTION", NULL, NULL, NULL);
#line 439 "../src/db/DatabaseTable.vala"
	if (res != SQLITE_DONE) {
#line 440 "../src/db/DatabaseTable.vala"
		database_table_throw_error ("commit_transaction", res, &_inner_error0_);
#line 440 "../src/db/DatabaseTable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 440 "../src/db/DatabaseTable.vala"
			if (_inner_error0_->domain == DATABASE_ERROR) {
#line 440 "../src/db/DatabaseTable.vala"
				g_propagate_error (error, _inner_error0_);
#line 440 "../src/db/DatabaseTable.vala"
				return;
#line 2113 "DatabaseTable.c"
			} else {
#line 440 "../src/db/DatabaseTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 440 "../src/db/DatabaseTable.vala"
				g_clear_error (&_inner_error0_);
#line 440 "../src/db/DatabaseTable.vala"
				return;
#line 2121 "DatabaseTable.c"
			}
		}
	}
}

DatabaseTable*
database_table_construct (GType object_type)
{
	DatabaseTable* self = NULL;
#line 29 "../src/db/DatabaseTable.vala"
	self = (DatabaseTable*) g_type_create_instance (object_type);
#line 29 "../src/db/DatabaseTable.vala"
	return self;
#line 2135 "DatabaseTable.c"
}

static void
value_database_table_init (GValue* value)
{
#line 29 "../src/db/DatabaseTable.vala"
	value->data[0].v_pointer = NULL;
#line 2143 "DatabaseTable.c"
}

static void
value_database_table_free_value (GValue* value)
{
#line 29 "../src/db/DatabaseTable.vala"
	if (value->data[0].v_pointer) {
#line 29 "../src/db/DatabaseTable.vala"
		database_table_unref (value->data[0].v_pointer);
#line 2153 "DatabaseTable.c"
	}
}

static void
value_database_table_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 29 "../src/db/DatabaseTable.vala"
	if (src_value->data[0].v_pointer) {
#line 29 "../src/db/DatabaseTable.vala"
		dest_value->data[0].v_pointer = database_table_ref (src_value->data[0].v_pointer);
#line 2165 "DatabaseTable.c"
	} else {
#line 29 "../src/db/DatabaseTable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2169 "DatabaseTable.c"
	}
}

static gpointer
value_database_table_peek_pointer (const GValue* value)
{
#line 29 "../src/db/DatabaseTable.vala"
	return value->data[0].v_pointer;
#line 2178 "DatabaseTable.c"
}

static gchar*
value_database_table_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 29 "../src/db/DatabaseTable.vala"
	if (collect_values[0].v_pointer) {
#line 2189 "DatabaseTable.c"
		DatabaseTable * object;
		object = collect_values[0].v_pointer;
#line 29 "../src/db/DatabaseTable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 29 "../src/db/DatabaseTable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2196 "DatabaseTable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 29 "../src/db/DatabaseTable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2200 "DatabaseTable.c"
		}
#line 29 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = database_table_ref (object);
#line 2204 "DatabaseTable.c"
	} else {
#line 29 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2208 "DatabaseTable.c"
	}
#line 29 "../src/db/DatabaseTable.vala"
	return NULL;
#line 2212 "DatabaseTable.c"
}

static gchar*
value_database_table_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	DatabaseTable ** object_p;
	object_p = collect_values[0].v_pointer;
#line 29 "../src/db/DatabaseTable.vala"
	if (!object_p) {
#line 29 "../src/db/DatabaseTable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2227 "DatabaseTable.c"
	}
#line 29 "../src/db/DatabaseTable.vala"
	if (!value->data[0].v_pointer) {
#line 29 "../src/db/DatabaseTable.vala"
		*object_p = NULL;
#line 2233 "DatabaseTable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 29 "../src/db/DatabaseTable.vala"
		*object_p = value->data[0].v_pointer;
#line 2237 "DatabaseTable.c"
	} else {
#line 29 "../src/db/DatabaseTable.vala"
		*object_p = database_table_ref (value->data[0].v_pointer);
#line 2241 "DatabaseTable.c"
	}
#line 29 "../src/db/DatabaseTable.vala"
	return NULL;
#line 2245 "DatabaseTable.c"
}

GParamSpec*
param_spec_database_table (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecDatabaseTable* spec;
#line 29 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DATABASE_TABLE), NULL);
#line 29 "../src/db/DatabaseTable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 29 "../src/db/DatabaseTable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 29 "../src/db/DatabaseTable.vala"
	return G_PARAM_SPEC (spec);
#line 2264 "DatabaseTable.c"
}

gpointer
value_get_database_table (const GValue* value)
{
#line 29 "../src/db/DatabaseTable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE), NULL);
#line 29 "../src/db/DatabaseTable.vala"
	return value->data[0].v_pointer;
#line 2274 "DatabaseTable.c"
}

void
value_set_database_table (GValue* value,
                          gpointer v_object)
{
	DatabaseTable * old;
#line 29 "../src/db/DatabaseTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
#line 29 "../src/db/DatabaseTable.vala"
	old = value->data[0].v_pointer;
#line 29 "../src/db/DatabaseTable.vala"
	if (v_object) {
#line 29 "../src/db/DatabaseTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
#line 29 "../src/db/DatabaseTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = v_object;
#line 29 "../src/db/DatabaseTable.vala"
		database_table_ref (value->data[0].v_pointer);
#line 2296 "DatabaseTable.c"
	} else {
#line 29 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2300 "DatabaseTable.c"
	}
#line 29 "../src/db/DatabaseTable.vala"
	if (old) {
#line 29 "../src/db/DatabaseTable.vala"
		database_table_unref (old);
#line 2306 "DatabaseTable.c"
	}
}

void
value_take_database_table (GValue* value,
                           gpointer v_object)
{
	DatabaseTable * old;
#line 29 "../src/db/DatabaseTable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DATABASE_TABLE));
#line 29 "../src/db/DatabaseTable.vala"
	old = value->data[0].v_pointer;
#line 29 "../src/db/DatabaseTable.vala"
	if (v_object) {
#line 29 "../src/db/DatabaseTable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DATABASE_TABLE));
#line 29 "../src/db/DatabaseTable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = v_object;
#line 2327 "DatabaseTable.c"
	} else {
#line 29 "../src/db/DatabaseTable.vala"
		value->data[0].v_pointer = NULL;
#line 2331 "DatabaseTable.c"
	}
#line 29 "../src/db/DatabaseTable.vala"
	if (old) {
#line 29 "../src/db/DatabaseTable.vala"
		database_table_unref (old);
#line 2337 "DatabaseTable.c"
	}
}

static void
database_table_class_init (DatabaseTableClass * klass,
                           gpointer klass_data)
{
#line 29 "../src/db/DatabaseTable.vala"
	database_table_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/db/DatabaseTable.vala"
	((DatabaseTableClass *) klass)->finalize = database_table_finalize;
#line 2349 "DatabaseTable.c"
}

static void
database_table_instance_init (DatabaseTable * self,
                              gpointer klass)
{
#line 43 "../src/db/DatabaseTable.vala"
	self->table_name = NULL;
#line 29 "../src/db/DatabaseTable.vala"
	self->ref_count = 1;
#line 2360 "DatabaseTable.c"
}

static void
database_table_finalize (DatabaseTable * obj)
{
	DatabaseTable * self;
#line 29 "../src/db/DatabaseTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DATABASE_TABLE, DatabaseTable);
#line 29 "../src/db/DatabaseTable.vala"
	g_signal_handlers_destroy (self);
#line 43 "../src/db/DatabaseTable.vala"
	_g_free0 (self->table_name);
#line 2373 "DatabaseTable.c"
}

GType
database_table_get_type (void)
{
	static volatile gsize database_table_type_id__volatile = 0;
	if (g_once_init_enter (&database_table_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_database_table_init, value_database_table_free_value, value_database_table_copy_value, value_database_table_peek_pointer, "p", value_database_table_collect_value, "p", value_database_table_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DatabaseTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) database_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DatabaseTable), 0, (GInstanceInitFunc) database_table_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType database_table_type_id;
		database_table_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DatabaseTable", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&database_table_type_id__volatile, database_table_type_id);
	}
	return database_table_type_id__volatile;
}

gpointer
database_table_ref (gpointer instance)
{
	DatabaseTable * self;
	self = instance;
#line 29 "../src/db/DatabaseTable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 29 "../src/db/DatabaseTable.vala"
	return instance;
#line 2400 "DatabaseTable.c"
}

void
database_table_unref (gpointer instance)
{
	DatabaseTable * self;
	self = instance;
#line 29 "../src/db/DatabaseTable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 29 "../src/db/DatabaseTable.vala"
		DATABASE_TABLE_GET_CLASS (self)->finalize (self);
#line 29 "../src/db/DatabaseTable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2414 "DatabaseTable.c"
	}
}

