/* VersionTable.c generated by valac 0.44.0, the Vala compiler
 * generated from VersionTable.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <sqlite3.h>

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_VERSION_TABLE (version_table_get_type ())
#define VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VERSION_TABLE, VersionTable))
#define VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VERSION_TABLE, VersionTableClass))
#define IS_VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VERSION_TABLE))
#define IS_VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VERSION_TABLE))
#define VERSION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VERSION_TABLE, VersionTableClass))

typedef struct _VersionTable VersionTable;
typedef struct _VersionTableClass VersionTableClass;
typedef struct _VersionTablePrivate VersionTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _VersionTable {
	DatabaseTable parent_instance;
	VersionTablePrivate * priv;
};

struct _VersionTableClass {
	DatabaseTableClass parent_class;
};

static gpointer version_table_parent_class = NULL;
static VersionTable* version_table_instance;
static VersionTable* version_table_instance = NULL;

gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType version_table_get_type (void) G_GNUC_CONST;
static VersionTable* version_table_new (void);
static VersionTable* version_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
sqlite3_stmt* database_table_create_stmt (DatabaseTable* self,
                                          const gchar* data);
void database_table_fatal (const gchar* op,
                           gint res);
void database_table_set_table_name (DatabaseTable* self,
                                    const gchar* table_name);
VersionTable* version_table_get_instance (void);
gint version_table_get_version (VersionTable* self,
                                gchar* * app_version);
void version_table_set_version (VersionTable* self,
                                gint version,
                                const gchar* app_version,
                                const gchar* user_data);
void database_table_bind_int (sqlite3_stmt* stmt,
                              gint column,
                              gint data);
void database_table_bind_text (sqlite3_stmt* stmt,
                               gint column,
                               const gchar* data);
void version_table_update_version (VersionTable* self,
                                   gint version,
                                   const gchar* app_version);
static void version_table_finalize (DatabaseTable * obj);

static VersionTable*
version_table_construct (GType object_type)
{
	VersionTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
#line 23 "../src/db/VersionTable.vala"
	self = (VersionTable*) database_table_construct (object_type);
#line 24 "../src/db/VersionTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "CREATE TABLE IF NOT EXISTS VersionTable (" "id INTEGER PRIMARY KEY, " "schema_version INTEGER, " "app_version TEXT, " "user_data TEXT NULL" ")");
#line 24 "../src/db/VersionTable.vala"
	stmt = _tmp0_;
#line 31 "../src/db/VersionTable.vala"
	_tmp1_ = stmt;
#line 31 "../src/db/VersionTable.vala"
	res = sqlite3_step (_tmp1_);
#line 32 "../src/db/VersionTable.vala"
	if (res != SQLITE_DONE) {
#line 33 "../src/db/VersionTable.vala"
		database_table_fatal ("create version table", res);
#line 143 "VersionTable.c"
	}
#line 35 "../src/db/VersionTable.vala"
	database_table_set_table_name ((DatabaseTable*) self, "VersionTable");
#line 23 "../src/db/VersionTable.vala"
	_sqlite3_finalize0 (stmt);
#line 23 "../src/db/VersionTable.vala"
	return self;
#line 151 "VersionTable.c"
}

static VersionTable*
version_table_new (void)
{
#line 23 "../src/db/VersionTable.vala"
	return version_table_construct (TYPE_VERSION_TABLE);
#line 159 "VersionTable.c"
}

static gpointer
_database_table_ref0 (gpointer self)
{
#line 42 "../src/db/VersionTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 167 "VersionTable.c"
}

VersionTable*
version_table_get_instance (void)
{
	VersionTable* result = NULL;
	VersionTable* _tmp0_;
	VersionTable* _tmp2_;
	VersionTable* _tmp3_;
#line 39 "../src/db/VersionTable.vala"
	_tmp0_ = version_table_instance;
#line 39 "../src/db/VersionTable.vala"
	if (_tmp0_ == NULL) {
#line 181 "VersionTable.c"
		VersionTable* _tmp1_;
#line 40 "../src/db/VersionTable.vala"
		_tmp1_ = version_table_new ();
#line 40 "../src/db/VersionTable.vala"
		_database_table_unref0 (version_table_instance);
#line 40 "../src/db/VersionTable.vala"
		version_table_instance = _tmp1_;
#line 189 "VersionTable.c"
	}
#line 42 "../src/db/VersionTable.vala"
	_tmp2_ = version_table_instance;
#line 42 "../src/db/VersionTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 42 "../src/db/VersionTable.vala"
	result = _tmp3_;
#line 42 "../src/db/VersionTable.vala"
	return result;
#line 199 "VersionTable.c"
}

gint
version_table_get_version (VersionTable* self,
                           gchar* * app_version)
{
	gchar* _vala_app_version = NULL;
	gint result = 0;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	gint res = 0;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	sqlite3_stmt* _tmp5_;
#line 45 "../src/db/VersionTable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "../src/db/VersionTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "SELECT schema_version, app_version FROM VersionTable ORDER BY schema_v" \
"ersion DESC LIMIT 1");
#line 46 "../src/db/VersionTable.vala"
	stmt = _tmp0_;
#line 48 "../src/db/VersionTable.vala"
	_tmp1_ = stmt;
#line 48 "../src/db/VersionTable.vala"
	res = sqlite3_step (_tmp1_);
#line 49 "../src/db/VersionTable.vala"
	if (res != SQLITE_ROW) {
#line 50 "../src/db/VersionTable.vala"
		if (res != SQLITE_DONE) {
#line 51 "../src/db/VersionTable.vala"
			database_table_fatal ("get_version", res);
#line 232 "VersionTable.c"
		}
#line 53 "../src/db/VersionTable.vala"
		_g_free0 (_vala_app_version);
#line 53 "../src/db/VersionTable.vala"
		_vala_app_version = NULL;
#line 55 "../src/db/VersionTable.vala"
		result = -1;
#line 55 "../src/db/VersionTable.vala"
		_sqlite3_finalize0 (stmt);
#line 55 "../src/db/VersionTable.vala"
		if (app_version) {
#line 55 "../src/db/VersionTable.vala"
			*app_version = _vala_app_version;
#line 246 "VersionTable.c"
		} else {
#line 55 "../src/db/VersionTable.vala"
			_g_free0 (_vala_app_version);
#line 250 "VersionTable.c"
		}
#line 55 "../src/db/VersionTable.vala"
		return result;
#line 254 "VersionTable.c"
	}
#line 58 "../src/db/VersionTable.vala"
	_tmp2_ = stmt;
#line 58 "../src/db/VersionTable.vala"
	_tmp3_ = (const gchar*) sqlite3_column_text (_tmp2_, 1);
#line 58 "../src/db/VersionTable.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 58 "../src/db/VersionTable.vala"
	_g_free0 (_vala_app_version);
#line 58 "../src/db/VersionTable.vala"
	_vala_app_version = _tmp4_;
#line 60 "../src/db/VersionTable.vala"
	_tmp5_ = stmt;
#line 60 "../src/db/VersionTable.vala"
	result = sqlite3_column_int (_tmp5_, 0);
#line 60 "../src/db/VersionTable.vala"
	_sqlite3_finalize0 (stmt);
#line 60 "../src/db/VersionTable.vala"
	if (app_version) {
#line 60 "../src/db/VersionTable.vala"
		*app_version = _vala_app_version;
#line 276 "VersionTable.c"
	} else {
#line 60 "../src/db/VersionTable.vala"
		_g_free0 (_vala_app_version);
#line 280 "VersionTable.c"
	}
#line 60 "../src/db/VersionTable.vala"
	return result;
#line 284 "VersionTable.c"
}

void
version_table_set_version (VersionTable* self,
                           gint version,
                           const gchar* app_version,
                           const gchar* user_data)
{
	sqlite3_stmt* stmt = NULL;
	gchar* bitbucket = NULL;
	gchar* _tmp0_ = NULL;
	gint _tmp1_;
	sqlite3_stmt* _tmp4_;
	sqlite3_stmt* _tmp5_;
	sqlite3_stmt* _tmp6_;
	gint res = 0;
	sqlite3_stmt* _tmp7_;
#line 63 "../src/db/VersionTable.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/db/VersionTable.vala"
	g_return_if_fail (app_version != NULL);
#line 66 "../src/db/VersionTable.vala"
	_tmp1_ = version_table_get_version (self, &_tmp0_);
#line 66 "../src/db/VersionTable.vala"
	_g_free0 (bitbucket);
#line 66 "../src/db/VersionTable.vala"
	bitbucket = _tmp0_;
#line 66 "../src/db/VersionTable.vala"
	if (_tmp1_ != -1) {
#line 314 "VersionTable.c"
		sqlite3_stmt* _tmp2_;
#line 68 "../src/db/VersionTable.vala"
		_tmp2_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE VersionTable SET schema_version=?, app_version=?, user_data=?");
#line 68 "../src/db/VersionTable.vala"
		_sqlite3_finalize0 (stmt);
#line 68 "../src/db/VersionTable.vala"
		stmt = _tmp2_;
#line 322 "VersionTable.c"
	} else {
		sqlite3_stmt* _tmp3_;
#line 71 "../src/db/VersionTable.vala"
		_tmp3_ = database_table_create_stmt ((DatabaseTable*) self, "INSERT INTO VersionTable (schema_version, app_version, user_data) VALU" \
"ES (?,?, ?)");
#line 71 "../src/db/VersionTable.vala"
		_sqlite3_finalize0 (stmt);
#line 71 "../src/db/VersionTable.vala"
		stmt = _tmp3_;
#line 331 "VersionTable.c"
	}
#line 74 "../src/db/VersionTable.vala"
	_tmp4_ = stmt;
#line 74 "../src/db/VersionTable.vala"
	database_table_bind_int (_tmp4_, 1, version);
#line 75 "../src/db/VersionTable.vala"
	_tmp5_ = stmt;
#line 75 "../src/db/VersionTable.vala"
	database_table_bind_text (_tmp5_, 2, app_version);
#line 76 "../src/db/VersionTable.vala"
	_tmp6_ = stmt;
#line 76 "../src/db/VersionTable.vala"
	database_table_bind_text (_tmp6_, 3, user_data);
#line 78 "../src/db/VersionTable.vala"
	_tmp7_ = stmt;
#line 78 "../src/db/VersionTable.vala"
	res = sqlite3_step (_tmp7_);
#line 79 "../src/db/VersionTable.vala"
	if (res != SQLITE_DONE) {
#line 351 "VersionTable.c"
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 80 "../src/db/VersionTable.vala"
		_tmp8_ = g_strdup_printf ("set_version %d %s %s", version, app_version, user_data);
#line 80 "../src/db/VersionTable.vala"
		_tmp9_ = _tmp8_;
#line 80 "../src/db/VersionTable.vala"
		database_table_fatal (_tmp9_, res);
#line 80 "../src/db/VersionTable.vala"
		_g_free0 (_tmp9_);
#line 362 "VersionTable.c"
	}
#line 63 "../src/db/VersionTable.vala"
	_g_free0 (bitbucket);
#line 63 "../src/db/VersionTable.vala"
	_sqlite3_finalize0 (stmt);
#line 368 "VersionTable.c"
}

void
version_table_update_version (VersionTable* self,
                              gint version,
                              const gchar* app_version)
{
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_;
	sqlite3_stmt* _tmp1_;
	sqlite3_stmt* _tmp2_;
	gint res = 0;
	sqlite3_stmt* _tmp3_;
#line 83 "../src/db/VersionTable.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/db/VersionTable.vala"
	g_return_if_fail (app_version != NULL);
#line 84 "../src/db/VersionTable.vala"
	_tmp0_ = database_table_create_stmt ((DatabaseTable*) self, "UPDATE VersionTable SET schema_version=?, app_version=?");
#line 84 "../src/db/VersionTable.vala"
	stmt = _tmp0_;
#line 86 "../src/db/VersionTable.vala"
	_tmp1_ = stmt;
#line 86 "../src/db/VersionTable.vala"
	database_table_bind_int (_tmp1_, 1, version);
#line 87 "../src/db/VersionTable.vala"
	_tmp2_ = stmt;
#line 87 "../src/db/VersionTable.vala"
	database_table_bind_text (_tmp2_, 2, app_version);
#line 89 "../src/db/VersionTable.vala"
	_tmp3_ = stmt;
#line 89 "../src/db/VersionTable.vala"
	res = sqlite3_step (_tmp3_);
#line 90 "../src/db/VersionTable.vala"
	if (res != SQLITE_DONE) {
#line 404 "VersionTable.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 91 "../src/db/VersionTable.vala"
		_tmp4_ = g_strdup_printf ("update_version %d", version);
#line 91 "../src/db/VersionTable.vala"
		_tmp5_ = _tmp4_;
#line 91 "../src/db/VersionTable.vala"
		database_table_fatal (_tmp5_, res);
#line 91 "../src/db/VersionTable.vala"
		_g_free0 (_tmp5_);
#line 415 "VersionTable.c"
	}
#line 83 "../src/db/VersionTable.vala"
	_sqlite3_finalize0 (stmt);
#line 419 "VersionTable.c"
}

static void
version_table_class_init (VersionTableClass * klass,
                          gpointer klass_data)
{
#line 20 "../src/db/VersionTable.vala"
	version_table_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/db/VersionTable.vala"
	((DatabaseTableClass *) klass)->finalize = version_table_finalize;
#line 430 "VersionTable.c"
}

static void
version_table_instance_init (VersionTable * self,
                             gpointer klass)
{
}

static void
version_table_finalize (DatabaseTable * obj)
{
	VersionTable * self;
#line 20 "../src/db/VersionTable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VERSION_TABLE, VersionTable);
#line 20 "../src/db/VersionTable.vala"
	DATABASE_TABLE_CLASS (version_table_parent_class)->finalize (obj);
#line 447 "VersionTable.c"
}

GType
version_table_get_type (void)
{
	static volatile gsize version_table_type_id__volatile = 0;
	if (g_once_init_enter (&version_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VersionTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) version_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VersionTable), 0, (GInstanceInitFunc) version_table_instance_init, NULL };
		GType version_table_type_id;
		version_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "VersionTable", &g_define_type_info, 0);
		g_once_init_leave (&version_table_type_id__volatile, version_table_type_id);
	}
	return version_table_type_id__volatile;
}

