/* string.c generated by valac 0.44.0, the Vala compiler
 * generated from string.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())

gint64 g_ascii_strtoll (const gchar* str,
                        gchar** endptr,
                        guint num_base);
#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
gboolean is_string_empty (const gchar* s);
gint utf8_cs_compare (void* a,
                      void* b);
gint utf8_ci_compare (void* a,
                      void* b);
gchar* uchar_array_to_string (guchar* data,
                              gint data_length1,
                              gint length);
guchar* string_to_uchar_array (const gchar* str,
                               gint* result_length1);
static void _vala_array_add123 (guchar* * array,
                         int* length,
                         int* size,
                         guchar value);
gchar* guarded_markup_escape_text (const gchar* plain);
glong find_last_offset (const gchar* str,
                        gchar c);
gboolean is_in_ci_array (const gchar* str,
                         gchar** strings,
                         gint strings_length1);
GType prepare_input_text_options_get_type (void) G_GNUC_CONST;
gchar* prepare_input_text (const gchar* text,
                           PrepareInputTextOptions options,
                           gint dest_length);
gint64 parse_int64 (const gchar* str,
                    gint num_base);
gboolean string_contains_char (const gchar* haystack,
                               gunichar needle);
gboolean string_contains_str (const gchar* haystack,
                              const gchar* needle);
gchar* string_sliced_at (const gchar* str,
                         gint index);
gchar* string_sliced_at_first_str (const gchar* haystack,
                                   const gchar* needle,
                                   gint start_index);
gchar* string_sliced_at_last_str (const gchar* haystack,
                                  const gchar* needle,
                                  gint start_index);
gchar* string_sliced_at_first_char (const gchar* haystack,
                                    gunichar ch,
                                    gint start_index);
gchar* string_sliced_at_last_char (const gchar* haystack,
                                   gunichar ch,
                                   gint start_index);
gchar* string_strip_leading_zeroes (const gchar* str);
gchar* string_remove_diacritics (const gchar* istring);
gchar* string_to_hex_string (const gchar* str);
guint string_collated_hash (void* ptr);
guint string_precollated_hash (void* ptr);
gint string_collated_compare (void* a,
                              void* b);
gint string_precollated_compare (const gchar* astr,
                                 const gchar* akey,
                                 const gchar* bstr,
                                 const gchar* bkey);
gboolean string_collated_equals (void* a,
                                 void* b);
gboolean string_precollated_equals (const gchar* astr,
                                    const gchar* akey,
                                    const gchar* bstr,
                                    const gchar* bkey);

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 123 "string.c"
}

inline gboolean
is_string_empty (const gchar* s)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 25 "../src/util/string.vala"
	if (s == NULL) {
#line 25 "../src/util/string.vala"
		_tmp0_ = TRUE;
#line 135 "string.c"
	} else {
#line 25 "../src/util/string.vala"
		_tmp0_ = string_get (s, (glong) 0) == '\0';
#line 139 "string.c"
	}
#line 25 "../src/util/string.vala"
	result = _tmp0_;
#line 25 "../src/util/string.vala"
	return result;
#line 145 "string.c"
}

gint
utf8_cs_compare (void* a,
                 void* b)
{
	gint result = 0;
#line 30 "../src/util/string.vala"
	result = g_utf8_collate ((const gchar*) a, (const gchar*) b);
#line 30 "../src/util/string.vala"
	return result;
#line 157 "string.c"
}

gint
utf8_ci_compare (void* a,
                 void* b)
{
	gint result = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
#line 35 "../src/util/string.vala"
	_tmp0_ = g_utf8_strdown ((const gchar*) a, (gssize) -1);
#line 35 "../src/util/string.vala"
	_tmp1_ = _tmp0_;
#line 35 "../src/util/string.vala"
	_tmp2_ = g_utf8_strdown ((const gchar*) b, (gssize) -1);
#line 35 "../src/util/string.vala"
	_tmp3_ = _tmp2_;
#line 35 "../src/util/string.vala"
	_tmp4_ = g_utf8_collate (_tmp1_, _tmp3_);
#line 35 "../src/util/string.vala"
	_g_free0 (_tmp3_);
#line 35 "../src/util/string.vala"
	_g_free0 (_tmp1_);
#line 35 "../src/util/string.vala"
	result = _tmp4_;
#line 35 "../src/util/string.vala"
	return result;
#line 188 "string.c"
}

gchar*
uchar_array_to_string (guchar* data,
                       gint data_length1,
                       gint length)
{
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 40 "../src/util/string.vala"
	if (length < 0) {
#line 41 "../src/util/string.vala"
		length = data_length1;
#line 206 "string.c"
	}
#line 43 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 43 "../src/util/string.vala"
	builder = _tmp0_;
#line 212 "string.c"
	{
		gint ctr = 0;
#line 44 "../src/util/string.vala"
		ctr = 0;
#line 217 "string.c"
		{
			gboolean _tmp1_ = FALSE;
#line 44 "../src/util/string.vala"
			_tmp1_ = TRUE;
#line 44 "../src/util/string.vala"
			while (TRUE) {
#line 224 "string.c"
				guchar _tmp3_;
#line 44 "../src/util/string.vala"
				if (!_tmp1_) {
#line 228 "string.c"
					gint _tmp2_;
#line 44 "../src/util/string.vala"
					_tmp2_ = ctr;
#line 44 "../src/util/string.vala"
					ctr = _tmp2_ + 1;
#line 234 "string.c"
				}
#line 44 "../src/util/string.vala"
				_tmp1_ = FALSE;
#line 44 "../src/util/string.vala"
				if (!(ctr < length)) {
#line 44 "../src/util/string.vala"
					break;
#line 242 "string.c"
				}
#line 45 "../src/util/string.vala"
				_tmp3_ = data[ctr];
#line 45 "../src/util/string.vala"
				if (_tmp3_ != ((guchar) '\0')) {
#line 248 "string.c"
					GString* _tmp4_;
					guchar _tmp5_;
#line 46 "../src/util/string.vala"
					_tmp4_ = builder;
#line 46 "../src/util/string.vala"
					_tmp5_ = data[ctr];
#line 46 "../src/util/string.vala"
					g_string_append_c (_tmp4_, (gchar) _tmp5_);
#line 257 "string.c"
				} else {
#line 48 "../src/util/string.vala"
					break;
#line 261 "string.c"
				}
			}
		}
	}
#line 51 "../src/util/string.vala"
	_tmp6_ = builder;
#line 51 "../src/util/string.vala"
	_tmp7_ = _tmp6_->str;
#line 51 "../src/util/string.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 51 "../src/util/string.vala"
	result = _tmp8_;
#line 51 "../src/util/string.vala"
	_g_string_free0 (builder);
#line 51 "../src/util/string.vala"
	return result;
#line 278 "string.c"
}

static void
_vala_array_add123 (guchar* * array,
                    int* length,
                    int* size,
                    guchar value)
{
#line 58 "../src/util/string.vala"
	if ((*length) == (*size)) {
#line 58 "../src/util/string.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 58 "../src/util/string.vala"
		*array = g_renew (guchar, *array, *size);
#line 293 "string.c"
	}
#line 58 "../src/util/string.vala"
	(*array)[(*length)++] = value;
#line 297 "string.c"
}

guchar*
string_to_uchar_array (const gchar* str,
                       gint* result_length1)
{
	guchar* result = NULL;
	guchar* data = NULL;
	guchar* _tmp0_;
	gint data_length1;
	gint _data_size_;
	guchar* _tmp6_;
	gint _tmp6__length1;
#line 55 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 56 "../src/util/string.vala"
	_tmp0_ = g_new0 (guchar, 0);
#line 56 "../src/util/string.vala"
	data = _tmp0_;
#line 56 "../src/util/string.vala"
	data_length1 = 0;
#line 56 "../src/util/string.vala"
	_data_size_ = data_length1;
#line 321 "string.c"
	{
		gint ctr = 0;
#line 57 "../src/util/string.vala"
		ctr = 0;
#line 326 "string.c"
		{
			gboolean _tmp1_ = FALSE;
#line 57 "../src/util/string.vala"
			_tmp1_ = TRUE;
#line 57 "../src/util/string.vala"
			while (TRUE) {
#line 333 "string.c"
				gint _tmp3_;
				gint _tmp4_;
				guchar* _tmp5_;
				gint _tmp5__length1;
#line 57 "../src/util/string.vala"
				if (!_tmp1_) {
#line 340 "string.c"
					gint _tmp2_;
#line 57 "../src/util/string.vala"
					_tmp2_ = ctr;
#line 57 "../src/util/string.vala"
					ctr = _tmp2_ + 1;
#line 346 "string.c"
				}
#line 57 "../src/util/string.vala"
				_tmp1_ = FALSE;
#line 57 "../src/util/string.vala"
				_tmp3_ = strlen (str);
#line 57 "../src/util/string.vala"
				_tmp4_ = _tmp3_;
#line 57 "../src/util/string.vala"
				if (!(ctr < _tmp4_)) {
#line 57 "../src/util/string.vala"
					break;
#line 358 "string.c"
				}
#line 58 "../src/util/string.vala"
				_tmp5_ = data;
#line 58 "../src/util/string.vala"
				_tmp5__length1 = data_length1;
#line 58 "../src/util/string.vala"
				_vala_array_add123 (&data, &data_length1, &_data_size_, (guchar) string_get (str, (glong) ctr));
#line 366 "string.c"
			}
		}
	}
#line 60 "../src/util/string.vala"
	_tmp6_ = data;
#line 60 "../src/util/string.vala"
	_tmp6__length1 = data_length1;
#line 60 "../src/util/string.vala"
	if (result_length1) {
#line 60 "../src/util/string.vala"
		*result_length1 = _tmp6__length1;
#line 378 "string.c"
	}
#line 60 "../src/util/string.vala"
	result = _tmp6_;
#line 60 "../src/util/string.vala"
	return result;
#line 384 "string.c"
}

inline gchar*
guarded_markup_escape_text (const gchar* plain)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 71 "../src/util/string.vala"
	if (!is_string_empty (plain)) {
#line 71 "../src/util/string.vala"
		_tmp1_ = g_utf8_validate (plain, (gssize) -1, NULL);
#line 397 "string.c"
	} else {
#line 71 "../src/util/string.vala"
		_tmp1_ = FALSE;
#line 401 "string.c"
	}
#line 71 "../src/util/string.vala"
	if (_tmp1_) {
#line 405 "string.c"
		gchar* _tmp2_;
#line 71 "../src/util/string.vala"
		_tmp2_ = g_markup_escape_text (plain, (gssize) -1);
#line 71 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 71 "../src/util/string.vala"
		_tmp0_ = _tmp2_;
#line 413 "string.c"
	} else {
		gchar* _tmp3_;
#line 71 "../src/util/string.vala"
		_tmp3_ = g_strdup ("");
#line 71 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 71 "../src/util/string.vala"
		_tmp0_ = _tmp3_;
#line 422 "string.c"
	}
#line 71 "../src/util/string.vala"
	result = _tmp0_;
#line 71 "../src/util/string.vala"
	return result;
#line 428 "string.c"
}

glong
find_last_offset (const gchar* str,
                  gchar c)
{
	glong result = 0L;
	glong offset = 0L;
	gint _tmp0_;
	gint _tmp1_;
#line 74 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, 0L);
#line 75 "../src/util/string.vala"
	_tmp0_ = strlen (str);
#line 75 "../src/util/string.vala"
	_tmp1_ = _tmp0_;
#line 75 "../src/util/string.vala"
	offset = (glong) _tmp1_;
#line 76 "../src/util/string.vala"
	while (TRUE) {
#line 76 "../src/util/string.vala"
		offset = offset - 1;
#line 76 "../src/util/string.vala"
		if (!(offset >= ((glong) 0))) {
#line 76 "../src/util/string.vala"
			break;
#line 455 "string.c"
		}
#line 77 "../src/util/string.vala"
		if (string_get (str, offset) == c) {
#line 78 "../src/util/string.vala"
			result = offset;
#line 78 "../src/util/string.vala"
			return result;
#line 463 "string.c"
		}
	}
#line 81 "../src/util/string.vala"
	result = (glong) -1;
#line 81 "../src/util/string.vala"
	return result;
#line 470 "string.c"
}

gboolean
is_in_ci_array (const gchar* str,
                gchar** strings,
                gint strings_length1)
{
	gboolean result = FALSE;
	gchar* strdown = NULL;
	gchar* _tmp0_;
#line 86 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, FALSE);
#line 87 "../src/util/string.vala"
	_tmp0_ = g_utf8_strdown (str, (gssize) -1);
#line 87 "../src/util/string.vala"
	strdown = _tmp0_;
#line 487 "string.c"
	{
		gchar** str_element_collection = NULL;
		gint str_element_collection_length1 = 0;
		gint _str_element_collection_size_ = 0;
		gint str_element_it = 0;
#line 88 "../src/util/string.vala"
		str_element_collection = strings;
#line 88 "../src/util/string.vala"
		str_element_collection_length1 = strings_length1;
#line 88 "../src/util/string.vala"
		for (str_element_it = 0; str_element_it < strings_length1; str_element_it = str_element_it + 1) {
#line 499 "string.c"
			gchar* _tmp1_;
			gchar* str_element = NULL;
#line 88 "../src/util/string.vala"
			_tmp1_ = g_strdup (str_element_collection[str_element_it]);
#line 88 "../src/util/string.vala"
			str_element = _tmp1_;
#line 506 "string.c"
			{
				const gchar* _tmp2_;
				const gchar* _tmp3_;
#line 89 "../src/util/string.vala"
				_tmp2_ = strdown;
#line 89 "../src/util/string.vala"
				_tmp3_ = str_element;
#line 89 "../src/util/string.vala"
				if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
#line 90 "../src/util/string.vala"
					result = TRUE;
#line 90 "../src/util/string.vala"
					_g_free0 (str_element);
#line 90 "../src/util/string.vala"
					_g_free0 (strdown);
#line 90 "../src/util/string.vala"
					return result;
#line 524 "string.c"
				}
#line 88 "../src/util/string.vala"
				_g_free0 (str_element);
#line 528 "string.c"
			}
		}
	}
#line 93 "../src/util/string.vala"
	result = FALSE;
#line 93 "../src/util/string.vala"
	_g_free0 (strdown);
#line 93 "../src/util/string.vala"
	return result;
#line 538 "string.c"
}

GType
prepare_input_text_options_get_type (void)
{
	static volatile gsize prepare_input_text_options_type_id__volatile = 0;
	if (g_once_init_enter (&prepare_input_text_options_type_id__volatile)) {
		static const GFlagsValue values[] = {{PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL", "empty-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_VALIDATE, "PREPARE_INPUT_TEXT_OPTIONS_VALIDATE", "validate"}, {PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL", "invalid-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_STRIP, "PREPARE_INPUT_TEXT_OPTIONS_STRIP", "strip"}, {PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF, "PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF", "strip-crlf"}, {PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE, "PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE", "normalize"}, {PREPARE_INPUT_TEXT_OPTIONS_DEFAULT, "PREPARE_INPUT_TEXT_OPTIONS_DEFAULT", "default"}, {0, NULL, NULL}};
		GType prepare_input_text_options_type_id;
		prepare_input_text_options_type_id = g_flags_register_static ("PrepareInputTextOptions", values);
		g_once_init_leave (&prepare_input_text_options_type_id__volatile, prepare_input_text_options_type_id);
	}
	return prepare_input_text_options_type_id__volatile;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 575 "string.c"
}

static gchar*
string_delimit (const gchar* self,
                const gchar* delimiters,
                gchar new_delimiter)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1312 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1312 "glib-2.0.vapi"
	g_return_val_if_fail (delimiters != NULL, NULL);
#line 1313 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1313 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1314 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1314 "glib-2.0.vapi"
	g_strdelimit (_tmp1_, delimiters, new_delimiter);
#line 1315 "glib-2.0.vapi"
	result = _result_;
#line 1315 "glib-2.0.vapi"
	return result;
#line 603 "string.c"
}

gchar*
prepare_input_text (const gchar* text,
                    PrepareInputTextOptions options,
                    gint dest_length)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* prepped = NULL;
	gchar* _tmp3_;
	gboolean _tmp10_ = FALSE;
#line 108 "../src/util/string.vala"
	if (text == NULL) {
#line 109 "../src/util/string.vala"
		result = NULL;
#line 109 "../src/util/string.vala"
		return result;
#line 622 "string.c"
	}
#line 111 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) != 0) {
#line 111 "../src/util/string.vala"
		_tmp0_ = !g_utf8_validate (text, (gssize) -1, NULL);
#line 628 "string.c"
	} else {
#line 111 "../src/util/string.vala"
		_tmp0_ = FALSE;
#line 632 "string.c"
	}
#line 111 "../src/util/string.vala"
	if (_tmp0_) {
#line 636 "string.c"
		const gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
#line 112 "../src/util/string.vala"
		if ((options & PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) != 0) {
#line 112 "../src/util/string.vala"
			_tmp1_ = NULL;
#line 643 "string.c"
		} else {
#line 112 "../src/util/string.vala"
			_tmp1_ = "";
#line 647 "string.c"
		}
#line 112 "../src/util/string.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 112 "../src/util/string.vala"
		result = _tmp2_;
#line 112 "../src/util/string.vala"
		return result;
#line 655 "string.c"
	}
#line 114 "../src/util/string.vala"
	_tmp3_ = g_strdup (text);
#line 114 "../src/util/string.vala"
	prepped = _tmp3_;
#line 120 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) != 0) {
#line 663 "string.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 121 "../src/util/string.vala"
		_tmp4_ = prepped;
#line 121 "../src/util/string.vala"
		_tmp5_ = g_utf8_normalize (_tmp4_, (gssize) -1, G_NORMALIZE_NFC);
#line 121 "../src/util/string.vala"
		_g_free0 (prepped);
#line 121 "../src/util/string.vala"
		prepped = _tmp5_;
#line 674 "string.c"
	}
#line 123 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_STRIP) != 0) {
#line 678 "string.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 124 "../src/util/string.vala"
		_tmp6_ = prepped;
#line 124 "../src/util/string.vala"
		_tmp7_ = string_strip (_tmp6_);
#line 124 "../src/util/string.vala"
		_g_free0 (prepped);
#line 124 "../src/util/string.vala"
		prepped = _tmp7_;
#line 689 "string.c"
	}
#line 128 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) != 0) {
#line 693 "string.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 129 "../src/util/string.vala"
		_tmp8_ = prepped;
#line 129 "../src/util/string.vala"
		_tmp9_ = string_delimit (_tmp8_, "\n\r", ' ');
#line 129 "../src/util/string.vala"
		_g_free0 (prepped);
#line 129 "../src/util/string.vala"
		prepped = _tmp9_;
#line 704 "string.c"
	}
#line 131 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) != 0) {
#line 708 "string.c"
		const gchar* _tmp11_;
#line 131 "../src/util/string.vala"
		_tmp11_ = prepped;
#line 131 "../src/util/string.vala"
		_tmp10_ = is_string_empty (_tmp11_);
#line 714 "string.c"
	} else {
#line 131 "../src/util/string.vala"
		_tmp10_ = FALSE;
#line 718 "string.c"
	}
#line 131 "../src/util/string.vala"
	if (_tmp10_) {
#line 132 "../src/util/string.vala"
		result = NULL;
#line 132 "../src/util/string.vala"
		_g_free0 (prepped);
#line 132 "../src/util/string.vala"
		return result;
#line 728 "string.c"
	}
#line 137 "../src/util/string.vala"
	if (dest_length >= 0) {
#line 732 "string.c"
		GString* sb = NULL;
		const gchar* _tmp12_;
		GString* _tmp13_;
		GString* _tmp14_;
		GString* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
#line 138 "../src/util/string.vala"
		_tmp12_ = prepped;
#line 138 "../src/util/string.vala"
		_tmp13_ = g_string_new (_tmp12_);
#line 138 "../src/util/string.vala"
		sb = _tmp13_;
#line 139 "../src/util/string.vala"
		_tmp14_ = sb;
#line 139 "../src/util/string.vala"
		g_string_truncate (_tmp14_, (gsize) dest_length);
#line 140 "../src/util/string.vala"
		_tmp15_ = sb;
#line 140 "../src/util/string.vala"
		_tmp16_ = _tmp15_->str;
#line 140 "../src/util/string.vala"
		_tmp17_ = g_strdup (_tmp16_);
#line 140 "../src/util/string.vala"
		result = _tmp17_;
#line 140 "../src/util/string.vala"
		_g_string_free0 (sb);
#line 140 "../src/util/string.vala"
		_g_free0 (prepped);
#line 140 "../src/util/string.vala"
		return result;
#line 764 "string.c"
	}
#line 144 "../src/util/string.vala"
	result = prepped;
#line 144 "../src/util/string.vala"
	return result;
#line 770 "string.c"
}

gint64
parse_int64 (const gchar* str,
             gint num_base)
{
	gint64 result = 0LL;
#line 147 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, 0LL);
#line 148 "../src/util/string.vala"
	result = g_ascii_strtoll (str, NULL, (guint) num_base);
#line 148 "../src/util/string.vala"
	return result;
#line 784 "string.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1101 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1102 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1102 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1104 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1104 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 806 "string.c"
		gchar* _tmp2_;
#line 1105 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1105 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1105 "glib-2.0.vapi"
		return result;
#line 814 "string.c"
	} else {
#line 1107 "glib-2.0.vapi"
		result = -1;
#line 1107 "glib-2.0.vapi"
		return result;
#line 820 "string.c"
	}
}

inline gboolean
string_contains_char (const gchar* haystack,
                      gunichar needle)
{
	gboolean result = FALSE;
#line 153 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, FALSE);
#line 154 "../src/util/string.vala"
	result = string_index_of_char (haystack, needle, 0) >= 0;
#line 154 "../src/util/string.vala"
	return result;
#line 835 "string.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 859 "string.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 867 "string.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 873 "string.c"
	}
}

inline gboolean
string_contains_str (const gchar* haystack,
                     const gchar* needle)
{
	gboolean result = FALSE;
#line 157 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, FALSE);
#line 157 "../src/util/string.vala"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 158 "../src/util/string.vala"
	result = string_index_of (haystack, needle, 0) >= 0;
#line 158 "../src/util/string.vala"
	return result;
#line 890 "string.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
#line 1425 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1426 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1426 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1426 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1427 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1428 "glib-2.0.vapi"
		start = string_length + start;
#line 917 "string.c"
	}
#line 1430 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1431 "glib-2.0.vapi"
		end = string_length + end;
#line 923 "string.c"
	}
#line 1433 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1433 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 929 "string.c"
	} else {
#line 1433 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 933 "string.c"
	}
#line 1433 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1434 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1434 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 941 "string.c"
	} else {
#line 1434 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 945 "string.c"
	}
#line 1434 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1435 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1436 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1436 "glib-2.0.vapi"
	result = _tmp4_;
#line 1436 "glib-2.0.vapi"
	return result;
#line 957 "string.c"
}

inline gchar*
string_sliced_at (const gchar* str,
                  gint index)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 161 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 162 "../src/util/string.vala"
	if (index >= 0) {
#line 970 "string.c"
		gint _tmp1_;
		gint _tmp2_;
		gchar* _tmp3_;
#line 162 "../src/util/string.vala"
		_tmp1_ = strlen (str);
#line 162 "../src/util/string.vala"
		_tmp2_ = _tmp1_;
#line 162 "../src/util/string.vala"
		_tmp3_ = string_slice (str, (glong) index, (glong) _tmp2_);
#line 162 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 162 "../src/util/string.vala"
		_tmp0_ = _tmp3_;
#line 984 "string.c"
	} else {
#line 162 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 162 "../src/util/string.vala"
		_tmp0_ = NULL;
#line 990 "string.c"
	}
#line 162 "../src/util/string.vala"
	result = _tmp0_;
#line 162 "../src/util/string.vala"
	return result;
#line 996 "string.c"
}

inline gchar*
string_sliced_at_first_str (const gchar* haystack,
                            const gchar* needle,
                            gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 165 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 165 "../src/util/string.vala"
	g_return_val_if_fail (needle != NULL, NULL);
#line 166 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_index_of (haystack, needle, start_index));
#line 166 "../src/util/string.vala"
	result = _tmp0_;
#line 166 "../src/util/string.vala"
	return result;
#line 1016 "string.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1092 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1092 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1094 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1094 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1040 "string.c"
		gchar* _tmp2_;
#line 1095 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1095 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1095 "glib-2.0.vapi"
		return result;
#line 1048 "string.c"
	} else {
#line 1097 "glib-2.0.vapi"
		result = -1;
#line 1097 "glib-2.0.vapi"
		return result;
#line 1054 "string.c"
	}
}

inline gchar*
string_sliced_at_last_str (const gchar* haystack,
                           const gchar* needle,
                           gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 169 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 169 "../src/util/string.vala"
	g_return_val_if_fail (needle != NULL, NULL);
#line 170 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_last_index_of (haystack, needle, start_index));
#line 170 "../src/util/string.vala"
	result = _tmp0_;
#line 170 "../src/util/string.vala"
	return result;
#line 1075 "string.c"
}

inline gchar*
string_sliced_at_first_char (const gchar* haystack,
                             gunichar ch,
                             gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 173 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 174 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_index_of_char (haystack, ch, start_index));
#line 174 "../src/util/string.vala"
	result = _tmp0_;
#line 174 "../src/util/string.vala"
	return result;
#line 1093 "string.c"
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1111 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1112 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1112 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1114 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1114 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1115 "string.c"
		gchar* _tmp2_;
#line 1115 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1115 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1115 "glib-2.0.vapi"
		return result;
#line 1123 "string.c"
	} else {
#line 1117 "glib-2.0.vapi"
		result = -1;
#line 1117 "glib-2.0.vapi"
		return result;
#line 1129 "string.c"
	}
}

inline gchar*
string_sliced_at_last_char (const gchar* haystack,
                            gunichar ch,
                            gint start_index)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 177 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 178 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_last_index_of_char (haystack, ch, start_index));
#line 178 "../src/util/string.vala"
	result = _tmp0_;
#line 178 "../src/util/string.vala"
	return result;
#line 1148 "string.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1210 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1211 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1211 "glib-2.0.vapi"
	return result;
#line 1162 "string.c"
}

gchar*
string_strip_leading_zeroes (const gchar* str)
{
	gchar* result = NULL;
	GString* stripped = NULL;
	GString* _tmp0_;
	gboolean prev_is_space = FALSE;
	GString* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
#line 182 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 183 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 183 "../src/util/string.vala"
	stripped = _tmp0_;
#line 184 "../src/util/string.vala"
	prev_is_space = TRUE;
#line 1183 "string.c"
	{
		const gchar* iter = NULL;
#line 185 "../src/util/string.vala"
		iter = str;
#line 1188 "string.c"
		{
			gboolean _tmp1_ = FALSE;
#line 185 "../src/util/string.vala"
			_tmp1_ = TRUE;
#line 185 "../src/util/string.vala"
			while (TRUE) {
#line 1195 "string.c"
				const gchar* _tmp4_;
				gunichar ch = 0U;
				const gchar* _tmp5_;
				gboolean _tmp6_ = FALSE;
#line 185 "../src/util/string.vala"
				if (!_tmp1_) {
#line 1202 "string.c"
					const gchar* _tmp2_;
					const gchar* _tmp3_;
#line 185 "../src/util/string.vala"
					_tmp2_ = iter;
#line 185 "../src/util/string.vala"
					_tmp3_ = g_utf8_next_char (_tmp2_);
#line 185 "../src/util/string.vala"
					iter = _tmp3_;
#line 1211 "string.c"
				}
#line 185 "../src/util/string.vala"
				_tmp1_ = FALSE;
#line 185 "../src/util/string.vala"
				_tmp4_ = iter;
#line 185 "../src/util/string.vala"
				if (!(string_get_char (_tmp4_, (glong) 0) != ((gunichar) 0))) {
#line 185 "../src/util/string.vala"
					break;
#line 1221 "string.c"
				}
#line 186 "../src/util/string.vala"
				_tmp5_ = iter;
#line 186 "../src/util/string.vala"
				ch = string_get_char (_tmp5_, (glong) 0);
#line 188 "../src/util/string.vala"
				if (!prev_is_space) {
#line 188 "../src/util/string.vala"
					_tmp6_ = TRUE;
#line 1231 "string.c"
				} else {
#line 188 "../src/util/string.vala"
					_tmp6_ = ch != ((gunichar) '0');
#line 1235 "string.c"
				}
#line 188 "../src/util/string.vala"
				if (_tmp6_) {
#line 1239 "string.c"
					GString* _tmp7_;
#line 189 "../src/util/string.vala"
					_tmp7_ = stripped;
#line 189 "../src/util/string.vala"
					g_string_append_unichar (_tmp7_, ch);
#line 190 "../src/util/string.vala"
					prev_is_space = g_unichar_isspace (ch);
#line 1247 "string.c"
				}
			}
		}
	}
#line 194 "../src/util/string.vala"
	_tmp8_ = stripped;
#line 194 "../src/util/string.vala"
	_tmp9_ = _tmp8_->str;
#line 194 "../src/util/string.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 194 "../src/util/string.vala"
	result = _tmp10_;
#line 194 "../src/util/string.vala"
	_g_string_free0 (stripped);
#line 194 "../src/util/string.vala"
	return result;
#line 1264 "string.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
#line 1199 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1200 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1201 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 1280 "string.c"
		gchar* _tmp0_;
#line 1202 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1202 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1203 "glib-2.0.vapi"
		result = TRUE;
#line 1203 "glib-2.0.vapi"
		if (c) {
#line 1203 "glib-2.0.vapi"
			*c = _vala_c;
#line 1292 "string.c"
		}
#line 1203 "glib-2.0.vapi"
		return result;
#line 1296 "string.c"
	} else {
#line 1205 "glib-2.0.vapi"
		result = FALSE;
#line 1205 "glib-2.0.vapi"
		if (c) {
#line 1205 "glib-2.0.vapi"
			*c = _vala_c;
#line 1304 "string.c"
		}
#line 1205 "glib-2.0.vapi"
		return result;
#line 1308 "string.c"
	}
#line 1199 "glib-2.0.vapi"
	if (c) {
#line 1199 "glib-2.0.vapi"
		*c = _vala_c;
#line 1314 "string.c"
	}
}

gchar*
string_remove_diacritics (const gchar* istring)
{
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
	gunichar ch = 0U;
	gint i = 0;
	GString* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
#line 197 "../src/util/string.vala"
	g_return_val_if_fail (istring != NULL, NULL);
#line 198 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 198 "../src/util/string.vala"
	builder = _tmp0_;
#line 200 "../src/util/string.vala"
	i = 0;
#line 201 "../src/util/string.vala"
	while (TRUE) {
#line 1339 "string.c"
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_;
		GString* _tmp3_;
#line 201 "../src/util/string.vala"
		_tmp2_ = string_get_next_char (istring, &i, &_tmp1_);
#line 201 "../src/util/string.vala"
		ch = _tmp1_;
#line 201 "../src/util/string.vala"
		if (!_tmp2_) {
#line 201 "../src/util/string.vala"
			break;
#line 1351 "string.c"
		}
#line 202 "../src/util/string.vala"
		switch (g_unichar_type (ch)) {
#line 202 "../src/util/string.vala"
			case G_UNICODE_CONTROL:
#line 202 "../src/util/string.vala"
			case G_UNICODE_FORMAT:
#line 202 "../src/util/string.vala"
			case G_UNICODE_UNASSIGNED:
#line 202 "../src/util/string.vala"
			case G_UNICODE_NON_SPACING_MARK:
#line 202 "../src/util/string.vala"
			case G_UNICODE_COMBINING_MARK:
#line 202 "../src/util/string.vala"
			case G_UNICODE_ENCLOSING_MARK:
#line 1367 "string.c"
			{
#line 210 "../src/util/string.vala"
				continue;
#line 1371 "string.c"
			}
			default:
#line 202 "../src/util/string.vala"
			break;
#line 1376 "string.c"
		}
#line 212 "../src/util/string.vala"
		_tmp3_ = builder;
#line 212 "../src/util/string.vala"
		g_string_append_unichar (_tmp3_, ch);
#line 1382 "string.c"
	}
#line 214 "../src/util/string.vala"
	_tmp4_ = builder;
#line 214 "../src/util/string.vala"
	_tmp5_ = _tmp4_->str;
#line 214 "../src/util/string.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 214 "../src/util/string.vala"
	result = _tmp6_;
#line 214 "../src/util/string.vala"
	_g_string_free0 (builder);
#line 214 "../src/util/string.vala"
	return result;
#line 1396 "string.c"
}

gchar*
string_to_hex_string (const gchar* str)
{
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_;
	guint8* data = NULL;
	GString* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
#line 217 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 218 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 218 "../src/util/string.vala"
	builder = _tmp0_;
#line 220 "../src/util/string.vala"
	data = (guint8*) str;
#line 221 "../src/util/string.vala"
	while (TRUE) {
#line 1419 "string.c"
		guint8* _tmp1_;
		const gchar* _tmp2_ = NULL;
		guint8* _tmp3_;
		GString* _tmp4_;
		guint8* _tmp5_;
#line 221 "../src/util/string.vala"
		_tmp1_ = data;
#line 221 "../src/util/string.vala"
		if (!(((gint) (*_tmp1_)) != 0)) {
#line 221 "../src/util/string.vala"
			break;
#line 1431 "string.c"
		}
#line 222 "../src/util/string.vala"
		_tmp3_ = data;
#line 222 "../src/util/string.vala"
		if (((gint) (*_tmp3_)) != 0) {
#line 222 "../src/util/string.vala"
			_tmp2_ = " ";
#line 1439 "string.c"
		} else {
#line 222 "../src/util/string.vala"
			_tmp2_ = "";
#line 1443 "string.c"
		}
#line 222 "../src/util/string.vala"
		_tmp4_ = builder;
#line 222 "../src/util/string.vala"
		_tmp5_ = data;
#line 222 "../src/util/string.vala"
		data = _tmp5_ + 1;
#line 222 "../src/util/string.vala"
		g_string_append_printf (_tmp4_, "%02Xh%s", (guint) (*_tmp5_), _tmp2_);
#line 1453 "string.c"
	}
#line 224 "../src/util/string.vala"
	_tmp6_ = builder;
#line 224 "../src/util/string.vala"
	_tmp7_ = _tmp6_->str;
#line 224 "../src/util/string.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 224 "../src/util/string.vala"
	result = _tmp8_;
#line 224 "../src/util/string.vala"
	_g_string_free0 (builder);
#line 224 "../src/util/string.vala"
	return result;
#line 1467 "string.c"
}

guint
string_collated_hash (void* ptr)
{
	guint result = 0U;
	gchar* str = NULL;
	gchar* _tmp0_;
	GHashFunc _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint _tmp4_;
#line 244 "../src/util/string.vala"
	_tmp0_ = g_strdup ((const gchar*) ptr);
#line 244 "../src/util/string.vala"
	str = _tmp0_;
#line 246 "../src/util/string.vala"
	_tmp1_ = g_str_hash;
#line 246 "../src/util/string.vala"
	_tmp2_ = g_utf8_collate_key (str, (gssize) -1);
#line 246 "../src/util/string.vala"
	_tmp3_ = _tmp2_;
#line 246 "../src/util/string.vala"
	_tmp4_ = _tmp1_ (_tmp3_);
#line 246 "../src/util/string.vala"
	_g_free0 (_tmp3_);
#line 246 "../src/util/string.vala"
	result = _tmp4_;
#line 246 "../src/util/string.vala"
	_g_free0 (str);
#line 246 "../src/util/string.vala"
	return result;
#line 1500 "string.c"
}

guint
string_precollated_hash (void* ptr)
{
	guint result = 0U;
	GHashFunc _tmp0_;
#line 251 "../src/util/string.vala"
	_tmp0_ = g_str_hash;
#line 251 "../src/util/string.vala"
	result = _tmp0_ ((const gchar*) ptr);
#line 251 "../src/util/string.vala"
	return result;
#line 1514 "string.c"
}

gint
string_collated_compare (void* a,
                         void* b)
{
	gint result = 0;
	gchar* astr = NULL;
	gchar* _tmp0_;
	gchar* bstr = NULL;
	gchar* _tmp1_;
	gint _result_ = 0;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_ = 0;
#line 256 "../src/util/string.vala"
	_tmp0_ = g_strdup ((const gchar*) a);
#line 256 "../src/util/string.vala"
	astr = _tmp0_;
#line 257 "../src/util/string.vala"
	_tmp1_ = g_strdup ((const gchar*) b);
#line 257 "../src/util/string.vala"
	bstr = _tmp1_;
#line 259 "../src/util/string.vala"
	_tmp2_ = astr;
#line 259 "../src/util/string.vala"
	_tmp3_ = bstr;
#line 259 "../src/util/string.vala"
	_result_ = g_utf8_collate (_tmp2_, _tmp3_);
#line 261 "../src/util/string.vala"
	if (_result_ != 0) {
#line 261 "../src/util/string.vala"
		_tmp4_ = _result_;
#line 1548 "string.c"
	} else {
		GCompareFunc _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 261 "../src/util/string.vala"
		_tmp5_ = ((GCompareFunc) g_strcmp0);
#line 261 "../src/util/string.vala"
		_tmp6_ = astr;
#line 261 "../src/util/string.vala"
		_tmp7_ = bstr;
#line 261 "../src/util/string.vala"
		_tmp4_ = _tmp5_ (_tmp6_, _tmp7_);
#line 1561 "string.c"
	}
#line 261 "../src/util/string.vala"
	result = _tmp4_;
#line 261 "../src/util/string.vala"
	_g_free0 (bstr);
#line 261 "../src/util/string.vala"
	_g_free0 (astr);
#line 261 "../src/util/string.vala"
	return result;
#line 1571 "string.c"
}

gint
string_precollated_compare (const gchar* astr,
                            const gchar* akey,
                            const gchar* bstr,
                            const gchar* bkey)
{
	gint result = 0;
	gint _result_ = 0;
	GCompareFunc _tmp0_;
	gint _tmp1_ = 0;
#line 265 "../src/util/string.vala"
	g_return_val_if_fail (astr != NULL, 0);
#line 265 "../src/util/string.vala"
	g_return_val_if_fail (akey != NULL, 0);
#line 265 "../src/util/string.vala"
	g_return_val_if_fail (bstr != NULL, 0);
#line 265 "../src/util/string.vala"
	g_return_val_if_fail (bkey != NULL, 0);
#line 266 "../src/util/string.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 266 "../src/util/string.vala"
	_result_ = _tmp0_ (akey, bkey);
#line 268 "../src/util/string.vala"
	if (_result_ != 0) {
#line 268 "../src/util/string.vala"
		_tmp1_ = _result_;
#line 1600 "string.c"
	} else {
		GCompareFunc _tmp2_;
#line 268 "../src/util/string.vala"
		_tmp2_ = ((GCompareFunc) g_strcmp0);
#line 268 "../src/util/string.vala"
		_tmp1_ = _tmp2_ (astr, bstr);
#line 1607 "string.c"
	}
#line 268 "../src/util/string.vala"
	result = _tmp1_;
#line 268 "../src/util/string.vala"
	return result;
#line 1613 "string.c"
}

gboolean
string_collated_equals (void* a,
                        void* b)
{
	gboolean result = FALSE;
#line 273 "../src/util/string.vala"
	result = string_collated_compare (a, b) == 0;
#line 273 "../src/util/string.vala"
	return result;
#line 1625 "string.c"
}

gboolean
string_precollated_equals (const gchar* astr,
                           const gchar* akey,
                           const gchar* bstr,
                           const gchar* bkey)
{
	gboolean result = FALSE;
#line 277 "../src/util/string.vala"
	g_return_val_if_fail (astr != NULL, FALSE);
#line 277 "../src/util/string.vala"
	g_return_val_if_fail (akey != NULL, FALSE);
#line 277 "../src/util/string.vala"
	g_return_val_if_fail (bstr != NULL, FALSE);
#line 277 "../src/util/string.vala"
	g_return_val_if_fail (bkey != NULL, FALSE);
#line 278 "../src/util/string.vala"
	result = string_precollated_compare (astr, akey, bstr, bkey) == 0;
#line 278 "../src/util/string.vala"
	return result;
#line 1647 "string.c"
}

