/* PhotoMetadata.c generated by valac 0.44.0, the Vala compiler
 * generated from PhotoMetadata.vala, do not modify */

/*
* Copyright (c) 2010-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/**/
/* PhotoMetadata*/
/**/
/* PhotoMetadata is a wrapper class around gexiv2.  The reasoning for this is (a) to facilitiate*/
/* interface changes to meet Photos' requirements without needing modifications of the library*/
/* itself, and (b) some requirements for this class (i.e. obtaining raw metadata) is not available*/
/* in gexiv2, and so must be done by hand.*/
/**/
/* Although it's perceived that Exiv2 will remain Photos' metadata library of choice, this*/
/* may change in the future, and so this wrapper helps with that as well.*/
/**/
/* There is no expectation of thread-safety in this class (yet).*/
/**/
/* Tags come from Exiv2's naming scheme:*/
/* http://www.exiv2.org/metadata.html*/
/**/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <gexiv2/gexiv2.h>
#include <libexif/exif-data.h>
#include <gee.h>
#include <libexif/exif-mem.h>
#include <float.h>
#include <math.h>

typedef enum  {
	METADATA_DOMAIN_UNKNOWN,
	METADATA_DOMAIN_EXIF,
	METADATA_DOMAIN_XMP,
	METADATA_DOMAIN_IPTC
} MetadataDomain;

#define TYPE_METADATA_DOMAIN (metadata_domain_get_type ())

#define TYPE_HIERARCHICAL_KEYWORD_FIELD (hierarchical_keyword_field_get_type ())
#define HIERARCHICAL_KEYWORD_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordField))
#define HIERARCHICAL_KEYWORD_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordFieldClass))
#define IS_HIERARCHICAL_KEYWORD_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD))
#define IS_HIERARCHICAL_KEYWORD_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_KEYWORD_FIELD))
#define HIERARCHICAL_KEYWORD_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordFieldClass))

typedef struct _HierarchicalKeywordField HierarchicalKeywordField;
typedef struct _HierarchicalKeywordFieldClass HierarchicalKeywordFieldClass;
typedef struct _HierarchicalKeywordFieldPrivate HierarchicalKeywordFieldPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecHierarchicalKeywordField ParamSpecHierarchicalKeywordField;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
typedef struct _PhotoPreviewPrivate PhotoPreviewPrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecPhotoPreview ParamSpecPhotoPreview;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;
typedef struct _MediaMetadataPrivate MediaMetadataPrivate;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
typedef struct _PhotoMetadataPrivate PhotoMetadataPrivate;
typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))
typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())
typedef void (*PhotoMetadataSetGenericValue) (const gchar* tag, gpointer user_data);
typedef struct _Block3Data Block3Data;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;

#define TYPE_METADATA_RATIONAL (metadata_rational_get_type ())
typedef struct _MetadataRational MetadataRational;
typedef struct _Block6Data Block6Data;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
#define _exif_mem_unref0(var) ((var == NULL) ? NULL : (var = (exif_mem_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW (photo_metadata_internal_photo_preview_get_type ())
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))

typedef struct _PhotoMetadataInternalPhotoPreview PhotoMetadataInternalPhotoPreview;
typedef struct _PhotoMetadataInternalPhotoPreviewClass PhotoMetadataInternalPhotoPreviewClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_keyword_field_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_keyword_field_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

#define TYPE_ORIENTATION (orientation_get_type ())
typedef struct _PhotoMetadataInternalPhotoPreviewPrivate PhotoMetadataInternalPhotoPreviewPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _HierarchicalKeywordField {
	GTypeInstance parent_instance;
	volatile int ref_count;
	HierarchicalKeywordFieldPrivate * priv;
	gchar* field_name;
	gchar* path_separator;
	gboolean wants_leading_separator;
	gboolean is_writeable;
};

struct _HierarchicalKeywordFieldClass {
	GTypeClass parent_class;
	void (*finalize) (HierarchicalKeywordField *self);
};

struct _ParamSpecHierarchicalKeywordField {
	GParamSpec parent_instance;
};

struct _PhotoPreview {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoPreviewPrivate * priv;
};

struct _PhotoPreviewClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoPreview *self);
	guint8* (*flatten) (PhotoPreview* self, gint* result_length1, GError** error);
	GdkPixbuf* (*get_pixbuf) (PhotoPreview* self, GError** error);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _PhotoPreviewPrivate {
	gchar* name;
	Dimensions dimensions;
	guint32 size;
	gchar* mime_type;
	gchar* extension;
};

struct _ParamSpecPhotoPreview {
	GParamSpec parent_instance;
};

struct _MediaMetadata {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MediaMetadataPrivate * priv;
};

struct _MediaMetadataClass {
	GTypeClass parent_class;
	void (*finalize) (MediaMetadata *self);
	void (*read_from_file) (MediaMetadata* self, GFile* file, GError** error);
	MetadataDateTime* (*get_creation_date_time) (MediaMetadata* self);
	gchar* (*get_title) (MediaMetadata* self);
	gchar* (*get_comment) (MediaMetadata* self);
};

struct _PhotoMetadata {
	MediaMetadata parent_instance;
	PhotoMetadataPrivate * priv;
};

struct _PhotoMetadataClass {
	MediaMetadataClass parent_class;
};

struct _PhotoMetadataPrivate {
	GExiv2Metadata* exiv2;
	ExifData* exif;
	gchar* source_name;
};

struct _Block3Data {
	int _ref_count_;
	PhotoMetadata* self;
	gchar* value;
};

struct _Block4Data {
	int _ref_count_;
	PhotoMetadata* self;
	GeeCollection* values;
};

struct _Block5Data {
	int _ref_count_;
	PhotoMetadata* self;
	glong value;
};

struct _MetadataRational {
	gint numerator;
	gint denominator;
};

struct _Block6Data {
	int _ref_count_;
	PhotoMetadata* self;
	MetadataRational rational;
};

typedef enum  {
	METADATA_DATE_TIME_ERROR_INVALID_FORMAT,
	METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT
} MetadataDateTimeError;
#define METADATA_DATE_TIME_ERROR metadata_date_time_error_quark ()
struct _Block7Data {
	int _ref_count_;
	PhotoMetadata* self;
	MetadataDateTime* date_time;
};

struct _PhotoMetadataInternalPhotoPreview {
	PhotoPreview parent_instance;
	PhotoMetadataInternalPhotoPreviewPrivate * priv;
	PhotoMetadata* owner;
	guint number;
};

struct _PhotoMetadataInternalPhotoPreviewClass {
	PhotoPreviewClass parent_class;
};

static gpointer hierarchical_keyword_field_parent_class = NULL;
static gint PhotoPreview_private_offset;
static gpointer photo_preview_parent_class = NULL;
static gint PhotoMetadata_private_offset;
static gpointer photo_metadata_parent_class = NULL;
static gchar** photo_metadata_DATE_TIME_TAGS;
static gint photo_metadata_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS = NULL;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_EXPOSURE_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DIGITIZED_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_WIDTH_TAGS;
static gint photo_metadata_WIDTH_TAGS_length1;
static gchar** photo_metadata_WIDTH_TAGS = NULL;
static gint photo_metadata_WIDTH_TAGS_length1 = 0;
static gint _photo_metadata_WIDTH_TAGS_size_ = 0;
extern gchar** photo_metadata_HEIGHT_TAGS;
extern gint photo_metadata_HEIGHT_TAGS_length1;
gchar** photo_metadata_HEIGHT_TAGS = NULL;
gint photo_metadata_HEIGHT_TAGS_length1 = 0;
static gchar** photo_metadata_STANDARD_TITLE_TAGS;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1;
static gchar** photo_metadata_STANDARD_TITLE_TAGS = NULL;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1 = 0;
static gint _photo_metadata_STANDARD_TITLE_TAGS_size_ = 0;
static gchar** photo_metadata_KEYWORD_TAGS;
static gint photo_metadata_KEYWORD_TAGS_length1;
static gchar** photo_metadata_KEYWORD_TAGS = NULL;
static gint photo_metadata_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_KEYWORD_TAGS_size_ = 0;
static HierarchicalKeywordField** photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
static HierarchicalKeywordField** photo_metadata_HIERARCHICAL_KEYWORD_TAGS = NULL;
static gint photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_HIERARCHICAL_KEYWORD_TAGS_size_ = 0;
static gchar** photo_metadata_ARTIST_TAGS;
static gint photo_metadata_ARTIST_TAGS_length1;
static gchar** photo_metadata_ARTIST_TAGS = NULL;
static gint photo_metadata_ARTIST_TAGS_length1 = 0;
static gint _photo_metadata_ARTIST_TAGS_size_ = 0;
static gpointer photo_metadata_internal_photo_preview_parent_class = NULL;

GType metadata_domain_get_type (void) G_GNUC_CONST;
gpointer hierarchical_keyword_field_ref (gpointer instance);
void hierarchical_keyword_field_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_keyword_field (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
void value_set_hierarchical_keyword_field (GValue* value,
                                           gpointer v_object);
void value_take_hierarchical_keyword_field (GValue* value,
                                            gpointer v_object);
gpointer value_get_hierarchical_keyword_field (const GValue* value);
GType hierarchical_keyword_field_get_type (void) G_GNUC_CONST;
HierarchicalKeywordField* hierarchical_keyword_field_new (const gchar* field_name,
                                                          const gchar* path_separator,
                                                          gboolean wants_leading_separator,
                                                          gboolean is_writeable);
HierarchicalKeywordField* hierarchical_keyword_field_construct (GType object_type,
                                                                const gchar* field_name,
                                                                const gchar* path_separator,
                                                                gboolean wants_leading_separator,
                                                                gboolean is_writeable);
static void hierarchical_keyword_field_finalize (HierarchicalKeywordField * obj);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_photo_preview (GValue* value,
                              gpointer v_object);
void value_take_photo_preview (GValue* value,
                               gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
PhotoPreview* photo_preview_construct (GType object_type,
                                       const gchar* name,
                                       Dimensions* dimensions,
                                       guint32 size,
                                       const gchar* mime_type,
                                       const gchar* extension);
gchar* photo_preview_get_name (PhotoPreview* self);
void photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                         Dimensions* result);
guint32 photo_preview_get_size (PhotoPreview* self);
gchar* photo_preview_get_mime_type (PhotoPreview* self);
gchar* photo_preview_get_extension (PhotoPreview* self);
guint8* photo_preview_flatten (PhotoPreview* self,
                               gint* result_length1,
                               GError** error);
static guint8* photo_preview_real_flatten (PhotoPreview* self,
                                    gint* result_length1,
                                    GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self,
                                     GError** error);
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self,
                                          GError** error);
static guint8* _vala_array_dup19 (guint8* self,
                           int length);
static void photo_preview_finalize (PhotoPreview * obj);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_media_metadata (GValue* value,
                               gpointer v_object);
void value_take_media_metadata (GValue* value,
                                gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_metadata_date_time (GValue* value,
                                   gpointer v_object);
void value_take_metadata_date_time (GValue* value,
                                    gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
GType prepare_input_text_options_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_PREPARE_STRING_OPTIONS (((((PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE)
#define PHOTO_METADATA_IPHOTO_TITLE_TAG "Iptc.Application2.ObjectName"
PhotoMetadata* photo_metadata_new (void);
PhotoMetadata* photo_metadata_construct (GType object_type);
MediaMetadata* media_metadata_construct (GType object_type);
static void photo_metadata_real_read_from_file (MediaMetadata* base,
                                         GFile* file,
                                         GError** error);
void photo_metadata_write_to_file (PhotoMetadata* self,
                                   GFile* file,
                                   GError** error);
void photo_metadata_read_from_buffer (PhotoMetadata* self,
                                      guint8* buffer,
                                      gint buffer_length1,
                                      gint length,
                                      GError** error);
void photo_metadata_read_from_app1_segment (PhotoMetadata* self,
                                            guint8* buffer,
                                            gint buffer_length1,
                                            gint length,
                                            GError** error);
MetadataDomain photo_metadata_get_tag_domain (const gchar* tag);
gboolean photo_metadata_has_domain (PhotoMetadata* self,
                                    MetadataDomain domain);
gboolean photo_metadata_has_exif (PhotoMetadata* self);
gboolean photo_metadata_has_xmp (PhotoMetadata* self);
gboolean photo_metadata_has_iptc (PhotoMetadata* self);
gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self,
                                             MetadataDomain domain);
gboolean photo_metadata_can_write_exif (PhotoMetadata* self);
gboolean photo_metadata_can_write_xmp (PhotoMetadata* self);
gboolean photo_metadata_can_write_iptc (PhotoMetadata* self);
gboolean photo_metadata_has_tag (PhotoMetadata* self,
                                 const gchar* tag);
static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self,
                                          GCompareDataFunc compare_func,
                                          gpointer compare_func_target,
                                          GDestroyNotify compare_func_target_destroy_notify);
GeeCollection* photo_metadata_get_tags (PhotoMetadata* self,
                                        MetadataDomain domain,
                                        GCompareDataFunc compare_func,
                                        gpointer compare_func_target,
                                        GDestroyNotify compare_func_target_destroy_notify);
GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self,
                                            GCompareDataFunc compare_func,
                                            gpointer compare_func_target,
                                            GDestroyNotify compare_func_target_destroy_notify);
gchar* photo_metadata_get_tag_label (PhotoMetadata* self,
                                     const gchar* tag);
gchar* photo_metadata_get_tag_description (PhotoMetadata* self,
                                           const gchar* tag);
gchar* photo_metadata_get_string (PhotoMetadata* self,
                                  const gchar* tag,
                                  PrepareInputTextOptions options);
gchar* prepare_input_text (const gchar* text,
                           PrepareInputTextOptions options,
                           gint dest_length);
#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
gchar* photo_metadata_get_string_interpreted (PhotoMetadata* self,
                                              const gchar* tag,
                                              PrepareInputTextOptions options);
gchar* photo_metadata_get_first_string (PhotoMetadata* self,
                                        gchar** tags,
                                        gint tags_length1);
gchar* photo_metadata_get_first_string_interpreted (PhotoMetadata* self,
                                                    gchar** tags,
                                                    gint tags_length1);
GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self,
                                             const gchar* tag);
GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self,
                                                   gchar** tags,
                                                   gint tags_length1);
void photo_metadata_set_string (PhotoMetadata* self,
                                const gchar* tag,
                                const gchar* value,
                                PrepareInputTextOptions options);
static void photo_metadata_set_all_generic (PhotoMetadata* self,
                                     gchar** tags,
                                     gint tags_length1,
                                     PhotoMetadataSetOption option,
                                     PhotoMetadataSetGenericValue setter,
                                     gpointer setter_target);
void photo_metadata_set_all_string (PhotoMetadata* self,
                                    gchar** tags,
                                    gint tags_length1,
                                    const gchar* value,
                                    PhotoMetadataSetOption option);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda4_ (Block3Data* _data3_,
                 const gchar* tag);
static void ___lambda4__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
void photo_metadata_set_string_multiple (PhotoMetadata* self,
                                         const gchar* tag,
                                         GeeCollection* collection);
static void _vala_array_add95 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
static void _vala_array_add96 (gchar** * array,
                        int* length,
                        int* size,
                        gchar* value);
void photo_metadata_set_all_string_multiple (PhotoMetadata* self,
                                             gchar** tags,
                                             gint tags_length1,
                                             GeeCollection* values,
                                             PhotoMetadataSetOption option);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda5_ (Block4Data* _data4_,
                 const gchar* tag);
static void ___lambda5__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
gboolean photo_metadata_get_long (PhotoMetadata* self,
                                  const gchar* tag,
                                  glong* value);
gboolean photo_metadata_get_first_long (PhotoMetadata* self,
                                        gchar** tags,
                                        gint tags_length1,
                                        glong* value);
void photo_metadata_set_long (PhotoMetadata* self,
                              const gchar* tag,
                              glong value);
void photo_metadata_set_all_long (PhotoMetadata* self,
                                  gchar** tags,
                                  gint tags_length1,
                                  glong value,
                                  PhotoMetadataSetOption option);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda6_ (Block5Data* _data5_,
                 const gchar* tag);
static void ___lambda6__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
GType metadata_rational_get_type (void) G_GNUC_CONST;
MetadataRational* metadata_rational_dup (const MetadataRational* self);
void metadata_rational_free (MetadataRational* self);
gboolean photo_metadata_get_rational (PhotoMetadata* self,
                                      const gchar* tag,
                                      MetadataRational* rational);
void metadata_rational_init (MetadataRational *self,
                             gint numerator,
                             gint denominator);
gboolean photo_metadata_get_first_rational (PhotoMetadata* self,
                                            gchar** tags,
                                            gint tags_length1,
                                            MetadataRational* rational);
void photo_metadata_set_rational (PhotoMetadata* self,
                                  const gchar* tag,
                                  MetadataRational* rational);
gchar* metadata_rational_to_string (MetadataRational *self);
void photo_metadata_set_all_rational (PhotoMetadata* self,
                                      gchar** tags,
                                      gint tags_length1,
                                      MetadataRational* rational,
                                      PhotoMetadataSetOption option);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda7_ (Block6Data* _data6_,
                 const gchar* tag);
static void ___lambda7__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self,
                                                const gchar* tag);
GQuark metadata_date_time_error_quark (void);
MetadataDateTime* metadata_date_time_new_from_xmp (const gchar* label,
                                                   GError** error);
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type,
                                                         const gchar* label,
                                                         GError** error);
MetadataDateTime* metadata_date_time_new_from_exif (const gchar* label,
                                                    GError** error);
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type,
                                                          const gchar* label,
                                                          GError** error);
MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self,
                                                      gchar** tags,
                                                      gint tags_length1);
void photo_metadata_set_date_time (PhotoMetadata* self,
                                   const gchar* tag,
                                   MetadataDateTime* date_time);
gchar* metadata_date_time_get_exif_label (MetadataDateTime* self);
gchar* metadata_date_time_get_xmp_label (MetadataDateTime* self);
const gchar* metadata_domain_to_string (MetadataDomain self);
void photo_metadata_set_all_date_time (PhotoMetadata* self,
                                       gchar** tags,
                                       gint tags_length1,
                                       MetadataDateTime* date_time,
                                       PhotoMetadataSetOption option);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda8_ (Block7Data* _data7_,
                 const gchar* tag);
static void ___lambda8__photo_metadata_set_generic_value (const gchar* tag,
                                                   gpointer self);
guint8* photo_metadata_flatten_exif (PhotoMetadata* self,
                                     gboolean include_preview,
                                     gint* result_length1);
guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self,
                                             gint* result_length1);
static guint8* _vala_array_dup20 (guint8* self,
                           int length);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self,
                                          guint number);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner,
                                                                              const gchar* name,
                                                                              guint number,
                                                                              GExiv2PreviewProperties* props);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type,
                                                                                    PhotoMetadata* owner,
                                                                                    const gchar* name,
                                                                                    guint number,
                                                                                    GExiv2PreviewProperties* props);
static GType photo_metadata_internal_photo_preview_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_remove_tag (PhotoMetadata* self,
                                const gchar* tag);
void photo_metadata_remove_tags (PhotoMetadata* self,
                                 gchar** tags,
                                 gint tags_length1);
void photo_metadata_clear_domain (PhotoMetadata* self,
                                  MetadataDomain domain);
void photo_metadata_clear (PhotoMetadata* self);
MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self);
void photo_metadata_set_modification_date_time (PhotoMetadata* self,
                                                MetadataDateTime* date_time,
                                                PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                            MetadataDateTime* date_time,
                                            PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self);
void photo_metadata_set_digitized_date_time (PhotoMetadata* self,
                                             MetadataDateTime* date_time,
                                             PhotoMetadataSetOption option);
static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base);
Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                          Dimensions* dim,
                                          PhotoMetadataSetOption option);
static gchar* photo_metadata_real_get_title (MediaMetadata* base);
gboolean is_string_empty (const gchar* s);
void photo_metadata_set_title (PhotoMetadata* self,
                               const gchar* title,
                               PhotoMetadataSetOption option);
static gchar* photo_metadata_real_get_comment (MediaMetadata* base);
void photo_metadata_set_comment (PhotoMetadata* self,
                                 const gchar* comment);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self,
                                     GCompareDataFunc compare_func,
                                     gpointer compare_func_target,
                                     GDestroyNotify compare_func_target_destroy_notify);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value,
                                       gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value,
                                        gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
static void photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self,
                                                        HierarchicalTagIndex* index);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
#define TAG_PATH_SEPARATOR_STRING "/"
void photo_metadata_set_keywords (PhotoMetadata* self,
                                  GeeCollection* keywords,
                                  PhotoMetadataSetOption option);
HierarchicalTagIndex* hierarchical_tag_index_new (void);
HierarchicalTagIndex* hierarchical_tag_index_construct (GType object_type);
GeeList* hierarchical_tag_utilities_enumerate_path_components (const gchar* in_path);
void hierarchical_tag_index_add_path (HierarchicalTagIndex* self,
                                      const gchar* tag,
                                      const gchar* path);
GeeCollection* hierarchical_tag_index_get_all_tags (HierarchicalTagIndex* self);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
gchar* hierarchical_tag_utilities_canonicalize (const gchar* in_tag,
                                                const gchar* foreign_separator);
gboolean photo_metadata_has_orientation (PhotoMetadata* self);
GType orientation_get_type (void) G_GNUC_CONST;
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self,
                                     Orientation orientation);
gboolean photo_metadata_get_gps (PhotoMetadata* self,
                                 gdouble* longitude,
                                 gchar* * long_ref,
                                 gdouble* latitude,
                                 gchar* * lat_ref,
                                 gdouble* altitude);
gboolean photo_metadata_get_exposure (PhotoMetadata* self,
                                      MetadataRational* exposure);
gchar* photo_metadata_get_exposure_string (PhotoMetadata* self);
gboolean metadata_rational_is_valid (MetadataRational *self);
gboolean photo_metadata_get_iso (PhotoMetadata* self,
                                 glong* iso);
gchar* photo_metadata_get_iso_string (PhotoMetadata* self);
gboolean photo_metadata_get_aperture (PhotoMetadata* self,
                                      MetadataRational* aperture);
gchar* photo_metadata_get_aperture_string (PhotoMetadata* self,
                                           gboolean pango_formatted);
gchar* photo_metadata_get_camera_make (PhotoMetadata* self);
gchar* photo_metadata_get_camera_model (PhotoMetadata* self);
gboolean photo_metadata_get_flash (PhotoMetadata* self,
                                   glong* flash);
gchar* photo_metadata_get_flash_string (PhotoMetadata* self);
gboolean photo_metadata_get_focal_length (PhotoMetadata* self,
                                          MetadataRational* focal_length);
gchar* photo_metadata_get_focal_length_string (PhotoMetadata* self);
gchar* photo_metadata_get_artist (PhotoMetadata* self);
gchar* photo_metadata_get_copyright (PhotoMetadata* self);
gchar* photo_metadata_get_software (PhotoMetadata* self);
void photo_metadata_set_software (PhotoMetadata* self,
                                  const gchar* software,
                                  const gchar* version);
void photo_metadata_remove_software (PhotoMetadata* self);
gchar* photo_metadata_get_exposure_bias (PhotoMetadata* self);
static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base,
                                                            gint* result_length1,
                                                            GError** error);
static guint8* _vala_array_dup21 (guint8* self,
                           int length);
static void photo_metadata_internal_photo_preview_finalize (PhotoPreview * obj);
static void photo_metadata_finalize (MediaMetadata * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

GType
metadata_domain_get_type (void)
{
	static volatile gsize metadata_domain_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_domain_type_id__volatile)) {
		static const GEnumValue values[] = {{METADATA_DOMAIN_UNKNOWN, "METADATA_DOMAIN_UNKNOWN", "unknown"}, {METADATA_DOMAIN_EXIF, "METADATA_DOMAIN_EXIF", "exif"}, {METADATA_DOMAIN_XMP, "METADATA_DOMAIN_XMP", "xmp"}, {METADATA_DOMAIN_IPTC, "METADATA_DOMAIN_IPTC", "iptc"}, {0, NULL, NULL}};
		GType metadata_domain_type_id;
		metadata_domain_type_id = g_enum_register_static ("MetadataDomain", values);
		g_once_init_leave (&metadata_domain_type_id__volatile, metadata_domain_type_id);
	}
	return metadata_domain_type_id__volatile;
}

HierarchicalKeywordField*
hierarchical_keyword_field_construct (GType object_type,
                                      const gchar* field_name,
                                      const gchar* path_separator,
                                      gboolean wants_leading_separator,
                                      gboolean is_writeable)
{
	HierarchicalKeywordField* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 50 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (field_name != NULL, NULL);
#line 50 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (path_separator != NULL, NULL);
#line 50 "../src/photos/PhotoMetadata.vala"
	self = (HierarchicalKeywordField*) g_type_create_instance (object_type);
#line 52 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (field_name);
#line 52 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 52 "../src/photos/PhotoMetadata.vala"
	self->field_name = _tmp0_;
#line 53 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (path_separator);
#line 53 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 53 "../src/photos/PhotoMetadata.vala"
	self->path_separator = _tmp1_;
#line 54 "../src/photos/PhotoMetadata.vala"
	self->wants_leading_separator = wants_leading_separator;
#line 55 "../src/photos/PhotoMetadata.vala"
	self->is_writeable = is_writeable;
#line 50 "../src/photos/PhotoMetadata.vala"
	return self;
#line 863 "PhotoMetadata.c"
}

HierarchicalKeywordField*
hierarchical_keyword_field_new (const gchar* field_name,
                                const gchar* path_separator,
                                gboolean wants_leading_separator,
                                gboolean is_writeable)
{
#line 50 "../src/photos/PhotoMetadata.vala"
	return hierarchical_keyword_field_construct (TYPE_HIERARCHICAL_KEYWORD_FIELD, field_name, path_separator, wants_leading_separator, is_writeable);
#line 874 "PhotoMetadata.c"
}

static void
value_hierarchical_keyword_field_init (GValue* value)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 882 "PhotoMetadata.c"
}

static void
value_hierarchical_keyword_field_free_value (GValue* value)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 44 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (value->data[0].v_pointer);
#line 892 "PhotoMetadata.c"
	}
}

static void
value_hierarchical_keyword_field_copy_value (const GValue* src_value,
                                             GValue* dest_value)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 44 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = hierarchical_keyword_field_ref (src_value->data[0].v_pointer);
#line 904 "PhotoMetadata.c"
	} else {
#line 44 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 908 "PhotoMetadata.c"
	}
}

static gpointer
value_hierarchical_keyword_field_peek_pointer (const GValue* value)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 917 "PhotoMetadata.c"
}

static gchar*
value_hierarchical_keyword_field_collect_value (GValue* value,
                                                guint n_collect_values,
                                                GTypeCValue* collect_values,
                                                guint collect_flags)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 928 "PhotoMetadata.c"
		HierarchicalKeywordField * object;
		object = collect_values[0].v_pointer;
#line 44 "../src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 44 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 935 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 44 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 939 "PhotoMetadata.c"
		}
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = hierarchical_keyword_field_ref (object);
#line 943 "PhotoMetadata.c"
	} else {
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 947 "PhotoMetadata.c"
	}
#line 44 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 951 "PhotoMetadata.c"
}

static gchar*
value_hierarchical_keyword_field_lcopy_value (const GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	HierarchicalKeywordField ** object_p;
	object_p = collect_values[0].v_pointer;
#line 44 "../src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 44 "../src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 966 "PhotoMetadata.c"
	}
#line 44 "../src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 44 "../src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 972 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 44 "../src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 976 "PhotoMetadata.c"
	} else {
#line 44 "../src/photos/PhotoMetadata.vala"
		*object_p = hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 980 "PhotoMetadata.c"
	}
#line 44 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 984 "PhotoMetadata.c"
}

GParamSpec*
param_spec_hierarchical_keyword_field (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags)
{
	ParamSpecHierarchicalKeywordField* spec;
#line 44 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 44 "../src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 44 "../src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 44 "../src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 1003 "PhotoMetadata.c"
}

gpointer
value_get_hierarchical_keyword_field (const GValue* value)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD), NULL);
#line 44 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1013 "PhotoMetadata.c"
}

void
value_set_hierarchical_keyword_field (GValue* value,
                                      gpointer v_object)
{
	HierarchicalKeywordField * old;
#line 44 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 44 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 44 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 44 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_ref (value->data[0].v_pointer);
#line 1035 "PhotoMetadata.c"
	} else {
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1039 "PhotoMetadata.c"
	}
#line 44 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 44 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 1045 "PhotoMetadata.c"
	}
}

void
value_take_hierarchical_keyword_field (GValue* value,
                                       gpointer v_object)
{
	HierarchicalKeywordField * old;
#line 44 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 44 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 44 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_HIERARCHICAL_KEYWORD_FIELD));
#line 44 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 1066 "PhotoMetadata.c"
	} else {
#line 44 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1070 "PhotoMetadata.c"
	}
#line 44 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 44 "../src/photos/PhotoMetadata.vala"
		hierarchical_keyword_field_unref (old);
#line 1076 "PhotoMetadata.c"
	}
}

static void
hierarchical_keyword_field_class_init (HierarchicalKeywordFieldClass * klass,
                                       gpointer klass_data)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	hierarchical_keyword_field_parent_class = g_type_class_peek_parent (klass);
#line 44 "../src/photos/PhotoMetadata.vala"
	((HierarchicalKeywordFieldClass *) klass)->finalize = hierarchical_keyword_field_finalize;
#line 1088 "PhotoMetadata.c"
}

static void
hierarchical_keyword_field_instance_init (HierarchicalKeywordField * self,
                                          gpointer klass)
{
#line 44 "../src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 1097 "PhotoMetadata.c"
}

static void
hierarchical_keyword_field_finalize (HierarchicalKeywordField * obj)
{
	HierarchicalKeywordField * self;
#line 44 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HIERARCHICAL_KEYWORD_FIELD, HierarchicalKeywordField);
#line 44 "../src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 45 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->field_name);
#line 46 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->path_separator);
#line 1112 "PhotoMetadata.c"
}

GType
hierarchical_keyword_field_get_type (void)
{
	static volatile gsize hierarchical_keyword_field_type_id__volatile = 0;
	if (g_once_init_enter (&hierarchical_keyword_field_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_hierarchical_keyword_field_init, value_hierarchical_keyword_field_free_value, value_hierarchical_keyword_field_copy_value, value_hierarchical_keyword_field_peek_pointer, "p", value_hierarchical_keyword_field_collect_value, "p", value_hierarchical_keyword_field_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (HierarchicalKeywordFieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) hierarchical_keyword_field_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HierarchicalKeywordField), 0, (GInstanceInitFunc) hierarchical_keyword_field_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType hierarchical_keyword_field_type_id;
		hierarchical_keyword_field_type_id = g_type_register_fundamental (g_type_fundamental_next (), "HierarchicalKeywordField", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&hierarchical_keyword_field_type_id__volatile, hierarchical_keyword_field_type_id);
	}
	return hierarchical_keyword_field_type_id__volatile;
}

gpointer
hierarchical_keyword_field_ref (gpointer instance)
{
	HierarchicalKeywordField * self;
	self = instance;
#line 44 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 44 "../src/photos/PhotoMetadata.vala"
	return instance;
#line 1139 "PhotoMetadata.c"
}

void
hierarchical_keyword_field_unref (gpointer instance)
{
	HierarchicalKeywordField * self;
	self = instance;
#line 44 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 44 "../src/photos/PhotoMetadata.vala"
		HIERARCHICAL_KEYWORD_FIELD_GET_CLASS (self)->finalize (self);
#line 44 "../src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1153 "PhotoMetadata.c"
	}
}

static inline gpointer
photo_preview_get_instance_private (PhotoPreview* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoPreview_private_offset);
}

PhotoPreview*
photo_preview_construct (GType object_type,
                         const gchar* name,
                         Dimensions* dimensions,
                         guint32 size,
                         const gchar* mime_type,
                         const gchar* extension)
{
	PhotoPreview* self = NULL;
	gchar* _tmp0_;
	Dimensions _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 66 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 66 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (dimensions != NULL, NULL);
#line 66 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 66 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 66 "../src/photos/PhotoMetadata.vala"
	self = (PhotoPreview*) g_type_create_instance (object_type);
#line 67 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (name);
#line 67 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 67 "../src/photos/PhotoMetadata.vala"
	self->priv->name = _tmp0_;
#line 68 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = *dimensions;
#line 68 "../src/photos/PhotoMetadata.vala"
	self->priv->dimensions = _tmp1_;
#line 69 "../src/photos/PhotoMetadata.vala"
	self->priv->size = size;
#line 70 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup (mime_type);
#line 70 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 70 "../src/photos/PhotoMetadata.vala"
	self->priv->mime_type = _tmp2_;
#line 71 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup (extension);
#line 71 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 71 "../src/photos/PhotoMetadata.vala"
	self->priv->extension = _tmp3_;
#line 66 "../src/photos/PhotoMetadata.vala"
	return self;
#line 1212 "PhotoMetadata.c"
}

gchar*
photo_preview_get_name (PhotoPreview* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 74 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->name;
#line 75 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 75 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 75 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1231 "PhotoMetadata.c"
}

void
photo_preview_get_pixel_dimensions (PhotoPreview* self,
                                    Dimensions* result)
{
	Dimensions _tmp0_;
#line 78 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->dimensions;
#line 79 "../src/photos/PhotoMetadata.vala"
	*result = _tmp0_;
#line 79 "../src/photos/PhotoMetadata.vala"
	return;
#line 1247 "PhotoMetadata.c"
}

guint32
photo_preview_get_size (PhotoPreview* self)
{
	guint32 result = 0U;
#line 82 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 83 "../src/photos/PhotoMetadata.vala"
	result = self->priv->size;
#line 83 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1260 "PhotoMetadata.c"
}

gchar*
photo_preview_get_mime_type (PhotoPreview* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 86 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 87 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->mime_type;
#line 87 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 87 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 87 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1279 "PhotoMetadata.c"
}

gchar*
photo_preview_get_extension (PhotoPreview* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 90 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->extension;
#line 91 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 91 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 91 "../src/photos/PhotoMetadata.vala"
	return result;
#line 1298 "PhotoMetadata.c"
}

static guint8*
photo_preview_real_flatten (PhotoPreview* self,
                            gint* result_length1,
                            GError** error)
{
#line 94 "../src/photos/PhotoMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_preview_flatten'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 94 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1310 "PhotoMetadata.c"
}

guint8*
photo_preview_flatten (PhotoPreview* self,
                       gint* result_length1,
                       GError** error)
{
#line 94 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../src/photos/PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->flatten (self, result_length1, error);
#line 1322 "PhotoMetadata.c"
}

static guint8*
_vala_array_dup19 (guint8* self,
                   int length)
{
#line 102 "../src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 1331 "PhotoMetadata.c"
}

static GdkPixbuf*
photo_preview_real_get_pixbuf (PhotoPreview* self,
                               GError** error)
{
	GdkPixbuf* result = NULL;
	guint8* flattened = NULL;
	gint _tmp0_ = 0;
	guint8* _tmp1_;
	gint flattened_length1;
	gint _flattened_size_;
	GError* _inner_error0_ = NULL;
#line 97 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_preview_flatten (self, &_tmp0_, &_inner_error0_);
#line 97 "../src/photos/PhotoMetadata.vala"
	flattened = _tmp1_;
#line 97 "../src/photos/PhotoMetadata.vala"
	flattened_length1 = _tmp0_;
#line 97 "../src/photos/PhotoMetadata.vala"
	_flattened_size_ = flattened_length1;
#line 97 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 97 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 97 "../src/photos/PhotoMetadata.vala"
		return NULL;
#line 1359 "PhotoMetadata.c"
	}
	{
		GdkPixbuf* _tmp2_ = NULL;
		guint8* _tmp3_;
		gint _tmp3__length1;
		GMemoryInputStream* _tmp4_;
		GMemoryInputStream* _tmp5_;
		GdkPixbuf* _tmp6_;
		GdkPixbuf* _tmp7_;
		GdkPixbuf* _tmp8_;
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = (flattened != NULL) ? _vala_array_dup19 (flattened, flattened_length1) : ((gpointer) flattened);
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp3__length1 = flattened_length1;
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp3_, _tmp3__length1, NULL);
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_;
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = gdk_pixbuf_new_from_stream ((GInputStream*) _tmp5_, NULL, &_inner_error0_);
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_;
#line 102 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp5_);
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = _tmp7_;
#line 102 "../src/photos/PhotoMetadata.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1388 "PhotoMetadata.c"
			goto __catch374_g_error;
		}
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = _tmp2_;
#line 102 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = NULL;
#line 102 "../src/photos/PhotoMetadata.vala"
		result = _tmp8_;
#line 102 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp2_);
#line 102 "../src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 102 "../src/photos/PhotoMetadata.vala"
		return result;
#line 1403 "PhotoMetadata.c"
	}
	goto __finally374;
	__catch374_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 101 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 101 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 105 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = self->priv->name;
#line 105 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = err;
#line 105 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = _tmp10_->message;
#line 105 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:105: Unable to decode thumbnail for %s: %s", _tmp9_, _tmp11_);
#line 107 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 107 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 107 "../src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 107 "../src/photos/PhotoMetadata.vala"
		return result;
#line 1432 "PhotoMetadata.c"
	}
	__finally374:
#line 101 "../src/photos/PhotoMetadata.vala"
	g_propagate_error (error, _inner_error0_);
#line 101 "../src/photos/PhotoMetadata.vala"
	flattened = (g_free (flattened), NULL);
#line 101 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1441 "PhotoMetadata.c"
}

GdkPixbuf*
photo_preview_get_pixbuf (PhotoPreview* self,
                          GError** error)
{
#line 96 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 96 "../src/photos/PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->get_pixbuf (self, error);
#line 1452 "PhotoMetadata.c"
}

static void
value_photo_preview_init (GValue* value)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 1460 "PhotoMetadata.c"
}

static void
value_photo_preview_free_value (GValue* value)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 59 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (value->data[0].v_pointer);
#line 1470 "PhotoMetadata.c"
	}
}

static void
value_photo_preview_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 59 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = photo_preview_ref (src_value->data[0].v_pointer);
#line 1482 "PhotoMetadata.c"
	} else {
#line 59 "../src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1486 "PhotoMetadata.c"
	}
}

static gpointer
value_photo_preview_peek_pointer (const GValue* value)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1495 "PhotoMetadata.c"
}

static gchar*
value_photo_preview_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 1506 "PhotoMetadata.c"
		PhotoPreview * object;
		object = collect_values[0].v_pointer;
#line 59 "../src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 59 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1513 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 59 "../src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1517 "PhotoMetadata.c"
		}
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = photo_preview_ref (object);
#line 1521 "PhotoMetadata.c"
	} else {
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1525 "PhotoMetadata.c"
	}
#line 59 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1529 "PhotoMetadata.c"
}

static gchar*
value_photo_preview_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	PhotoPreview ** object_p;
	object_p = collect_values[0].v_pointer;
#line 59 "../src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 59 "../src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1544 "PhotoMetadata.c"
	}
#line 59 "../src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 59 "../src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 1550 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 59 "../src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 1554 "PhotoMetadata.c"
	} else {
#line 59 "../src/photos/PhotoMetadata.vala"
		*object_p = photo_preview_ref (value->data[0].v_pointer);
#line 1558 "PhotoMetadata.c"
	}
#line 59 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 1562 "PhotoMetadata.c"
}

GParamSpec*
param_spec_photo_preview (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecPhotoPreview* spec;
#line 59 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_PREVIEW), NULL);
#line 59 "../src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 59 "../src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 59 "../src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 1581 "PhotoMetadata.c"
}

gpointer
value_get_photo_preview (const GValue* value)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW), NULL);
#line 59 "../src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 1591 "PhotoMetadata.c"
}

void
value_set_photo_preview (GValue* value,
                         gpointer v_object)
{
	PhotoPreview * old;
#line 59 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 59 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 59 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 59 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 59 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 59 "../src/photos/PhotoMetadata.vala"
		photo_preview_ref (value->data[0].v_pointer);
#line 1613 "PhotoMetadata.c"
	} else {
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1617 "PhotoMetadata.c"
	}
#line 59 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 59 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 1623 "PhotoMetadata.c"
	}
}

void
value_take_photo_preview (GValue* value,
                          gpointer v_object)
{
	PhotoPreview * old;
#line 59 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 59 "../src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 59 "../src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 59 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 59 "../src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 1644 "PhotoMetadata.c"
	} else {
#line 59 "../src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 1648 "PhotoMetadata.c"
	}
#line 59 "../src/photos/PhotoMetadata.vala"
	if (old) {
#line 59 "../src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 1654 "PhotoMetadata.c"
	}
}

static void
photo_preview_class_init (PhotoPreviewClass * klass,
                          gpointer klass_data)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 59 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->finalize = photo_preview_finalize;
#line 59 "../src/photos/PhotoMetadata.vala"
	g_type_class_adjust_private_offset (klass, &PhotoPreview_private_offset);
#line 59 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->flatten = (guint8* (*) (PhotoPreview*, gint*, GError**)) photo_preview_real_flatten;
#line 59 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->get_pixbuf = (GdkPixbuf* (*) (PhotoPreview*, GError**)) photo_preview_real_get_pixbuf;
#line 1672 "PhotoMetadata.c"
}

static void
photo_preview_instance_init (PhotoPreview * self,
                             gpointer klass)
{
#line 59 "../src/photos/PhotoMetadata.vala"
	self->priv = photo_preview_get_instance_private (self);
#line 59 "../src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 1683 "PhotoMetadata.c"
}

static void
photo_preview_finalize (PhotoPreview * obj)
{
	PhotoPreview * self;
#line 59 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_PREVIEW, PhotoPreview);
#line 59 "../src/photos/PhotoMetadata.vala"
	g_signal_handlers_destroy (self);
#line 60 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 63 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 64 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 1700 "PhotoMetadata.c"
}

GType
photo_preview_get_type (void)
{
	static volatile gsize photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_preview_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_preview_init, value_photo_preview_free_value, value_photo_preview_copy_value, value_photo_preview_peek_pointer, "p", value_photo_preview_collect_value, "p", value_photo_preview_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPreview), 0, (GInstanceInitFunc) photo_preview_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_preview_type_id;
		photo_preview_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoPreview", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		PhotoPreview_private_offset = g_type_add_instance_private (photo_preview_type_id, sizeof (PhotoPreviewPrivate));
		g_once_init_leave (&photo_preview_type_id__volatile, photo_preview_type_id);
	}
	return photo_preview_type_id__volatile;
}

gpointer
photo_preview_ref (gpointer instance)
{
	PhotoPreview * self;
	self = instance;
#line 59 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 59 "../src/photos/PhotoMetadata.vala"
	return instance;
#line 1728 "PhotoMetadata.c"
}

void
photo_preview_unref (gpointer instance)
{
	PhotoPreview * self;
	self = instance;
#line 59 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 59 "../src/photos/PhotoMetadata.vala"
		PHOTO_PREVIEW_GET_CLASS (self)->finalize (self);
#line 59 "../src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1742 "PhotoMetadata.c"
	}
}

static inline gpointer
photo_metadata_get_instance_private (PhotoMetadata* self)
{
	return G_STRUCT_MEMBER_P (self, PhotoMetadata_private_offset);
}

GType
photo_metadata_set_option_get_type (void)
{
	static volatile gsize photo_metadata_set_option_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_set_option_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_METADATA_SET_OPTION_ALL_DOMAINS, "PHOTO_METADATA_SET_OPTION_ALL_DOMAINS", "all-domains"}, {PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT, "PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT", "only-if-domain-present"}, {PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN, "PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN", "at-least-default-domain"}, {0, NULL, NULL}};
		GType photo_metadata_set_option_type_id;
		photo_metadata_set_option_type_id = g_enum_register_static ("PhotoMetadataSetOption", values);
		g_once_init_leave (&photo_metadata_set_option_type_id__volatile, photo_metadata_set_option_type_id);
	}
	return photo_metadata_set_option_type_id__volatile;
}

PhotoMetadata*
photo_metadata_construct (GType object_type)
{
	PhotoMetadata* self = NULL;
#line 152 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) media_metadata_construct (object_type);
#line 152 "../src/photos/PhotoMetadata.vala"
	return self;
#line 1773 "PhotoMetadata.c"
}

PhotoMetadata*
photo_metadata_new (void)
{
#line 152 "../src/photos/PhotoMetadata.vala"
	return photo_metadata_construct (TYPE_PHOTO_METADATA);
#line 1781 "PhotoMetadata.c"
}

static void
photo_metadata_real_read_from_file (MediaMetadata* base,
                                    GFile* file,
                                    GError** error)
{
	PhotoMetadata * self;
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	ExifData* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 155 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 155 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (file != NULL);
#line 156 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 156 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 156 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 157 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 157 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 159 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 159 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_file_get_path (file);
#line 159 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 159 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_path (_tmp1_, _tmp3_, &_inner_error0_);
#line 159 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 159 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 159 "../src/photos/PhotoMetadata.vala"
		return;
#line 1829 "PhotoMetadata.c"
	}
#line 160 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = g_file_get_path (file);
#line 160 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_;
#line 160 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = exif_data_new_from_file (_tmp5_);
#line 160 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 160 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp6_;
#line 160 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp5_);
#line 161 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = g_file_get_basename (file);
#line 161 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 161 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp7_;
#line 1849 "PhotoMetadata.c"
}

void
photo_metadata_write_to_file (PhotoMetadata* self,
                              GFile* file,
                              GError** error)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 164 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (file != NULL);
#line 165 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 165 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_file_get_path (file);
#line 165 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_;
#line 165 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_save_file (_tmp0_, _tmp2_, &_inner_error0_);
#line 165 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp2_);
#line 165 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 165 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 165 "../src/photos/PhotoMetadata.vala"
		return;
#line 1881 "PhotoMetadata.c"
	}
}

void
photo_metadata_read_from_buffer (PhotoMetadata* self,
                                 guint8* buffer,
                                 gint buffer_length1,
                                 gint length,
                                 GError** error)
{
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	ExifData* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 168 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/photos/PhotoMetadata.vala"
	if (length <= 0) {
#line 170 "../src/photos/PhotoMetadata.vala"
		length = buffer_length1;
#line 1903 "PhotoMetadata.c"
	}
#line 172 "../src/photos/PhotoMetadata.vala"
	_vala_assert (buffer_length1 >= length, "buffer.length >= length");
#line 174 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 174 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 174 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 175 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 175 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 178 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 178 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_buf (_tmp1_, buffer + 0, (glong) (length - 0), &_inner_error0_);
#line 178 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 178 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 178 "../src/photos/PhotoMetadata.vala"
		return;
#line 1927 "PhotoMetadata.c"
	}
#line 182 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = exif_data_new_from_data (buffer, (gsize) length);
#line 182 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 182 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp2_;
#line 183 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup_printf ("<memory buffer %d bytes>", length);
#line 183 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 183 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp3_;
#line 1941 "PhotoMetadata.c"
}

void
photo_metadata_read_from_app1_segment (PhotoMetadata* self,
                                       guint8* buffer,
                                       gint buffer_length1,
                                       gint length,
                                       GError** error)
{
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	ExifData* _tmp2_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 186 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/photos/PhotoMetadata.vala"
	if (length <= 0) {
#line 188 "../src/photos/PhotoMetadata.vala"
		length = buffer_length1;
#line 1962 "PhotoMetadata.c"
	}
#line 190 "../src/photos/PhotoMetadata.vala"
	_vala_assert (buffer_length1 >= length, "buffer.length >= length");
#line 192 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 192 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 192 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 193 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 193 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 196 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 196 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_from_app1_segment (_tmp1_, buffer + 0, (glong) (length - 0), &_inner_error0_);
#line 196 "../src/photos/PhotoMetadata.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 196 "../src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error0_);
#line 196 "../src/photos/PhotoMetadata.vala"
		return;
#line 1986 "PhotoMetadata.c"
	}
#line 200 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = exif_data_new_from_data (buffer, (gsize) length);
#line 200 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 200 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp2_;
#line 201 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_strdup_printf ("<app1 segment %d bytes>", length);
#line 201 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 201 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp3_;
#line 2000 "PhotoMetadata.c"
}

MetadataDomain
photo_metadata_get_tag_domain (const gchar* tag)
{
	MetadataDomain result = 0;
#line 204 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, 0);
#line 205 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_exif_tag (tag)) {
#line 206 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_EXIF;
#line 206 "../src/photos/PhotoMetadata.vala"
		return result;
#line 2015 "PhotoMetadata.c"
	}
#line 208 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_xmp_tag (tag)) {
#line 209 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_XMP;
#line 209 "../src/photos/PhotoMetadata.vala"
		return result;
#line 2023 "PhotoMetadata.c"
	}
#line 211 "../src/photos/PhotoMetadata.vala"
	if (gexiv2_metadata_is_iptc_tag (tag)) {
#line 212 "../src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_IPTC;
#line 212 "../src/photos/PhotoMetadata.vala"
		return result;
#line 2031 "PhotoMetadata.c"
	}
#line 214 "../src/photos/PhotoMetadata.vala"
	result = METADATA_DOMAIN_UNKNOWN;
#line 214 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2037 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_domain (PhotoMetadata* self,
                           MetadataDomain domain)
{
	gboolean result = FALSE;
#line 217 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 218 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 218 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 2051 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 220 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 220 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_exif (_tmp0_);
#line 220 "../src/photos/PhotoMetadata.vala"
			return result;
#line 2060 "PhotoMetadata.c"
		}
#line 218 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 2064 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 223 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 223 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_xmp (_tmp1_);
#line 223 "../src/photos/PhotoMetadata.vala"
			return result;
#line 2073 "PhotoMetadata.c"
		}
#line 218 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 2077 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 226 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 226 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_has_iptc (_tmp2_);
#line 226 "../src/photos/PhotoMetadata.vala"
			return result;
#line 2086 "PhotoMetadata.c"
		}
		default:
#line 218 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 2091 "PhotoMetadata.c"
		{
#line 230 "../src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 230 "../src/photos/PhotoMetadata.vala"
			return result;
#line 2097 "PhotoMetadata.c"
		}
	}
}

gboolean
photo_metadata_has_exif (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 234 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 235 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_EXIF);
#line 235 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2112 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_xmp (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 238 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 239 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_XMP);
#line 239 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2125 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_iptc (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 242 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 243 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_has_domain (self, METADATA_DOMAIN_IPTC);
#line 243 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2138 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_to_domain (PhotoMetadata* self,
                                    MetadataDomain domain)
{
	gboolean result = FALSE;
#line 246 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 247 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 247 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 2152 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 249 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 249 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_exif (_tmp0_);
#line 249 "../src/photos/PhotoMetadata.vala"
			return result;
#line 2161 "PhotoMetadata.c"
		}
#line 247 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 2165 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 252 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 252 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_xmp (_tmp1_);
#line 252 "../src/photos/PhotoMetadata.vala"
			return result;
#line 2174 "PhotoMetadata.c"
		}
#line 247 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 2178 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 255 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 255 "../src/photos/PhotoMetadata.vala"
			result = gexiv2_metadata_get_supports_iptc (_tmp2_);
#line 255 "../src/photos/PhotoMetadata.vala"
			return result;
#line 2187 "PhotoMetadata.c"
		}
		default:
#line 247 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 2192 "PhotoMetadata.c"
		{
#line 259 "../src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 259 "../src/photos/PhotoMetadata.vala"
			return result;
#line 2198 "PhotoMetadata.c"
		}
	}
}

gboolean
photo_metadata_can_write_exif (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 263 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 264 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_EXIF);
#line 264 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2213 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_xmp (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 267 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 268 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_XMP);
#line 268 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2226 "PhotoMetadata.c"
}

gboolean
photo_metadata_can_write_iptc (PhotoMetadata* self)
{
	gboolean result = FALSE;
#line 271 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 272 "../src/photos/PhotoMetadata.vala"
	result = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_IPTC);
#line 272 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2239 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_tag (PhotoMetadata* self,
                        const gchar* tag)
{
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_;
#line 275 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 275 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 276 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 276 "../src/photos/PhotoMetadata.vala"
	result = gexiv2_metadata_has_tag (_tmp0_, tag);
#line 276 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2258 "PhotoMetadata.c"
}

static GeeSet*
photo_metadata_create_string_set (PhotoMetadata* self,
                                  GCompareDataFunc compare_func,
                                  gpointer compare_func_target,
                                  GDestroyNotify compare_func_target_destroy_notify)
{
	GeeSet* result = NULL;
#line 279 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 281 "../src/photos/PhotoMetadata.vala"
	if (compare_func == NULL) {
#line 2272 "PhotoMetadata.c"
		GeeHashSet* _tmp0_;
#line 282 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 282 "../src/photos/PhotoMetadata.vala"
		result = (GeeSet*) _tmp0_;
#line 282 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 282 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 282 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 282 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 282 "../src/photos/PhotoMetadata.vala"
		return result;
#line 2288 "PhotoMetadata.c"
	} else {
		GCompareDataFunc _tmp1_;
		gpointer _tmp1__target;
		GDestroyNotify _tmp1__target_destroy_notify;
		GeeTreeSet* _tmp2_;
#line 284 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = compare_func;
#line 284 "../src/photos/PhotoMetadata.vala"
		_tmp1__target = compare_func_target;
#line 284 "../src/photos/PhotoMetadata.vala"
		_tmp1__target_destroy_notify = compare_func_target_destroy_notify;
#line 284 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 284 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 284 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 284 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify);
#line 284 "../src/photos/PhotoMetadata.vala"
		result = (GeeSet*) _tmp2_;
#line 284 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 284 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 284 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 284 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 284 "../src/photos/PhotoMetadata.vala"
		return result;
#line 2320 "PhotoMetadata.c"
	}
#line 279 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 279 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 279 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 279 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 2330 "PhotoMetadata.c"
}

GeeCollection*
photo_metadata_get_tags (PhotoMetadata* self,
                         MetadataDomain domain,
                         GCompareDataFunc compare_func,
                         gpointer compare_func_target,
                         GDestroyNotify compare_func_target_destroy_notify)
{
	GeeCollection* result = NULL;
	gchar** tags = NULL;
	gint tags_length1;
	gint _tags_size_;
	gboolean _tmp9_ = FALSE;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GeeCollection* collection = NULL;
	GCompareDataFunc _tmp12_;
	gpointer _tmp12__target;
	GDestroyNotify _tmp12__target_destroy_notify;
	GeeSet* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
#line 287 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 289 "../src/photos/PhotoMetadata.vala"
	tags = NULL;
#line 289 "../src/photos/PhotoMetadata.vala"
	tags_length1 = 0;
#line 289 "../src/photos/PhotoMetadata.vala"
	_tags_size_ = tags_length1;
#line 290 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 290 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 2366 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
			gchar** _tmp1_;
			gchar** _tmp2_;
#line 292 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 292 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _tmp1_ = gexiv2_metadata_get_exif_tags (_tmp0_);
#line 292 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 292 "../src/photos/PhotoMetadata.vala"
			tags = _tmp2_;
#line 292 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp1_);
#line 292 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 293 "../src/photos/PhotoMetadata.vala"
			break;
#line 2385 "PhotoMetadata.c"
		}
#line 290 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 2389 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_;
			gchar** _tmp4_;
			gchar** _tmp5_;
#line 296 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 296 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = _tmp4_ = gexiv2_metadata_get_xmp_tags (_tmp3_);
#line 296 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 296 "../src/photos/PhotoMetadata.vala"
			tags = _tmp5_;
#line 296 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp4_);
#line 296 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 297 "../src/photos/PhotoMetadata.vala"
			break;
#line 2408 "PhotoMetadata.c"
		}
#line 290 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 2412 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp6_;
			gchar** _tmp7_;
			gchar** _tmp8_;
#line 300 "../src/photos/PhotoMetadata.vala"
			_tmp6_ = self->priv->exiv2;
#line 300 "../src/photos/PhotoMetadata.vala"
			_tmp8_ = _tmp7_ = gexiv2_metadata_get_iptc_tags (_tmp6_);
#line 300 "../src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 300 "../src/photos/PhotoMetadata.vala"
			tags = _tmp8_;
#line 300 "../src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp7_);
#line 300 "../src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 301 "../src/photos/PhotoMetadata.vala"
			break;
#line 2431 "PhotoMetadata.c"
		}
		default:
#line 290 "../src/photos/PhotoMetadata.vala"
		break;
#line 2436 "PhotoMetadata.c"
	}
#line 304 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = tags;
#line 304 "../src/photos/PhotoMetadata.vala"
	_tmp10__length1 = tags_length1;
#line 304 "../src/photos/PhotoMetadata.vala"
	if (_tmp10_ == NULL) {
#line 304 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = TRUE;
#line 2446 "PhotoMetadata.c"
	} else {
		gchar** _tmp11_;
		gint _tmp11__length1;
#line 304 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = tags;
#line 304 "../src/photos/PhotoMetadata.vala"
		_tmp11__length1 = tags_length1;
#line 304 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp11__length1 == 0;
#line 2456 "PhotoMetadata.c"
	}
#line 304 "../src/photos/PhotoMetadata.vala"
	if (_tmp9_) {
#line 305 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 305 "../src/photos/PhotoMetadata.vala"
		tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 305 "../src/photos/PhotoMetadata.vala"
		(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 305 "../src/photos/PhotoMetadata.vala"
		compare_func = NULL;
#line 305 "../src/photos/PhotoMetadata.vala"
		compare_func_target = NULL;
#line 305 "../src/photos/PhotoMetadata.vala"
		compare_func_target_destroy_notify = NULL;
#line 305 "../src/photos/PhotoMetadata.vala"
		return result;
#line 2474 "PhotoMetadata.c"
	}
#line 307 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = compare_func;
#line 307 "../src/photos/PhotoMetadata.vala"
	_tmp12__target = compare_func_target;
#line 307 "../src/photos/PhotoMetadata.vala"
	_tmp12__target_destroy_notify = compare_func_target_destroy_notify;
#line 307 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 307 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 307 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 307 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = photo_metadata_create_string_set (self, _tmp12_, _tmp12__target, _tmp12__target_destroy_notify);
#line 307 "../src/photos/PhotoMetadata.vala"
	collection = (GeeCollection*) _tmp13_;
#line 308 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = tags;
#line 308 "../src/photos/PhotoMetadata.vala"
	_tmp14__length1 = tags_length1;
#line 2496 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 308 "../src/photos/PhotoMetadata.vala"
		tag_collection = _tmp14_;
#line 308 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp14__length1;
#line 308 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp14__length1; tag_it = tag_it + 1) {
#line 2508 "PhotoMetadata.c"
			gchar* _tmp15_;
			gchar* tag = NULL;
#line 308 "../src/photos/PhotoMetadata.vala"
			_tmp15_ = g_strdup (tag_collection[tag_it]);
#line 308 "../src/photos/PhotoMetadata.vala"
			tag = _tmp15_;
#line 2515 "PhotoMetadata.c"
			{
				GeeCollection* _tmp16_;
				const gchar* _tmp17_;
#line 309 "../src/photos/PhotoMetadata.vala"
				_tmp16_ = collection;
#line 309 "../src/photos/PhotoMetadata.vala"
				_tmp17_ = tag;
#line 309 "../src/photos/PhotoMetadata.vala"
				gee_collection_add (_tmp16_, _tmp17_);
#line 308 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2527 "PhotoMetadata.c"
			}
		}
	}
#line 311 "../src/photos/PhotoMetadata.vala"
	result = collection;
#line 311 "../src/photos/PhotoMetadata.vala"
	tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 311 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 311 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 311 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 311 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 311 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2545 "PhotoMetadata.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 330 "../src/photos/PhotoMetadata.vala"
	return self ? g_object_ref (self) : NULL;
#line 2553 "PhotoMetadata.c"
}

GeeCollection*
photo_metadata_get_all_tags (PhotoMetadata* self,
                             GCompareDataFunc compare_func,
                             gpointer compare_func_target,
                             GDestroyNotify compare_func_target_destroy_notify)
{
	GeeCollection* result = NULL;
	GeeCollection* all_tags = NULL;
	GCompareDataFunc _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	GeeSet* _tmp1_;
	GeeCollection* exif_tags = NULL;
	GeeCollection* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GeeCollection* _tmp4_;
	GeeCollection* xmp_tags = NULL;
	GeeCollection* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GeeCollection* _tmp12_;
	GeeCollection* iptc_tags = NULL;
	GeeCollection* _tmp18_;
	gboolean _tmp19_ = FALSE;
	GeeCollection* _tmp20_;
	GeeCollection* _tmp26_ = NULL;
	GeeCollection* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	GeeCollection* _tmp31_;
#line 314 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 316 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = compare_func;
#line 316 "../src/photos/PhotoMetadata.vala"
	_tmp0__target = compare_func_target;
#line 316 "../src/photos/PhotoMetadata.vala"
	_tmp0__target_destroy_notify = compare_func_target_destroy_notify;
#line 316 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 316 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 316 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 316 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_create_string_set (self, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify);
#line 316 "../src/photos/PhotoMetadata.vala"
	all_tags = (GeeCollection*) _tmp1_;
#line 318 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_tags (self, METADATA_DOMAIN_EXIF, NULL, NULL, NULL);
#line 318 "../src/photos/PhotoMetadata.vala"
	exif_tags = _tmp2_;
#line 319 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = exif_tags;
#line 319 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 2611 "PhotoMetadata.c"
		GeeCollection* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 319 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = exif_tags;
#line 319 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = gee_collection_get_size (_tmp5_);
#line 319 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_;
#line 319 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp7_ > 0;
#line 2623 "PhotoMetadata.c"
	} else {
#line 319 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = FALSE;
#line 2627 "PhotoMetadata.c"
	}
#line 319 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 2631 "PhotoMetadata.c"
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
#line 320 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = all_tags;
#line 320 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = exif_tags;
#line 320 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp8_, _tmp9_);
#line 2640 "PhotoMetadata.c"
	}
#line 322 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = photo_metadata_get_tags (self, METADATA_DOMAIN_XMP, NULL, NULL, NULL);
#line 322 "../src/photos/PhotoMetadata.vala"
	xmp_tags = _tmp10_;
#line 323 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = xmp_tags;
#line 323 "../src/photos/PhotoMetadata.vala"
	if (_tmp12_ != NULL) {
#line 2650 "PhotoMetadata.c"
		GeeCollection* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 323 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = xmp_tags;
#line 323 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = gee_collection_get_size (_tmp13_);
#line 323 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = _tmp14_;
#line 323 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = _tmp15_ > 0;
#line 2662 "PhotoMetadata.c"
	} else {
#line 323 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = FALSE;
#line 2666 "PhotoMetadata.c"
	}
#line 323 "../src/photos/PhotoMetadata.vala"
	if (_tmp11_) {
#line 2670 "PhotoMetadata.c"
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
#line 324 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = all_tags;
#line 324 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = xmp_tags;
#line 324 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp16_, _tmp17_);
#line 2679 "PhotoMetadata.c"
	}
#line 326 "../src/photos/PhotoMetadata.vala"
	_tmp18_ = photo_metadata_get_tags (self, METADATA_DOMAIN_IPTC, NULL, NULL, NULL);
#line 326 "../src/photos/PhotoMetadata.vala"
	iptc_tags = _tmp18_;
#line 327 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = iptc_tags;
#line 327 "../src/photos/PhotoMetadata.vala"
	if (_tmp20_ != NULL) {
#line 2689 "PhotoMetadata.c"
		GeeCollection* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
#line 327 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = iptc_tags;
#line 327 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = gee_collection_get_size (_tmp21_);
#line 327 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = _tmp22_;
#line 327 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = _tmp23_ > 0;
#line 2701 "PhotoMetadata.c"
	} else {
#line 327 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = FALSE;
#line 2705 "PhotoMetadata.c"
	}
#line 327 "../src/photos/PhotoMetadata.vala"
	if (_tmp19_) {
#line 2709 "PhotoMetadata.c"
		GeeCollection* _tmp24_;
		GeeCollection* _tmp25_;
#line 328 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = all_tags;
#line 328 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = iptc_tags;
#line 328 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp24_, _tmp25_);
#line 2718 "PhotoMetadata.c"
	}
#line 330 "../src/photos/PhotoMetadata.vala"
	_tmp27_ = all_tags;
#line 330 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = gee_collection_get_size (_tmp27_);
#line 330 "../src/photos/PhotoMetadata.vala"
	_tmp29_ = _tmp28_;
#line 330 "../src/photos/PhotoMetadata.vala"
	if (_tmp29_ > 0) {
#line 2728 "PhotoMetadata.c"
		GeeCollection* _tmp30_;
#line 330 "../src/photos/PhotoMetadata.vala"
		_tmp30_ = all_tags;
#line 330 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = _tmp30_;
#line 2734 "PhotoMetadata.c"
	} else {
#line 330 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = NULL;
#line 2738 "PhotoMetadata.c"
	}
#line 330 "../src/photos/PhotoMetadata.vala"
	_tmp31_ = _g_object_ref0 (_tmp26_);
#line 330 "../src/photos/PhotoMetadata.vala"
	result = _tmp31_;
#line 330 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (iptc_tags);
#line 330 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (xmp_tags);
#line 330 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (exif_tags);
#line 330 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (all_tags);
#line 330 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 330 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 330 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 330 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 330 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2762 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_tag_label (PhotoMetadata* self,
                              const gchar* tag)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 333 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 333 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 334 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_get_tag_label (tag);
#line 334 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 334 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 334 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2784 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_tag_description (PhotoMetadata* self,
                                    const gchar* tag)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 337 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 337 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 338 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_get_tag_description (tag);
#line 338 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 338 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 338 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2806 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_string (PhotoMetadata* self,
                           const gchar* tag,
                           PrepareInputTextOptions options)
{
	gchar* result = NULL;
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 341 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 341 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 342 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 342 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_string (_tmp0_, tag);
#line 342 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_;
#line 342 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = prepare_input_text (_tmp2_, options, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 342 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = _tmp3_;
#line 342 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp2_);
#line 342 "../src/photos/PhotoMetadata.vala"
	result = _tmp4_;
#line 342 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2840 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_string_interpreted (PhotoMetadata* self,
                                       const gchar* tag,
                                       PrepareInputTextOptions options)
{
	gchar* result = NULL;
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 345 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 345 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 346 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 346 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_interpreted_string (_tmp0_, tag);
#line 346 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_;
#line 346 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = prepare_input_text (_tmp2_, options, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 346 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = _tmp3_;
#line 346 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp2_);
#line 346 "../src/photos/PhotoMetadata.vala"
	result = _tmp4_;
#line 346 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2874 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_first_string (PhotoMetadata* self,
                                 gchar** tags,
                                 gint tags_length1)
{
	gchar* result = NULL;
#line 349 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2885 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 350 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 350 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 350 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
#line 2897 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 350 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 350 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 2904 "PhotoMetadata.c"
			{
				gchar* value = NULL;
				const gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp3_;
#line 351 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 351 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string (self, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 351 "../src/photos/PhotoMetadata.vala"
				value = _tmp2_;
#line 352 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 352 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 353 "../src/photos/PhotoMetadata.vala"
					result = value;
#line 353 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 353 "../src/photos/PhotoMetadata.vala"
					return result;
#line 2926 "PhotoMetadata.c"
				}
#line 350 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 350 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2932 "PhotoMetadata.c"
			}
		}
	}
#line 356 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 356 "../src/photos/PhotoMetadata.vala"
	return result;
#line 2940 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_first_string_interpreted (PhotoMetadata* self,
                                             gchar** tags,
                                             gint tags_length1)
{
	gchar* result = NULL;
#line 359 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2951 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 360 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 360 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 360 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
#line 2963 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 360 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 360 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 2970 "PhotoMetadata.c"
			{
				gchar* value = NULL;
				const gchar* _tmp1_;
				gchar* _tmp2_;
				const gchar* _tmp3_;
#line 361 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 361 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string_interpreted (self, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 361 "../src/photos/PhotoMetadata.vala"
				value = _tmp2_;
#line 362 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 362 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 363 "../src/photos/PhotoMetadata.vala"
					result = value;
#line 363 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 363 "../src/photos/PhotoMetadata.vala"
					return result;
#line 2992 "PhotoMetadata.c"
				}
#line 360 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 360 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2998 "PhotoMetadata.c"
			}
		}
	}
#line 366 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 366 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3006 "PhotoMetadata.c"
}

GeeList*
photo_metadata_get_string_multiple (PhotoMetadata* self,
                                    const gchar* tag)
{
	GeeList* result = NULL;
	gchar** values = NULL;
	GExiv2Metadata* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint values_length1;
	gint _values_size_;
	gboolean _tmp3_ = FALSE;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GeeList* list = NULL;
	GeeArrayList* _tmp6_;
	GeeHashSet* collection = NULL;
	GeeHashSet* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GeeList* _tmp20_ = NULL;
	GeeList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	GeeList* _tmp25_;
#line 375 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 375 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 376 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 376 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_tag_multiple (_tmp0_, tag);
#line 376 "../src/photos/PhotoMetadata.vala"
	values = _tmp2_;
#line 376 "../src/photos/PhotoMetadata.vala"
	values_length1 = _vala_array_length (_tmp1_);
#line 376 "../src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 377 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = values;
#line 377 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = values_length1;
#line 377 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 377 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 3056 "PhotoMetadata.c"
	} else {
		gchar** _tmp5_;
		gint _tmp5__length1;
#line 377 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = values;
#line 377 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = values_length1;
#line 377 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5__length1 == 0;
#line 3066 "PhotoMetadata.c"
	}
#line 377 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 378 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 378 "../src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 378 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3076 "PhotoMetadata.c"
	}
#line 380 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 380 "../src/photos/PhotoMetadata.vala"
	list = (GeeList*) _tmp6_;
#line 382 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 382 "../src/photos/PhotoMetadata.vala"
	collection = _tmp7_;
#line 383 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = values;
#line 383 "../src/photos/PhotoMetadata.vala"
	_tmp8__length1 = values_length1;
#line 3090 "PhotoMetadata.c"
	{
		gchar** value_collection = NULL;
		gint value_collection_length1 = 0;
		gint _value_collection_size_ = 0;
		gint value_it = 0;
#line 383 "../src/photos/PhotoMetadata.vala"
		value_collection = _tmp8_;
#line 383 "../src/photos/PhotoMetadata.vala"
		value_collection_length1 = _tmp8__length1;
#line 383 "../src/photos/PhotoMetadata.vala"
		for (value_it = 0; value_it < _tmp8__length1; value_it = value_it + 1) {
#line 3102 "PhotoMetadata.c"
			gchar* _tmp9_;
			gchar* value = NULL;
#line 383 "../src/photos/PhotoMetadata.vala"
			_tmp9_ = g_strdup (value_collection[value_it]);
#line 383 "../src/photos/PhotoMetadata.vala"
			value = _tmp9_;
#line 3109 "PhotoMetadata.c"
			{
				gchar* prepped = NULL;
				const gchar* _tmp10_;
				gchar* _tmp11_;
				gboolean _tmp12_ = FALSE;
				const gchar* _tmp13_;
#line 384 "../src/photos/PhotoMetadata.vala"
				_tmp10_ = value;
#line 384 "../src/photos/PhotoMetadata.vala"
				_tmp11_ = prepare_input_text (_tmp10_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 384 "../src/photos/PhotoMetadata.vala"
				prepped = _tmp11_;
#line 387 "../src/photos/PhotoMetadata.vala"
				_tmp13_ = prepped;
#line 387 "../src/photos/PhotoMetadata.vala"
				if (_tmp13_ != NULL) {
#line 3126 "PhotoMetadata.c"
					GeeHashSet* _tmp14_;
					const gchar* _tmp15_;
#line 387 "../src/photos/PhotoMetadata.vala"
					_tmp14_ = collection;
#line 387 "../src/photos/PhotoMetadata.vala"
					_tmp15_ = prepped;
#line 387 "../src/photos/PhotoMetadata.vala"
					_tmp12_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp14_, _tmp15_);
#line 3135 "PhotoMetadata.c"
				} else {
#line 387 "../src/photos/PhotoMetadata.vala"
					_tmp12_ = FALSE;
#line 3139 "PhotoMetadata.c"
				}
#line 387 "../src/photos/PhotoMetadata.vala"
				if (_tmp12_) {
#line 3143 "PhotoMetadata.c"
					GeeList* _tmp16_;
					const gchar* _tmp17_;
					GeeHashSet* _tmp18_;
					const gchar* _tmp19_;
#line 388 "../src/photos/PhotoMetadata.vala"
					_tmp16_ = list;
#line 388 "../src/photos/PhotoMetadata.vala"
					_tmp17_ = prepped;
#line 388 "../src/photos/PhotoMetadata.vala"
					gee_collection_add ((GeeCollection*) _tmp16_, _tmp17_);
#line 389 "../src/photos/PhotoMetadata.vala"
					_tmp18_ = collection;
#line 389 "../src/photos/PhotoMetadata.vala"
					_tmp19_ = prepped;
#line 389 "../src/photos/PhotoMetadata.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
#line 3160 "PhotoMetadata.c"
				}
#line 383 "../src/photos/PhotoMetadata.vala"
				_g_free0 (prepped);
#line 383 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 3166 "PhotoMetadata.c"
			}
		}
	}
#line 393 "../src/photos/PhotoMetadata.vala"
	_tmp21_ = list;
#line 393 "../src/photos/PhotoMetadata.vala"
	_tmp22_ = gee_collection_get_size ((GeeCollection*) _tmp21_);
#line 393 "../src/photos/PhotoMetadata.vala"
	_tmp23_ = _tmp22_;
#line 393 "../src/photos/PhotoMetadata.vala"
	if (_tmp23_ > 0) {
#line 3178 "PhotoMetadata.c"
		GeeList* _tmp24_;
#line 393 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = list;
#line 393 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = _tmp24_;
#line 3184 "PhotoMetadata.c"
	} else {
#line 393 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = NULL;
#line 3188 "PhotoMetadata.c"
	}
#line 393 "../src/photos/PhotoMetadata.vala"
	_tmp25_ = _g_object_ref0 (_tmp20_);
#line 393 "../src/photos/PhotoMetadata.vala"
	result = _tmp25_;
#line 393 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (collection);
#line 393 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (list);
#line 393 "../src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 393 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3202 "PhotoMetadata.c"
}

GeeList*
photo_metadata_get_first_string_multiple (PhotoMetadata* self,
                                          gchar** tags,
                                          gint tags_length1)
{
	GeeList* result = NULL;
#line 402 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3213 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 403 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 403 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 403 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
#line 3225 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 403 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 403 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 3232 "PhotoMetadata.c"
			{
				GeeList* values = NULL;
				const gchar* _tmp1_;
				GeeList* _tmp2_;
				gboolean _tmp3_ = FALSE;
				GeeList* _tmp4_;
#line 404 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 404 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_string_multiple (self, _tmp1_);
#line 404 "../src/photos/PhotoMetadata.vala"
				values = _tmp2_;
#line 405 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = values;
#line 405 "../src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 3249 "PhotoMetadata.c"
					GeeList* _tmp5_;
					gint _tmp6_;
					gint _tmp7_;
#line 405 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = values;
#line 405 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 405 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = _tmp6_;
#line 405 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = _tmp7_ > 0;
#line 3261 "PhotoMetadata.c"
				} else {
#line 405 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = FALSE;
#line 3265 "PhotoMetadata.c"
				}
#line 405 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 406 "../src/photos/PhotoMetadata.vala"
					result = values;
#line 406 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 406 "../src/photos/PhotoMetadata.vala"
					return result;
#line 3275 "PhotoMetadata.c"
				}
#line 403 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 403 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3281 "PhotoMetadata.c"
			}
		}
	}
#line 409 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 409 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3289 "PhotoMetadata.c"
}

void
photo_metadata_set_string (PhotoMetadata* self,
                           const gchar* tag,
                           const gchar* value,
                           PrepareInputTextOptions options)
{
	gchar* prepped = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GExiv2Metadata* _tmp2_;
	const gchar* _tmp3_;
#line 412 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 412 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 412 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 413 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = prepare_input_text (value, options, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 413 "../src/photos/PhotoMetadata.vala"
	prepped = _tmp0_;
#line 414 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = prepped;
#line 414 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 415 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:415: Not setting tag %s to string %s: invalid UTF-8", tag, value);
#line 417 "../src/photos/PhotoMetadata.vala"
		_g_free0 (prepped);
#line 417 "../src/photos/PhotoMetadata.vala"
		return;
#line 3323 "PhotoMetadata.c"
	}
#line 420 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->exiv2;
#line 420 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = prepped;
#line 420 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_string (_tmp2_, tag, _tmp3_)) {
#line 3331 "PhotoMetadata.c"
		const gchar* _tmp4_;
#line 421 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = self->priv->source_name;
#line 421 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:421: Unable to set tag %s to string %s from source " \
"%s", tag, value, _tmp4_);
#line 3337 "PhotoMetadata.c"
	}
#line 412 "../src/photos/PhotoMetadata.vala"
	_g_free0 (prepped);
#line 3341 "PhotoMetadata.c"
}

static void
photo_metadata_set_all_generic (PhotoMetadata* self,
                                gchar** tags,
                                gint tags_length1,
                                PhotoMetadataSetOption option,
                                PhotoMetadataSetGenericValue setter,
                                gpointer setter_target)
{
	gboolean written = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 426 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 427 "../src/photos/PhotoMetadata.vala"
	written = FALSE;
#line 3359 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 428 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 428 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 428 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
#line 3371 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 428 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 428 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 3378 "PhotoMetadata.c"
			{
				gboolean _tmp1_ = FALSE;
#line 429 "../src/photos/PhotoMetadata.vala"
				if (option == PHOTO_METADATA_SET_OPTION_ALL_DOMAINS) {
#line 429 "../src/photos/PhotoMetadata.vala"
					_tmp1_ = TRUE;
#line 3385 "PhotoMetadata.c"
				} else {
					const gchar* _tmp2_;
#line 429 "../src/photos/PhotoMetadata.vala"
					_tmp2_ = tag;
#line 429 "../src/photos/PhotoMetadata.vala"
					_tmp1_ = photo_metadata_has_domain (self, photo_metadata_get_tag_domain (_tmp2_));
#line 3392 "PhotoMetadata.c"
				}
#line 429 "../src/photos/PhotoMetadata.vala"
				if (_tmp1_) {
#line 3396 "PhotoMetadata.c"
					const gchar* _tmp3_;
#line 430 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = tag;
#line 430 "../src/photos/PhotoMetadata.vala"
					setter (_tmp3_, setter_target);
#line 431 "../src/photos/PhotoMetadata.vala"
					written = TRUE;
#line 3404 "PhotoMetadata.c"
				}
#line 428 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3408 "PhotoMetadata.c"
			}
		}
	}
#line 435 "../src/photos/PhotoMetadata.vala"
	if (option == PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN) {
#line 435 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = !written;
#line 3416 "PhotoMetadata.c"
	} else {
#line 435 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = FALSE;
#line 3420 "PhotoMetadata.c"
	}
#line 435 "../src/photos/PhotoMetadata.vala"
	if (_tmp5_) {
#line 435 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = tags_length1 > 0;
#line 3426 "PhotoMetadata.c"
	} else {
#line 435 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 3430 "PhotoMetadata.c"
	}
#line 435 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 3434 "PhotoMetadata.c"
		MetadataDomain default_domain = 0;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 436 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = tags[0];
#line 436 "../src/photos/PhotoMetadata.vala"
		default_domain = photo_metadata_get_tag_domain (_tmp6_);
#line 439 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = tags[0];
#line 439 "../src/photos/PhotoMetadata.vala"
		setter (_tmp7_, setter_target);
#line 3446 "PhotoMetadata.c"
		{
			gint ctr = 0;
#line 442 "../src/photos/PhotoMetadata.vala"
			ctr = 1;
#line 3451 "PhotoMetadata.c"
			{
				gboolean _tmp8_ = FALSE;
#line 442 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = TRUE;
#line 442 "../src/photos/PhotoMetadata.vala"
				while (TRUE) {
#line 3458 "PhotoMetadata.c"
					const gchar* _tmp10_;
					MetadataDomain _tmp11_;
#line 442 "../src/photos/PhotoMetadata.vala"
					if (!_tmp8_) {
#line 3463 "PhotoMetadata.c"
						gint _tmp9_;
#line 442 "../src/photos/PhotoMetadata.vala"
						_tmp9_ = ctr;
#line 442 "../src/photos/PhotoMetadata.vala"
						ctr = _tmp9_ + 1;
#line 3469 "PhotoMetadata.c"
					}
#line 442 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = FALSE;
#line 442 "../src/photos/PhotoMetadata.vala"
					if (!(ctr < tags_length1)) {
#line 442 "../src/photos/PhotoMetadata.vala"
						break;
#line 3477 "PhotoMetadata.c"
					}
#line 443 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = tags[ctr];
#line 443 "../src/photos/PhotoMetadata.vala"
					_tmp11_ = default_domain;
#line 443 "../src/photos/PhotoMetadata.vala"
					if (photo_metadata_get_tag_domain (_tmp10_) == _tmp11_) {
#line 3485 "PhotoMetadata.c"
						const gchar* _tmp12_;
#line 444 "../src/photos/PhotoMetadata.vala"
						_tmp12_ = tags[ctr];
#line 444 "../src/photos/PhotoMetadata.vala"
						setter (_tmp12_, setter_target);
#line 3491 "PhotoMetadata.c"
					}
				}
			}
		}
	}
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 449 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 449 "../src/photos/PhotoMetadata.vala"
	return _data3_;
#line 3506 "PhotoMetadata.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 449 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 3516 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 449 "../src/photos/PhotoMetadata.vala"
		self = _data3_->self;
#line 449 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_data3_->value);
#line 449 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 449 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block3Data, _data3_);
#line 3526 "PhotoMetadata.c"
	}
}

static void
__lambda4_ (Block3Data* _data3_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 450 "../src/photos/PhotoMetadata.vala"
	self = _data3_->self;
#line 450 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 451 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, tag, _data3_->value, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 3541 "PhotoMetadata.c"
}

static void
___lambda4__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 450 "../src/photos/PhotoMetadata.vala"
	__lambda4_ (self, tag);
#line 3550 "PhotoMetadata.c"
}

void
photo_metadata_set_all_string (PhotoMetadata* self,
                               gchar** tags,
                               gint tags_length1,
                               const gchar* value,
                               PhotoMetadataSetOption option)
{
	Block3Data* _data3_;
	gchar* _tmp0_;
#line 449 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 449 "../src/photos/PhotoMetadata.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 449 "../src/photos/PhotoMetadata.vala"
	_data3_->_ref_count_ = 1;
#line 449 "../src/photos/PhotoMetadata.vala"
	_data3_->self = media_metadata_ref (self);
#line 449 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup (value);
#line 449 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_data3_->value);
#line 449 "../src/photos/PhotoMetadata.vala"
	_data3_->value = _tmp0_;
#line 450 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda4__photo_metadata_set_generic_value, _data3_);
#line 449 "../src/photos/PhotoMetadata.vala"
	block3_data_unref (_data3_);
#line 449 "../src/photos/PhotoMetadata.vala"
	_data3_ = NULL;
#line 3584 "PhotoMetadata.c"
}

static void
_vala_array_add95 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 460 "../src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 460 "../src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 460 "../src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3599 "PhotoMetadata.c"
	}
#line 460 "../src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 460 "../src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 3605 "PhotoMetadata.c"
}

static void
_vala_array_add96 (gchar** * array,
                   int* length,
                   int* size,
                   gchar* value)
{
#line 472 "../src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 472 "../src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 472 "../src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3620 "PhotoMetadata.c"
	}
#line 472 "../src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 472 "../src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 3626 "PhotoMetadata.c"
}

void
photo_metadata_set_string_multiple (PhotoMetadata* self,
                                    const gchar* tag,
                                    GeeCollection* collection)
{
	gchar** values = NULL;
	gchar** _tmp0_;
	gint values_length1;
	gint _values_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar** _tmp13_;
	gint _tmp13__length1;
	GExiv2Metadata* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
#line 455 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 455 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 455 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (collection != NULL);
#line 456 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 456 "../src/photos/PhotoMetadata.vala"
	values = _tmp0_;
#line 456 "../src/photos/PhotoMetadata.vala"
	values_length1 = 0;
#line 456 "../src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 3659 "PhotoMetadata.c"
	{
		GeeIterator* _value_it = NULL;
		GeeIterator* _tmp1_;
#line 457 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) collection);
#line 457 "../src/photos/PhotoMetadata.vala"
		_value_it = _tmp1_;
#line 457 "../src/photos/PhotoMetadata.vala"
		while (TRUE) {
#line 3669 "PhotoMetadata.c"
			GeeIterator* _tmp2_;
			gchar* value = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			gchar* prepped = NULL;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			const gchar* _tmp7_;
#line 457 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _value_it;
#line 457 "../src/photos/PhotoMetadata.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 457 "../src/photos/PhotoMetadata.vala"
				break;
#line 3684 "PhotoMetadata.c"
			}
#line 457 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = _value_it;
#line 457 "../src/photos/PhotoMetadata.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 457 "../src/photos/PhotoMetadata.vala"
			value = (gchar*) _tmp4_;
#line 458 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = value;
#line 458 "../src/photos/PhotoMetadata.vala"
			_tmp6_ = prepare_input_text (_tmp5_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, -1);
#line 458 "../src/photos/PhotoMetadata.vala"
			prepped = _tmp6_;
#line 459 "../src/photos/PhotoMetadata.vala"
			_tmp7_ = prepped;
#line 459 "../src/photos/PhotoMetadata.vala"
			if (_tmp7_ != NULL) {
#line 3702 "PhotoMetadata.c"
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
				gchar* _tmp10_;
#line 460 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = values;
#line 460 "../src/photos/PhotoMetadata.vala"
				_tmp8__length1 = values_length1;
#line 460 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = prepped;
#line 460 "../src/photos/PhotoMetadata.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 460 "../src/photos/PhotoMetadata.vala"
				_vala_array_add95 (&values, &values_length1, &_values_size_, _tmp10_);
#line 3717 "PhotoMetadata.c"
			} else {
				const gchar* _tmp11_;
#line 462 "../src/photos/PhotoMetadata.vala"
				_tmp11_ = value;
#line 462 "../src/photos/PhotoMetadata.vala"
				g_warning ("PhotoMetadata.vala:462: Unable to set string %s to %s: invalid UTF-8", _tmp11_, tag);
#line 3724 "PhotoMetadata.c"
			}
#line 457 "../src/photos/PhotoMetadata.vala"
			_g_free0 (prepped);
#line 457 "../src/photos/PhotoMetadata.vala"
			_g_free0 (value);
#line 3730 "PhotoMetadata.c"
		}
#line 457 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_value_it);
#line 3734 "PhotoMetadata.c"
	}
#line 465 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = values;
#line 465 "../src/photos/PhotoMetadata.vala"
	_tmp12__length1 = values_length1;
#line 465 "../src/photos/PhotoMetadata.vala"
	if (_tmp12__length1 == 0) {
#line 466 "../src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 466 "../src/photos/PhotoMetadata.vala"
		return;
#line 3746 "PhotoMetadata.c"
	}
#line 472 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = values;
#line 472 "../src/photos/PhotoMetadata.vala"
	_tmp13__length1 = values_length1;
#line 472 "../src/photos/PhotoMetadata.vala"
	_vala_array_add96 (&values, &values_length1, &_values_size_, NULL);
#line 474 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = self->priv->exiv2;
#line 474 "../src/photos/PhotoMetadata.vala"
	_tmp15_ = values;
#line 474 "../src/photos/PhotoMetadata.vala"
	_tmp15__length1 = values_length1;
#line 474 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_multiple (_tmp14_, tag, _tmp15_)) {
#line 3762 "PhotoMetadata.c"
		gchar** _tmp16_;
		gint _tmp16__length1;
		const gchar* _tmp17_;
#line 475 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = values;
#line 475 "../src/photos/PhotoMetadata.vala"
		_tmp16__length1 = values_length1;
#line 475 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = self->priv->source_name;
#line 475 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:475: Unable to set %d strings to tag %s from source" \
" %s", _tmp16__length1, tag, _tmp17_);
#line 3774 "PhotoMetadata.c"
	}
#line 455 "../src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 3778 "PhotoMetadata.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 478 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 478 "../src/photos/PhotoMetadata.vala"
	return _data4_;
#line 3788 "PhotoMetadata.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 478 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 3798 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 478 "../src/photos/PhotoMetadata.vala"
		self = _data4_->self;
#line 478 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_data4_->values);
#line 478 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 478 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block4Data, _data4_);
#line 3808 "PhotoMetadata.c"
	}
}

static void
__lambda5_ (Block4Data* _data4_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 479 "../src/photos/PhotoMetadata.vala"
	self = _data4_->self;
#line 479 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 480 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string_multiple (self, tag, _data4_->values);
#line 3823 "PhotoMetadata.c"
}

static void
___lambda5__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 479 "../src/photos/PhotoMetadata.vala"
	__lambda5_ (self, tag);
#line 3832 "PhotoMetadata.c"
}

void
photo_metadata_set_all_string_multiple (PhotoMetadata* self,
                                        gchar** tags,
                                        gint tags_length1,
                                        GeeCollection* values,
                                        PhotoMetadataSetOption option)
{
	Block4Data* _data4_;
	GeeCollection* _tmp0_;
#line 478 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 478 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (values != NULL);
#line 478 "../src/photos/PhotoMetadata.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 478 "../src/photos/PhotoMetadata.vala"
	_data4_->_ref_count_ = 1;
#line 478 "../src/photos/PhotoMetadata.vala"
	_data4_->self = media_metadata_ref (self);
#line 478 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _g_object_ref0 (values);
#line 478 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_data4_->values);
#line 478 "../src/photos/PhotoMetadata.vala"
	_data4_->values = _tmp0_;
#line 479 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda5__photo_metadata_set_generic_value, _data4_);
#line 478 "../src/photos/PhotoMetadata.vala"
	block4_data_unref (_data4_);
#line 478 "../src/photos/PhotoMetadata.vala"
	_data4_ = NULL;
#line 3866 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_long (PhotoMetadata* self,
                         const gchar* tag,
                         glong* value)
{
	glong _vala_value = 0L;
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_;
#line 484 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 484 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 485 "../src/photos/PhotoMetadata.vala"
	if (!photo_metadata_has_tag (self, tag)) {
#line 486 "../src/photos/PhotoMetadata.vala"
		_vala_value = (glong) 0;
#line 488 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 488 "../src/photos/PhotoMetadata.vala"
		if (value) {
#line 488 "../src/photos/PhotoMetadata.vala"
			*value = _vala_value;
#line 3891 "PhotoMetadata.c"
		}
#line 488 "../src/photos/PhotoMetadata.vala"
		return result;
#line 3895 "PhotoMetadata.c"
	}
#line 491 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 491 "../src/photos/PhotoMetadata.vala"
	_vala_value = gexiv2_metadata_get_tag_long (_tmp0_, tag);
#line 493 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 493 "../src/photos/PhotoMetadata.vala"
	if (value) {
#line 493 "../src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 3907 "PhotoMetadata.c"
	}
#line 493 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3911 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_first_long (PhotoMetadata* self,
                               gchar** tags,
                               gint tags_length1,
                               glong* value)
{
	glong _vala_value = 0L;
	gboolean result = FALSE;
#line 496 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3924 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 497 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 497 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 497 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
#line 3936 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 497 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 497 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 3943 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
				glong _tmp2_ = 0L;
				gboolean _tmp3_;
#line 498 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 498 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_long (self, _tmp1_, &_tmp2_);
#line 498 "../src/photos/PhotoMetadata.vala"
				_vala_value = _tmp2_;
#line 498 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 499 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 499 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 499 "../src/photos/PhotoMetadata.vala"
					if (value) {
#line 499 "../src/photos/PhotoMetadata.vala"
						*value = _vala_value;
#line 3964 "PhotoMetadata.c"
					}
#line 499 "../src/photos/PhotoMetadata.vala"
					return result;
#line 3968 "PhotoMetadata.c"
				}
#line 497 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3972 "PhotoMetadata.c"
			}
		}
	}
#line 502 "../src/photos/PhotoMetadata.vala"
	_vala_value = (glong) 0;
#line 504 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 504 "../src/photos/PhotoMetadata.vala"
	if (value) {
#line 504 "../src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 3984 "PhotoMetadata.c"
	}
#line 504 "../src/photos/PhotoMetadata.vala"
	return result;
#line 3988 "PhotoMetadata.c"
}

void
photo_metadata_set_long (PhotoMetadata* self,
                         const gchar* tag,
                         glong value)
{
	GExiv2Metadata* _tmp0_;
#line 507 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 507 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 508 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 508 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_tag_long (_tmp0_, tag, value)) {
#line 4005 "PhotoMetadata.c"
		const gchar* _tmp1_;
#line 509 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = self->priv->source_name;
#line 509 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:509: Unable to set tag %s to long %ld from source %" \
"s", tag, value, _tmp1_);
#line 4011 "PhotoMetadata.c"
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 512 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 512 "../src/photos/PhotoMetadata.vala"
	return _data5_;
#line 4022 "PhotoMetadata.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 512 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 4032 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 512 "../src/photos/PhotoMetadata.vala"
		self = _data5_->self;
#line 512 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 512 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block5Data, _data5_);
#line 4040 "PhotoMetadata.c"
	}
}

static void
__lambda6_ (Block5Data* _data5_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 513 "../src/photos/PhotoMetadata.vala"
	self = _data5_->self;
#line 513 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 514 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_long (self, tag, _data5_->value);
#line 4055 "PhotoMetadata.c"
}

static void
___lambda6__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 513 "../src/photos/PhotoMetadata.vala"
	__lambda6_ (self, tag);
#line 4064 "PhotoMetadata.c"
}

void
photo_metadata_set_all_long (PhotoMetadata* self,
                             gchar** tags,
                             gint tags_length1,
                             glong value,
                             PhotoMetadataSetOption option)
{
	Block5Data* _data5_;
#line 512 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 512 "../src/photos/PhotoMetadata.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 512 "../src/photos/PhotoMetadata.vala"
	_data5_->_ref_count_ = 1;
#line 512 "../src/photos/PhotoMetadata.vala"
	_data5_->self = media_metadata_ref (self);
#line 512 "../src/photos/PhotoMetadata.vala"
	_data5_->value = value;
#line 513 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda6__photo_metadata_set_generic_value, _data5_);
#line 512 "../src/photos/PhotoMetadata.vala"
	block5_data_unref (_data5_);
#line 512 "../src/photos/PhotoMetadata.vala"
	_data5_ = NULL;
#line 4091 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_rational (PhotoMetadata* self,
                             const gchar* tag,
                             MetadataRational* rational)
{
	MetadataRational _vala_rational = {0};
	gboolean result = FALSE;
	gint numerator = 0;
	gint denominator = 0;
	gboolean _result_ = FALSE;
	GExiv2Metadata* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
#line 518 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 518 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 520 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 520 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = gexiv2_metadata_get_exif_tag_rational (_tmp0_, tag, &_tmp1_, &_tmp2_);
#line 520 "../src/photos/PhotoMetadata.vala"
	numerator = _tmp1_;
#line 520 "../src/photos/PhotoMetadata.vala"
	denominator = _tmp2_;
#line 520 "../src/photos/PhotoMetadata.vala"
	_result_ = _tmp3_;
#line 522 "../src/photos/PhotoMetadata.vala"
	metadata_rational_init (&_vala_rational, numerator, denominator);
#line 524 "../src/photos/PhotoMetadata.vala"
	result = _result_;
#line 524 "../src/photos/PhotoMetadata.vala"
	if (rational) {
#line 524 "../src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 4130 "PhotoMetadata.c"
	}
#line 524 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4134 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_first_rational (PhotoMetadata* self,
                                   gchar** tags,
                                   gint tags_length1,
                                   MetadataRational* rational)
{
	MetadataRational _vala_rational = {0};
	gboolean result = FALSE;
#line 527 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4147 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 528 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 528 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 528 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
#line 4159 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 528 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 528 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 4166 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
				MetadataRational _tmp2_ = {0};
				gboolean _tmp3_;
#line 529 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 529 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_rational (self, _tmp1_, &_tmp2_);
#line 529 "../src/photos/PhotoMetadata.vala"
				_vala_rational = _tmp2_;
#line 529 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_) {
#line 530 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 530 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 530 "../src/photos/PhotoMetadata.vala"
					if (rational) {
#line 530 "../src/photos/PhotoMetadata.vala"
						*rational = _vala_rational;
#line 4187 "PhotoMetadata.c"
					}
#line 530 "../src/photos/PhotoMetadata.vala"
					return result;
#line 4191 "PhotoMetadata.c"
				}
#line 528 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4195 "PhotoMetadata.c"
			}
		}
	}
#line 533 "../src/photos/PhotoMetadata.vala"
	metadata_rational_init (&_vala_rational, 0, 0);
#line 535 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 535 "../src/photos/PhotoMetadata.vala"
	if (rational) {
#line 535 "../src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 4207 "PhotoMetadata.c"
	}
#line 535 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4211 "PhotoMetadata.c"
}

void
photo_metadata_set_rational (PhotoMetadata* self,
                             const gchar* tag,
                             MetadataRational* rational)
{
	GExiv2Metadata* _tmp0_;
	MetadataRational _tmp1_;
	MetadataRational _tmp2_;
#line 538 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 538 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 538 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 539 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 539 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = *rational;
#line 539 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = *rational;
#line 539 "../src/photos/PhotoMetadata.vala"
	if (!gexiv2_metadata_set_exif_tag_rational (_tmp0_, tag, _tmp1_.numerator, _tmp2_.denominator)) {
#line 4236 "PhotoMetadata.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 540 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = metadata_rational_to_string (rational);
#line 540 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = _tmp3_;
#line 540 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = self->priv->source_name;
#line 540 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:540: Unable to set tag %s to rational %s from sourc" \
"e %s", tag, _tmp4_, _tmp5_);
#line 540 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp4_);
#line 4250 "PhotoMetadata.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 545 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 545 "../src/photos/PhotoMetadata.vala"
	return _data6_;
#line 4261 "PhotoMetadata.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 545 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 4271 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 545 "../src/photos/PhotoMetadata.vala"
		self = _data6_->self;
#line 545 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 545 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block6Data, _data6_);
#line 4279 "PhotoMetadata.c"
	}
}

static void
__lambda7_ (Block6Data* _data6_,
            const gchar* tag)
{
	PhotoMetadata* self;
	MetadataRational _tmp0_;
#line 546 "../src/photos/PhotoMetadata.vala"
	self = _data6_->self;
#line 546 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 547 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _data6_->rational;
#line 547 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_rational (self, tag, &_tmp0_);
#line 4297 "PhotoMetadata.c"
}

static void
___lambda7__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 546 "../src/photos/PhotoMetadata.vala"
	__lambda7_ (self, tag);
#line 4306 "PhotoMetadata.c"
}

void
photo_metadata_set_all_rational (PhotoMetadata* self,
                                 gchar** tags,
                                 gint tags_length1,
                                 MetadataRational* rational,
                                 PhotoMetadataSetOption option)
{
	Block6Data* _data6_;
	MetadataRational _tmp0_;
#line 545 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 545 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 545 "../src/photos/PhotoMetadata.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 545 "../src/photos/PhotoMetadata.vala"
	_data6_->_ref_count_ = 1;
#line 545 "../src/photos/PhotoMetadata.vala"
	_data6_->self = media_metadata_ref (self);
#line 545 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = *rational;
#line 545 "../src/photos/PhotoMetadata.vala"
	_data6_->rational = _tmp0_;
#line 546 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda7__photo_metadata_set_generic_value, _data6_);
#line 545 "../src/photos/PhotoMetadata.vala"
	block6_data_unref (_data6_);
#line 545 "../src/photos/PhotoMetadata.vala"
	_data6_ = NULL;
#line 4338 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_date_time (PhotoMetadata* self,
                              const gchar* tag)
{
	MetadataDateTime* result = NULL;
	gchar* value = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 551 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 551 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 552 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string (self, tag, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 552 "../src/photos/PhotoMetadata.vala"
	value = _tmp0_;
#line 553 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = value;
#line 553 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 554 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 554 "../src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 554 "../src/photos/PhotoMetadata.vala"
		return result;
#line 4368 "PhotoMetadata.c"
	}
	{
#line 557 "../src/photos/PhotoMetadata.vala"
		switch (photo_metadata_get_tag_domain (tag)) {
#line 557 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_XMP:
#line 4375 "PhotoMetadata.c"
			{
				MetadataDateTime* _tmp2_ = NULL;
				const gchar* _tmp3_;
				MetadataDateTime* _tmp4_;
				MetadataDateTime* _tmp5_;
#line 559 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = value;
#line 559 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = metadata_date_time_new_from_xmp (_tmp3_, &_inner_error0_);
#line 559 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = _tmp4_;
#line 559 "../src/photos/PhotoMetadata.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4389 "PhotoMetadata.c"
					goto __catch375_g_error;
				}
#line 559 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = _tmp2_;
#line 559 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = NULL;
#line 559 "../src/photos/PhotoMetadata.vala"
				result = _tmp5_;
#line 559 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (_tmp2_);
#line 559 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 559 "../src/photos/PhotoMetadata.vala"
				return result;
#line 4404 "PhotoMetadata.c"
			}
#line 557 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_IPTC:
#line 4408 "PhotoMetadata.c"
			{
#line 564 "../src/photos/PhotoMetadata.vala"
				result = NULL;
#line 564 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 564 "../src/photos/PhotoMetadata.vala"
				return result;
#line 4416 "PhotoMetadata.c"
			}
			default:
#line 557 "../src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_EXIF:
#line 4421 "PhotoMetadata.c"
			{
				MetadataDateTime* _tmp6_ = NULL;
				const gchar* _tmp7_;
				MetadataDateTime* _tmp8_;
				MetadataDateTime* _tmp9_;
#line 568 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = value;
#line 568 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = metadata_date_time_new_from_exif (_tmp7_, &_inner_error0_);
#line 568 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = _tmp8_;
#line 568 "../src/photos/PhotoMetadata.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4435 "PhotoMetadata.c"
					goto __catch375_g_error;
				}
#line 568 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = _tmp6_;
#line 568 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = NULL;
#line 568 "../src/photos/PhotoMetadata.vala"
				result = _tmp9_;
#line 568 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (_tmp6_);
#line 568 "../src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 568 "../src/photos/PhotoMetadata.vala"
				return result;
#line 4450 "PhotoMetadata.c"
			}
		}
	}
	goto __finally375;
	__catch375_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 556 "../src/photos/PhotoMetadata.vala"
		err = _inner_error0_;
#line 556 "../src/photos/PhotoMetadata.vala"
		_inner_error0_ = NULL;
#line 571 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = self->priv->source_name;
#line 571 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = err;
#line 571 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = _tmp11_->message;
#line 571 "../src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:571: Unable to read date/time %s from source %s: %s", tag, _tmp10_, _tmp12_);
#line 573 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 573 "../src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 573 "../src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 573 "../src/photos/PhotoMetadata.vala"
		return result;
#line 4481 "PhotoMetadata.c"
	}
	__finally375:
#line 556 "../src/photos/PhotoMetadata.vala"
	_g_free0 (value);
#line 556 "../src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 556 "../src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error0_);
#line 556 "../src/photos/PhotoMetadata.vala"
	return NULL;
#line 4492 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_first_date_time (PhotoMetadata* self,
                                    gchar** tags,
                                    gint tags_length1)
{
	MetadataDateTime* result = NULL;
#line 577 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4503 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 578 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 578 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 578 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
#line 4515 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 578 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 578 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 4522 "PhotoMetadata.c"
			{
				MetadataDateTime* date_time = NULL;
				const gchar* _tmp1_;
				MetadataDateTime* _tmp2_;
				MetadataDateTime* _tmp3_;
#line 579 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 579 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = photo_metadata_get_date_time (self, _tmp1_);
#line 579 "../src/photos/PhotoMetadata.vala"
				date_time = _tmp2_;
#line 580 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = date_time;
#line 580 "../src/photos/PhotoMetadata.vala"
				if (_tmp3_ != NULL) {
#line 581 "../src/photos/PhotoMetadata.vala"
					result = date_time;
#line 581 "../src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 581 "../src/photos/PhotoMetadata.vala"
					return result;
#line 4544 "PhotoMetadata.c"
				}
#line 578 "../src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (date_time);
#line 578 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4550 "PhotoMetadata.c"
			}
		}
	}
#line 584 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 584 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4558 "PhotoMetadata.c"
}

void
photo_metadata_set_date_time (PhotoMetadata* self,
                              const gchar* tag,
                              MetadataDateTime* date_time)
{
#line 587 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 587 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 587 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (date_time != NULL);
#line 588 "../src/photos/PhotoMetadata.vala"
	switch (photo_metadata_get_tag_domain (tag)) {
#line 588 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 4576 "PhotoMetadata.c"
		{
			gchar* _tmp0_;
			gchar* _tmp1_;
#line 590 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = metadata_date_time_get_exif_label (date_time);
#line 590 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _tmp0_;
#line 590 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 590 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp1_);
#line 591 "../src/photos/PhotoMetadata.vala"
			break;
#line 4590 "PhotoMetadata.c"
		}
#line 588 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 4594 "PhotoMetadata.c"
		{
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 594 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = metadata_date_time_get_xmp_label (date_time);
#line 594 "../src/photos/PhotoMetadata.vala"
			_tmp3_ = _tmp2_;
#line 594 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, tag, _tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 594 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp3_);
#line 595 "../src/photos/PhotoMetadata.vala"
			break;
#line 4608 "PhotoMetadata.c"
		}
		default:
#line 588 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 4613 "PhotoMetadata.c"
		{
			const gchar* _tmp4_;
			GEnumValue* _tmp5_;
#line 600 "../src/photos/PhotoMetadata.vala"
			_tmp4_ = self->priv->source_name;
#line 601 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_METADATA_DOMAIN), photo_metadata_get_tag_domain (tag));
#line 600 "../src/photos/PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:600: Cannot set date/time for %s from source %s: un" \
"supported metadata domain %s", tag, _tmp4_, (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 602 "../src/photos/PhotoMetadata.vala"
			break;
#line 4625 "PhotoMetadata.c"
		}
	}
}

static gpointer
_metadata_date_time_ref0 (gpointer self)
{
#line 606 "../src/photos/PhotoMetadata.vala"
	return self ? metadata_date_time_ref (self) : NULL;
#line 4635 "PhotoMetadata.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 606 "../src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 606 "../src/photos/PhotoMetadata.vala"
	return _data7_;
#line 4645 "PhotoMetadata.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 606 "../src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 4655 "PhotoMetadata.c"
		PhotoMetadata* self;
#line 606 "../src/photos/PhotoMetadata.vala"
		self = _data7_->self;
#line 606 "../src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (_data7_->date_time);
#line 606 "../src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (self);
#line 606 "../src/photos/PhotoMetadata.vala"
		g_slice_free (Block7Data, _data7_);
#line 4665 "PhotoMetadata.c"
	}
}

static void
__lambda8_ (Block7Data* _data7_,
            const gchar* tag)
{
	PhotoMetadata* self;
#line 607 "../src/photos/PhotoMetadata.vala"
	self = _data7_->self;
#line 607 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 608 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_date_time (self, tag, _data7_->date_time);
#line 4680 "PhotoMetadata.c"
}

static void
___lambda8__photo_metadata_set_generic_value (const gchar* tag,
                                              gpointer self)
{
#line 607 "../src/photos/PhotoMetadata.vala"
	__lambda8_ (self, tag);
#line 4689 "PhotoMetadata.c"
}

void
photo_metadata_set_all_date_time (PhotoMetadata* self,
                                  gchar** tags,
                                  gint tags_length1,
                                  MetadataDateTime* date_time,
                                  PhotoMetadataSetOption option)
{
	Block7Data* _data7_;
	MetadataDateTime* _tmp0_;
#line 606 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 606 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (date_time != NULL);
#line 606 "../src/photos/PhotoMetadata.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 606 "../src/photos/PhotoMetadata.vala"
	_data7_->_ref_count_ = 1;
#line 606 "../src/photos/PhotoMetadata.vala"
	_data7_->self = media_metadata_ref (self);
#line 606 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = _metadata_date_time_ref0 (date_time);
#line 606 "../src/photos/PhotoMetadata.vala"
	_metadata_date_time_unref0 (_data7_->date_time);
#line 606 "../src/photos/PhotoMetadata.vala"
	_data7_->date_time = _tmp0_;
#line 607 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, tags, (gint) tags_length1, option, ___lambda8__photo_metadata_set_generic_value, _data7_);
#line 606 "../src/photos/PhotoMetadata.vala"
	block7_data_unref (_data7_);
#line 606 "../src/photos/PhotoMetadata.vala"
	_data7_ = NULL;
#line 4723 "PhotoMetadata.c"
}

guint8*
photo_metadata_flatten_exif (PhotoMetadata* self,
                             gboolean include_preview,
                             gint* result_length1)
{
	guint8* result = NULL;
	ExifData* _tmp0_;
	guchar* thumbnail = NULL;
	ExifData* _tmp2_;
	guchar* _tmp3_;
	guint thumbnail_size = 0U;
	ExifData* _tmp4_;
	guint8* flattened = NULL;
	gint flattened_length1;
	gint _flattened_size_;
	guchar* saved_data = NULL;
	guint saved_size = 0U;
	ExifData* _tmp7_;
	gboolean _tmp8_ = FALSE;
	ExifData* _tmp16_;
	guchar* _tmp17_;
	ExifData* _tmp18_;
	guint8* _tmp19_;
	gint _tmp19__length1;
#line 613 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 614 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exif;
#line 614 "../src/photos/PhotoMetadata.vala"
	if (_tmp0_ == NULL) {
#line 4756 "PhotoMetadata.c"
		guint8* _tmp1_;
		gint _tmp1__length1;
#line 615 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = NULL;
#line 615 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = 0;
#line 615 "../src/photos/PhotoMetadata.vala"
		if (result_length1) {
#line 615 "../src/photos/PhotoMetadata.vala"
			*result_length1 = _tmp1__length1;
#line 4767 "PhotoMetadata.c"
		}
#line 615 "../src/photos/PhotoMetadata.vala"
		result = _tmp1_;
#line 615 "../src/photos/PhotoMetadata.vala"
		return result;
#line 4773 "PhotoMetadata.c"
	}
#line 619 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->exif;
#line 619 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_->data;
#line 619 "../src/photos/PhotoMetadata.vala"
	thumbnail = _tmp3_;
#line 620 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = self->priv->exif;
#line 620 "../src/photos/PhotoMetadata.vala"
	thumbnail_size = _tmp4_->size;
#line 621 "../src/photos/PhotoMetadata.vala"
	if (!include_preview) {
#line 4787 "PhotoMetadata.c"
		ExifData* _tmp5_;
		ExifData* _tmp6_;
#line 622 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = self->priv->exif;
#line 622 "../src/photos/PhotoMetadata.vala"
		_tmp5_->data = NULL;
#line 623 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->exif;
#line 623 "../src/photos/PhotoMetadata.vala"
		_tmp6_->size = (guint) 0;
#line 4798 "PhotoMetadata.c"
	}
#line 626 "../src/photos/PhotoMetadata.vala"
	flattened = NULL;
#line 626 "../src/photos/PhotoMetadata.vala"
	flattened_length1 = 0;
#line 626 "../src/photos/PhotoMetadata.vala"
	_flattened_size_ = flattened_length1;
#line 629 "../src/photos/PhotoMetadata.vala"
	saved_data = NULL;
#line 630 "../src/photos/PhotoMetadata.vala"
	saved_size = (guint) 0;
#line 631 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = self->priv->exif;
#line 631 "../src/photos/PhotoMetadata.vala"
	exif_data_save_data (_tmp7_, &saved_data, &saved_size);
#line 632 "../src/photos/PhotoMetadata.vala"
	if (saved_size > ((guint) 0)) {
#line 4816 "PhotoMetadata.c"
		guchar* _tmp9_;
#line 632 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = saved_data;
#line 632 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = _tmp9_ != NULL;
#line 4822 "PhotoMetadata.c"
	} else {
#line 632 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = FALSE;
#line 4826 "PhotoMetadata.c"
	}
#line 632 "../src/photos/PhotoMetadata.vala"
	if (_tmp8_) {
#line 4830 "PhotoMetadata.c"
		guint8* _tmp10_;
		guint8* _tmp11_;
		gint _tmp11__length1;
		guchar* _tmp12_;
		ExifMem* _tmp13_;
		ExifMem* _tmp14_;
		guchar* _tmp15_;
#line 633 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = g_new0 (guint8, saved_size);
#line 633 "../src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 633 "../src/photos/PhotoMetadata.vala"
		flattened = _tmp10_;
#line 633 "../src/photos/PhotoMetadata.vala"
		flattened_length1 = saved_size;
#line 633 "../src/photos/PhotoMetadata.vala"
		_flattened_size_ = flattened_length1;
#line 634 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = flattened;
#line 634 "../src/photos/PhotoMetadata.vala"
		_tmp11__length1 = flattened_length1;
#line 634 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = saved_data;
#line 634 "../src/photos/PhotoMetadata.vala"
		memcpy (_tmp11_, _tmp12_, (gsize) saved_size);
#line 636 "../src/photos/PhotoMetadata.vala"
		_tmp13_ = exif_mem_new_default ();
#line 636 "../src/photos/PhotoMetadata.vala"
		_tmp14_ = _tmp13_;
#line 636 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = saved_data;
#line 636 "../src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp14_, _tmp15_);
#line 636 "../src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp14_);
#line 4866 "PhotoMetadata.c"
	}
#line 640 "../src/photos/PhotoMetadata.vala"
	_tmp16_ = self->priv->exif;
#line 640 "../src/photos/PhotoMetadata.vala"
	_tmp17_ = thumbnail;
#line 640 "../src/photos/PhotoMetadata.vala"
	_tmp16_->data = _tmp17_;
#line 641 "../src/photos/PhotoMetadata.vala"
	_tmp18_ = self->priv->exif;
#line 641 "../src/photos/PhotoMetadata.vala"
	_tmp18_->size = thumbnail_size;
#line 643 "../src/photos/PhotoMetadata.vala"
	_tmp19_ = flattened;
#line 643 "../src/photos/PhotoMetadata.vala"
	_tmp19__length1 = flattened_length1;
#line 643 "../src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 643 "../src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp19__length1;
#line 4886 "PhotoMetadata.c"
	}
#line 643 "../src/photos/PhotoMetadata.vala"
	result = _tmp19_;
#line 643 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4892 "PhotoMetadata.c"
}

static guint8*
_vala_array_dup20 (guint8* self,
                   int length)
{
#line 649 "../src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 4901 "PhotoMetadata.c"
}

guint8*
photo_metadata_flatten_exif_preview (PhotoMetadata* self,
                                     gint* result_length1)
{
	guint8* result = NULL;
	guchar* buffer = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	guchar* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint __tmp0__size_ = 0;
	GExiv2Metadata* _tmp1_;
	guint8* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	guint8* _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	gint _tmp7__length1;
#line 647 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 649 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 649 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_exif_thumbnail (_tmp1_, &_tmp2_, &_tmp3_);
#line 649 "../src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 649 "../src/photos/PhotoMetadata.vala"
	buffer = _tmp2_;
#line 649 "../src/photos/PhotoMetadata.vala"
	buffer_length1 = _tmp3_;
#line 649 "../src/photos/PhotoMetadata.vala"
	_buffer_size_ = buffer_length1;
#line 649 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 4939 "PhotoMetadata.c"
		guchar* _tmp5_;
		gint _tmp5__length1;
#line 649 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = buffer;
#line 649 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = buffer_length1;
#line 649 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp5_;
#line 649 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = _tmp5__length1;
#line 649 "../src/photos/PhotoMetadata.vala"
		__tmp0__size_ = _tmp0__length1;
#line 4952 "PhotoMetadata.c"
	} else {
#line 649 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = NULL;
#line 649 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = 0;
#line 649 "../src/photos/PhotoMetadata.vala"
		__tmp0__size_ = _tmp0__length1;
#line 4960 "PhotoMetadata.c"
	}
#line 649 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = (_tmp0_ != NULL) ? _vala_array_dup20 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
#line 649 "../src/photos/PhotoMetadata.vala"
	_tmp6__length1 = _tmp0__length1;
#line 649 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp6_;
#line 649 "../src/photos/PhotoMetadata.vala"
	_tmp7__length1 = _tmp6__length1;
#line 649 "../src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 649 "../src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp7__length1;
#line 4974 "PhotoMetadata.c"
	}
#line 649 "../src/photos/PhotoMetadata.vala"
	result = _tmp7_;
#line 649 "../src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 649 "../src/photos/PhotoMetadata.vala"
	return result;
#line 4982 "PhotoMetadata.c"
}

guint
photo_metadata_get_preview_count (PhotoMetadata* self)
{
	guint result = 0U;
	GExiv2PreviewProperties** props = NULL;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	gint props_length1;
	gint _props_size_;
	gint _tmp3_ = 0;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
#line 652 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 653 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 653 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 653 "../src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 653 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 653 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 655 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 655 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 655 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 5016 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
#line 655 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 655 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 655 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5__length1;
#line 5025 "PhotoMetadata.c"
	} else {
#line 655 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = 0;
#line 5029 "PhotoMetadata.c"
	}
#line 655 "../src/photos/PhotoMetadata.vala"
	result = (guint) _tmp3_;
#line 655 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5035 "PhotoMetadata.c"
}

PhotoPreview*
photo_metadata_get_preview (PhotoMetadata* self,
                            guint number)
{
	PhotoPreview* result = NULL;
	GExiv2PreviewProperties** props = NULL;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp3_ = FALSE;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp6_;
	GExiv2PreviewProperties** _tmp7_;
	gint _tmp7__length1;
	GExiv2PreviewProperties* _tmp8_;
	PhotoMetadataInternalPhotoPreview* _tmp9_;
#line 659 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 660 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 660 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 660 "../src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 660 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 660 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 661 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 661 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 661 "../src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 661 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 5077 "PhotoMetadata.c"
	} else {
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
#line 661 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 661 "../src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 661 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = ((guint) _tmp5__length1) <= number;
#line 5087 "PhotoMetadata.c"
	}
#line 661 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 662 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 662 "../src/photos/PhotoMetadata.vala"
		return result;
#line 5095 "PhotoMetadata.c"
	}
#line 664 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = self->priv->source_name;
#line 664 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = props;
#line 664 "../src/photos/PhotoMetadata.vala"
	_tmp7__length1 = props_length1;
#line 664 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp7_[number];
#line 664 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = photo_metadata_internal_photo_preview_new (self, _tmp6_, number, _tmp8_);
#line 664 "../src/photos/PhotoMetadata.vala"
	result = (PhotoPreview*) _tmp9_;
#line 664 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5111 "PhotoMetadata.c"
}

void
photo_metadata_remove_exif_thumbnail (PhotoMetadata* self)
{
	GExiv2Metadata* _tmp0_;
	ExifData* _tmp1_;
#line 667 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 668 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 668 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_erase_exif_thumbnail (_tmp0_);
#line 669 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exif;
#line 669 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ != NULL) {
#line 5129 "PhotoMetadata.c"
		ExifMem* _tmp2_;
		ExifMem* _tmp3_;
		ExifData* _tmp4_;
		guchar* _tmp5_;
		ExifData* _tmp6_;
		ExifData* _tmp7_;
#line 670 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = exif_mem_new_default ();
#line 670 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_;
#line 670 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = self->priv->exif;
#line 670 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_->data;
#line 670 "../src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp3_, _tmp5_);
#line 670 "../src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp3_);
#line 671 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->exif;
#line 671 "../src/photos/PhotoMetadata.vala"
		_tmp6_->data = NULL;
#line 672 "../src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->exif;
#line 672 "../src/photos/PhotoMetadata.vala"
		_tmp7_->size = (guint) 0;
#line 5156 "PhotoMetadata.c"
	}
}

void
photo_metadata_remove_tag (PhotoMetadata* self,
                           const gchar* tag)
{
	GExiv2Metadata* _tmp0_;
#line 676 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 676 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 677 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 677 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear_tag (_tmp0_, tag);
#line 5173 "PhotoMetadata.c"
}

void
photo_metadata_remove_tags (PhotoMetadata* self,
                            gchar** tags,
                            gint tags_length1)
{
#line 680 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 5183 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 681 "../src/photos/PhotoMetadata.vala"
		tag_collection = tags;
#line 681 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = tags_length1;
#line 681 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < tags_length1; tag_it = tag_it + 1) {
#line 5195 "PhotoMetadata.c"
			gchar* _tmp0_;
			gchar* tag = NULL;
#line 681 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = g_strdup (tag_collection[tag_it]);
#line 681 "../src/photos/PhotoMetadata.vala"
			tag = _tmp0_;
#line 5202 "PhotoMetadata.c"
			{
				const gchar* _tmp1_;
#line 682 "../src/photos/PhotoMetadata.vala"
				_tmp1_ = tag;
#line 682 "../src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp1_);
#line 681 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 5211 "PhotoMetadata.c"
			}
		}
	}
}

void
photo_metadata_clear_domain (PhotoMetadata* self,
                             MetadataDomain domain)
{
#line 685 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 686 "../src/photos/PhotoMetadata.vala"
	switch (domain) {
#line 686 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 5227 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp0_;
#line 688 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = self->priv->exiv2;
#line 688 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_exif (_tmp0_);
#line 689 "../src/photos/PhotoMetadata.vala"
			break;
#line 5236 "PhotoMetadata.c"
		}
#line 686 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 5240 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 692 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 692 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_xmp (_tmp1_);
#line 693 "../src/photos/PhotoMetadata.vala"
			break;
#line 5249 "PhotoMetadata.c"
		}
#line 686 "../src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 5253 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 696 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 696 "../src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_iptc (_tmp2_);
#line 697 "../src/photos/PhotoMetadata.vala"
			break;
#line 5262 "PhotoMetadata.c"
		}
		default:
#line 686 "../src/photos/PhotoMetadata.vala"
		break;
#line 5267 "PhotoMetadata.c"
	}
}

void
photo_metadata_clear (PhotoMetadata* self)
{
	GExiv2Metadata* _tmp0_;
#line 701 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 702 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 702 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear (_tmp0_);
#line 5281 "PhotoMetadata.c"
}

MetadataDateTime*
photo_metadata_get_modification_date_time (PhotoMetadata* self)
{
	MetadataDateTime* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
#line 711 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 712 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DATE_TIME_TAGS;
#line 712 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 712 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 712 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 712 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5303 "PhotoMetadata.c"
}

void
photo_metadata_set_modification_date_time (PhotoMetadata* self,
                                           MetadataDateTime* date_time,
                                           PhotoMetadataSetOption option)
{
#line 715 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 717 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 5315 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 718 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_DATE_TIME_TAGS;
#line 718 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 718 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 5324 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 720 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DATE_TIME_TAGS;
#line 720 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 720 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 5334 "PhotoMetadata.c"
	}
}

MetadataDateTime*
photo_metadata_get_exposure_date_time (PhotoMetadata* self)
{
	MetadataDateTime* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
#line 732 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 733 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 733 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 733 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 733 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 733 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5357 "PhotoMetadata.c"
}

void
photo_metadata_set_exposure_date_time (PhotoMetadata* self,
                                       MetadataDateTime* date_time,
                                       PhotoMetadataSetOption option)
{
#line 736 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 738 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 5369 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 739 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 739 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 739 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 5378 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 741 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 741 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 741 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 5388 "PhotoMetadata.c"
	}
}

MetadataDateTime*
photo_metadata_get_digitized_date_time (PhotoMetadata* self)
{
	MetadataDateTime* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_;
#line 749 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 750 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 750 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 750 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, (gint) _tmp0__length1);
#line 750 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 750 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5411 "PhotoMetadata.c"
}

void
photo_metadata_set_digitized_date_time (PhotoMetadata* self,
                                        MetadataDateTime* date_time,
                                        PhotoMetadataSetOption option)
{
#line 753 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 755 "../src/photos/PhotoMetadata.vala"
	if (date_time != NULL) {
#line 5423 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 756 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 756 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 756 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp0_, (gint) _tmp0__length1, date_time, option);
#line 5432 "PhotoMetadata.c"
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 758 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 758 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 758 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 5442 "PhotoMetadata.c"
	}
}

static MetadataDateTime*
photo_metadata_real_get_creation_date_time (MediaMetadata* base)
{
	PhotoMetadata * self;
	MetadataDateTime* result = NULL;
	MetadataDateTime* creation = NULL;
	MetadataDateTime* _tmp0_;
	MetadataDateTime* _tmp1_;
#line 761 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 762 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_exposure_date_time (self);
#line 762 "../src/photos/PhotoMetadata.vala"
	creation = _tmp0_;
#line 763 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = creation;
#line 763 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 5464 "PhotoMetadata.c"
		MetadataDateTime* _tmp2_;
#line 764 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_get_digitized_date_time (self);
#line 764 "../src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (creation);
#line 764 "../src/photos/PhotoMetadata.vala"
		creation = _tmp2_;
#line 5472 "PhotoMetadata.c"
	}
#line 766 "../src/photos/PhotoMetadata.vala"
	result = creation;
#line 766 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5478 "PhotoMetadata.c"
}

static gpointer
_dimensions_dup0 (gpointer self)
{
#line 797 "../src/photos/PhotoMetadata.vala"
	return self ? dimensions_dup (self) : NULL;
#line 5486 "PhotoMetadata.c"
}

Dimensions*
photo_metadata_get_pixel_dimensions (PhotoMetadata* self)
{
	Dimensions* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 783 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 785 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_WIDTH_TAGS;
#line 785 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 785 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_HEIGHT_TAGS;
#line 785 "../src/photos/PhotoMetadata.vala"
	_tmp1__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 785 "../src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp0__length1 == _tmp1__length1, "WIDTH_TAGS.length == HEIGHT_TAGS.length");
#line 5509 "PhotoMetadata.c"
	{
		gint ctr = 0;
#line 786 "../src/photos/PhotoMetadata.vala"
		ctr = 0;
#line 5514 "PhotoMetadata.c"
		{
			gboolean _tmp2_ = FALSE;
#line 786 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = TRUE;
#line 786 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 5521 "PhotoMetadata.c"
				gchar** _tmp4_;
				gint _tmp4__length1;
				glong width = 0L;
				gchar** _tmp5_;
				gint _tmp5__length1;
				const gchar* _tmp6_;
				glong _tmp7_ = 0L;
				gboolean _tmp8_;
				glong height = 0L;
				gchar** _tmp9_;
				gint _tmp9__length1;
				const gchar* _tmp10_;
				glong _tmp11_ = 0L;
				gboolean _tmp12_;
				Dimensions _tmp13_ = {0};
				Dimensions* _tmp14_;
#line 786 "../src/photos/PhotoMetadata.vala"
				if (!_tmp2_) {
#line 5540 "PhotoMetadata.c"
					gint _tmp3_;
#line 786 "../src/photos/PhotoMetadata.vala"
					_tmp3_ = ctr;
#line 786 "../src/photos/PhotoMetadata.vala"
					ctr = _tmp3_ + 1;
#line 5546 "PhotoMetadata.c"
				}
#line 786 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = FALSE;
#line 786 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_WIDTH_TAGS;
#line 786 "../src/photos/PhotoMetadata.vala"
				_tmp4__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 786 "../src/photos/PhotoMetadata.vala"
				if (!(ctr < _tmp4__length1)) {
#line 786 "../src/photos/PhotoMetadata.vala"
					break;
#line 5558 "PhotoMetadata.c"
				}
#line 790 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = photo_metadata_WIDTH_TAGS;
#line 790 "../src/photos/PhotoMetadata.vala"
				_tmp5__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 790 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = _tmp5_[ctr];
#line 790 "../src/photos/PhotoMetadata.vala"
				_tmp8_ = photo_metadata_get_long (self, _tmp6_, &_tmp7_);
#line 790 "../src/photos/PhotoMetadata.vala"
				width = _tmp7_;
#line 790 "../src/photos/PhotoMetadata.vala"
				if (!_tmp8_) {
#line 791 "../src/photos/PhotoMetadata.vala"
					continue;
#line 5574 "PhotoMetadata.c"
				}
#line 794 "../src/photos/PhotoMetadata.vala"
				_tmp9_ = photo_metadata_HEIGHT_TAGS;
#line 794 "../src/photos/PhotoMetadata.vala"
				_tmp9__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 794 "../src/photos/PhotoMetadata.vala"
				_tmp10_ = _tmp9_[ctr];
#line 794 "../src/photos/PhotoMetadata.vala"
				_tmp12_ = photo_metadata_get_long (self, _tmp10_, &_tmp11_);
#line 794 "../src/photos/PhotoMetadata.vala"
				height = _tmp11_;
#line 794 "../src/photos/PhotoMetadata.vala"
				if (!_tmp12_) {
#line 795 "../src/photos/PhotoMetadata.vala"
					continue;
#line 5590 "PhotoMetadata.c"
				}
#line 797 "../src/photos/PhotoMetadata.vala"
				dimensions_init (&_tmp13_, (gint) width, (gint) height);
#line 797 "../src/photos/PhotoMetadata.vala"
				_tmp14_ = _dimensions_dup0 (&_tmp13_);
#line 797 "../src/photos/PhotoMetadata.vala"
				result = _tmp14_;
#line 797 "../src/photos/PhotoMetadata.vala"
				return result;
#line 5600 "PhotoMetadata.c"
			}
		}
	}
#line 800 "../src/photos/PhotoMetadata.vala"
	result = NULL;
#line 800 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5608 "PhotoMetadata.c"
}

void
photo_metadata_set_pixel_dimensions (PhotoMetadata* self,
                                     Dimensions* dim,
                                     PhotoMetadataSetOption option)
{
#line 803 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 804 "../src/photos/PhotoMetadata.vala"
	if (dim != NULL) {
#line 5620 "PhotoMetadata.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 805 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = photo_metadata_WIDTH_TAGS;
#line 805 "../src/photos/PhotoMetadata.vala"
		_tmp0__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 805 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp0_, (gint) _tmp0__length1, (glong) (*dim).width, option);
#line 806 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_HEIGHT_TAGS;
#line 806 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 806 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp1_, (gint) _tmp1__length1, (glong) (*dim).height, option);
#line 5637 "PhotoMetadata.c"
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar** _tmp3_;
		gint _tmp3__length1;
#line 808 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_WIDTH_TAGS;
#line 808 "../src/photos/PhotoMetadata.vala"
		_tmp2__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 808 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp2_, (gint) _tmp2__length1);
#line 809 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = photo_metadata_HEIGHT_TAGS;
#line 809 "../src/photos/PhotoMetadata.vala"
		_tmp3__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 809 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp3_, (gint) _tmp3__length1);
#line 5655 "PhotoMetadata.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 5680 "PhotoMetadata.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 5699 "PhotoMetadata.c"
}

static gchar*
photo_metadata_real_get_title (MediaMetadata* base)
{
	PhotoMetadata * self;
	gchar* result = NULL;
	GeeList* _tmp0_ = NULL;
	GeeList* titles = NULL;
	GeeList* _tmp4_;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GeeList* _tmp7_;
	gchar* title = NULL;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	const gchar* _tmp20_;
	gchar* _tmp24_;
#line 842 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 850 "../src/photos/PhotoMetadata.vala"
	if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 5725 "PhotoMetadata.c"
		GeeList* _tmp1_;
#line 851 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_get_string_multiple (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 851 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 851 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp1_;
#line 5733 "PhotoMetadata.c"
	} else {
		gchar** _tmp2_;
		gint _tmp2__length1;
		GeeList* _tmp3_;
#line 852 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 852 "../src/photos/PhotoMetadata.vala"
		_tmp2__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 852 "../src/photos/PhotoMetadata.vala"
		_tmp3_ = photo_metadata_get_first_string_multiple (self, _tmp2_, (gint) _tmp2__length1);
#line 852 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 852 "../src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp3_;
#line 5748 "PhotoMetadata.c"
	}
#line 850 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = _g_object_ref0 (_tmp0_);
#line 850 "../src/photos/PhotoMetadata.vala"
	titles = _tmp4_;
#line 857 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = titles;
#line 857 "../src/photos/PhotoMetadata.vala"
	if (_tmp7_ != NULL) {
#line 5758 "PhotoMetadata.c"
		GeeList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 857 "../src/photos/PhotoMetadata.vala"
		_tmp8_ = titles;
#line 857 "../src/photos/PhotoMetadata.vala"
		_tmp9_ = gee_collection_get_size ((GeeCollection*) _tmp8_);
#line 857 "../src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp9_;
#line 857 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp10_ > 0;
#line 5770 "PhotoMetadata.c"
	} else {
#line 857 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = FALSE;
#line 5774 "PhotoMetadata.c"
	}
#line 857 "../src/photos/PhotoMetadata.vala"
	if (_tmp6_) {
#line 5778 "PhotoMetadata.c"
		GeeList* _tmp11_;
		gpointer _tmp12_;
#line 857 "../src/photos/PhotoMetadata.vala"
		_tmp11_ = titles;
#line 857 "../src/photos/PhotoMetadata.vala"
		_tmp12_ = gee_list_get (_tmp11_, 0);
#line 857 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp5_);
#line 857 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = (gchar*) _tmp12_;
#line 5789 "PhotoMetadata.c"
	} else {
#line 857 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp5_);
#line 857 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = NULL;
#line 5795 "PhotoMetadata.c"
	}
#line 857 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = g_strdup (_tmp5_);
#line 857 "../src/photos/PhotoMetadata.vala"
	title = _tmp13_;
#line 860 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = title;
#line 860 "../src/photos/PhotoMetadata.vala"
	if (_tmp14_ != NULL) {
#line 5805 "PhotoMetadata.c"
		const gchar* _tmp15_;
		gchar* _tmp16_;
#line 861 "../src/photos/PhotoMetadata.vala"
		_tmp15_ = title;
#line 861 "../src/photos/PhotoMetadata.vala"
		_tmp16_ = string_strip (_tmp15_);
#line 861 "../src/photos/PhotoMetadata.vala"
		_g_free0 (title);
#line 861 "../src/photos/PhotoMetadata.vala"
		title = _tmp16_;
#line 5816 "PhotoMetadata.c"
	}
#line 864 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = title;
#line 864 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (_tmp20_)) {
#line 5822 "PhotoMetadata.c"
		const gchar* _tmp21_;
#line 864 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = title;
#line 864 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = !string_contains (_tmp21_, "\n");
#line 5828 "PhotoMetadata.c"
	} else {
#line 864 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = FALSE;
#line 5832 "PhotoMetadata.c"
	}
#line 864 "../src/photos/PhotoMetadata.vala"
	if (_tmp19_) {
#line 5836 "PhotoMetadata.c"
		const gchar* _tmp22_;
#line 864 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = title;
#line 864 "../src/photos/PhotoMetadata.vala"
		_tmp18_ = !string_contains (_tmp22_, "\r");
#line 5842 "PhotoMetadata.c"
	} else {
#line 864 "../src/photos/PhotoMetadata.vala"
		_tmp18_ = FALSE;
#line 5846 "PhotoMetadata.c"
	}
#line 864 "../src/photos/PhotoMetadata.vala"
	if (_tmp18_) {
#line 5850 "PhotoMetadata.c"
		const gchar* _tmp23_;
#line 865 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = title;
#line 865 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = _tmp23_;
#line 5856 "PhotoMetadata.c"
	} else {
#line 865 "../src/photos/PhotoMetadata.vala"
		_tmp17_ = NULL;
#line 5860 "PhotoMetadata.c"
	}
#line 864 "../src/photos/PhotoMetadata.vala"
	_tmp24_ = g_strdup (_tmp17_);
#line 864 "../src/photos/PhotoMetadata.vala"
	result = _tmp24_;
#line 864 "../src/photos/PhotoMetadata.vala"
	_g_free0 (title);
#line 864 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp5_);
#line 864 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (titles);
#line 864 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_tmp0_);
#line 864 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5876 "PhotoMetadata.c"
}

void
photo_metadata_set_title (PhotoMetadata* self,
                          const gchar* title,
                          PhotoMetadataSetOption option)
{
#line 868 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 869 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (title)) {
#line 870 "../src/photos/PhotoMetadata.vala"
		if (photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG)) {
#line 871 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_TITLE_TAG, title, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 5892 "PhotoMetadata.c"
		} else {
			gchar** _tmp0_;
			gint _tmp0__length1;
#line 873 "../src/photos/PhotoMetadata.vala"
			_tmp0_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 873 "../src/photos/PhotoMetadata.vala"
			_tmp0__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 873 "../src/photos/PhotoMetadata.vala"
			photo_metadata_set_all_string (self, _tmp0_, (gint) _tmp0__length1, title, option);
#line 5902 "PhotoMetadata.c"
		}
	} else {
		gchar** _tmp1_;
		gint _tmp1__length1;
#line 875 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 875 "../src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 875 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp1_, (gint) _tmp1__length1);
#line 5913 "PhotoMetadata.c"
	}
}

static gchar*
photo_metadata_real_get_comment (MediaMetadata* base)
{
	PhotoMetadata * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 879 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) base;
#line 880 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.UserComment", PREPARE_INPUT_TEXT_OPTIONS_DEFAULT & (~PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF));
#line 880 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 880 "../src/photos/PhotoMetadata.vala"
	return result;
#line 5931 "PhotoMetadata.c"
}

void
photo_metadata_set_comment (PhotoMetadata* self,
                            const gchar* comment)
{
#line 883 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 884 "../src/photos/PhotoMetadata.vala"
	if (!is_string_empty (comment)) {
#line 885 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Exif.Photo.UserComment", comment, PREPARE_INPUT_TEXT_OPTIONS_DEFAULT & (~PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF));
#line 5944 "PhotoMetadata.c"
	} else {
#line 887 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tag (self, "Exif.Photo.UserComment");
#line 5948 "PhotoMetadata.c"
	}
}

GeeSet*
photo_metadata_get_keywords (PhotoMetadata* self,
                             GCompareDataFunc compare_func,
                             gpointer compare_func_target,
                             GDestroyNotify compare_func_target_destroy_notify)
{
	GeeSet* result = NULL;
	GeeSet* keywords = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GeeSet* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
	GeeSet* _tmp23_;
	GeeSet* _tmp28_;
#line 901 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 902 "../src/photos/PhotoMetadata.vala"
	keywords = NULL;
#line 903 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_KEYWORD_TAGS;
#line 903 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 5974 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 903 "../src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 903 "../src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 903 "../src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 5986 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 903 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 903 "../src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 5993 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				const gchar* _tmp2_;
				GeeList* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeCollection* _tmp5_;
#line 904 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 904 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_multiple (self, _tmp2_);
#line 904 "../src/photos/PhotoMetadata.vala"
				values = (GeeCollection*) _tmp3_;
#line 905 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = values;
#line 905 "../src/photos/PhotoMetadata.vala"
				if (_tmp5_ != NULL) {
#line 6010 "PhotoMetadata.c"
					GeeCollection* _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
#line 905 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = values;
#line 905 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = gee_collection_get_size (_tmp6_);
#line 905 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = _tmp7_;
#line 905 "../src/photos/PhotoMetadata.vala"
					_tmp4_ = _tmp8_ > 0;
#line 6022 "PhotoMetadata.c"
				} else {
#line 905 "../src/photos/PhotoMetadata.vala"
					_tmp4_ = FALSE;
#line 6026 "PhotoMetadata.c"
				}
#line 905 "../src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 6030 "PhotoMetadata.c"
					GeeSet* _tmp9_;
#line 906 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = keywords;
#line 906 "../src/photos/PhotoMetadata.vala"
					if (_tmp9_ == NULL) {
#line 6036 "PhotoMetadata.c"
						GCompareDataFunc _tmp10_;
						gpointer _tmp10__target;
						GDestroyNotify _tmp10__target_destroy_notify;
						GeeSet* _tmp11_;
#line 907 "../src/photos/PhotoMetadata.vala"
						_tmp10_ = compare_func;
#line 907 "../src/photos/PhotoMetadata.vala"
						_tmp10__target = compare_func_target;
#line 907 "../src/photos/PhotoMetadata.vala"
						_tmp10__target_destroy_notify = compare_func_target_destroy_notify;
#line 907 "../src/photos/PhotoMetadata.vala"
						compare_func = NULL;
#line 907 "../src/photos/PhotoMetadata.vala"
						compare_func_target = NULL;
#line 907 "../src/photos/PhotoMetadata.vala"
						compare_func_target_destroy_notify = NULL;
#line 907 "../src/photos/PhotoMetadata.vala"
						_tmp11_ = photo_metadata_create_string_set (self, _tmp10_, _tmp10__target, _tmp10__target_destroy_notify);
#line 907 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (keywords);
#line 907 "../src/photos/PhotoMetadata.vala"
						keywords = _tmp11_;
#line 6059 "PhotoMetadata.c"
					}
					{
						GeeIterator* _current_value_it = NULL;
						GeeCollection* _tmp12_;
						GeeIterator* _tmp13_;
#line 909 "../src/photos/PhotoMetadata.vala"
						_tmp12_ = values;
#line 909 "../src/photos/PhotoMetadata.vala"
						_tmp13_ = gee_iterable_iterator ((GeeIterable*) _tmp12_);
#line 909 "../src/photos/PhotoMetadata.vala"
						_current_value_it = _tmp13_;
#line 909 "../src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 6073 "PhotoMetadata.c"
							GeeIterator* _tmp14_;
							gchar* current_value = NULL;
							GeeIterator* _tmp15_;
							gpointer _tmp16_;
							GeeSet* _tmp17_;
							const gchar* _tmp18_;
							gchar* _tmp19_;
							gchar* _tmp20_;
#line 909 "../src/photos/PhotoMetadata.vala"
							_tmp14_ = _current_value_it;
#line 909 "../src/photos/PhotoMetadata.vala"
							if (!gee_iterator_next (_tmp14_)) {
#line 909 "../src/photos/PhotoMetadata.vala"
								break;
#line 6088 "PhotoMetadata.c"
							}
#line 909 "../src/photos/PhotoMetadata.vala"
							_tmp15_ = _current_value_it;
#line 909 "../src/photos/PhotoMetadata.vala"
							_tmp16_ = gee_iterator_get (_tmp15_);
#line 909 "../src/photos/PhotoMetadata.vala"
							current_value = (gchar*) _tmp16_;
#line 910 "../src/photos/PhotoMetadata.vala"
							_tmp17_ = keywords;
#line 910 "../src/photos/PhotoMetadata.vala"
							_tmp18_ = current_value;
#line 910 "../src/photos/PhotoMetadata.vala"
							_tmp19_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp18_);
#line 910 "../src/photos/PhotoMetadata.vala"
							_tmp20_ = _tmp19_;
#line 910 "../src/photos/PhotoMetadata.vala"
							gee_collection_add ((GeeCollection*) _tmp17_, _tmp20_);
#line 910 "../src/photos/PhotoMetadata.vala"
							_g_free0 (_tmp20_);
#line 909 "../src/photos/PhotoMetadata.vala"
							_g_free0 (current_value);
#line 6110 "PhotoMetadata.c"
						}
#line 909 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_current_value_it);
#line 6114 "PhotoMetadata.c"
					}
				}
#line 903 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 903 "../src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 6121 "PhotoMetadata.c"
			}
		}
	}
#line 914 "../src/photos/PhotoMetadata.vala"
	_tmp23_ = keywords;
#line 914 "../src/photos/PhotoMetadata.vala"
	if (_tmp23_ != NULL) {
#line 6129 "PhotoMetadata.c"
		GeeSet* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = keywords;
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = gee_collection_get_size ((GeeCollection*) _tmp24_);
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = _tmp25_;
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp26_ > 0;
#line 6141 "PhotoMetadata.c"
	} else {
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = FALSE;
#line 6145 "PhotoMetadata.c"
	}
#line 914 "../src/photos/PhotoMetadata.vala"
	if (_tmp22_) {
#line 6149 "PhotoMetadata.c"
		GeeSet* _tmp27_;
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp27_ = keywords;
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = _tmp27_;
#line 6155 "PhotoMetadata.c"
	} else {
#line 914 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = NULL;
#line 6159 "PhotoMetadata.c"
	}
#line 914 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = _g_object_ref0 (_tmp21_);
#line 914 "../src/photos/PhotoMetadata.vala"
	result = _tmp28_;
#line 914 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (keywords);
#line 914 "../src/photos/PhotoMetadata.vala"
	(compare_func_target_destroy_notify == NULL) ? NULL : (compare_func_target_destroy_notify (compare_func_target), NULL);
#line 914 "../src/photos/PhotoMetadata.vala"
	compare_func = NULL;
#line 914 "../src/photos/PhotoMetadata.vala"
	compare_func_target = NULL;
#line 914 "../src/photos/PhotoMetadata.vala"
	compare_func_target_destroy_notify = NULL;
#line 914 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6177 "PhotoMetadata.c"
}

static gpointer
_hierarchical_keyword_field_ref0 (gpointer self)
{
#line 918 "../src/photos/PhotoMetadata.vala"
	return self ? hierarchical_keyword_field_ref (self) : NULL;
#line 6185 "PhotoMetadata.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 6207 "PhotoMetadata.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 6211 "PhotoMetadata.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 6217 "PhotoMetadata.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 6221 "PhotoMetadata.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 6225 "PhotoMetadata.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 6233 "PhotoMetadata.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 6261 "PhotoMetadata.c"
				goto __catch376_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 6270 "PhotoMetadata.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 6284 "PhotoMetadata.c"
				goto __catch376_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 6295 "PhotoMetadata.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 6309 "PhotoMetadata.c"
	}
	goto __finally376;
	__catch376_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1481 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 6323 "PhotoMetadata.c"
	}
	__finally376:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 6334 "PhotoMetadata.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "glib-2.0.vapi"
		result = maxlen;
#line 1394 "glib-2.0.vapi"
		return result;
#line 6358 "PhotoMetadata.c"
	} else {
		gchar* _tmp2_;
#line 1396 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "glib-2.0.vapi"
		return result;
#line 6367 "PhotoMetadata.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1403 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 6386 "PhotoMetadata.c"
	} else {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 6390 "PhotoMetadata.c"
	}
#line 1405 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 6396 "PhotoMetadata.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 6406 "PhotoMetadata.c"
	}
#line 1412 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1413 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1414 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 6414 "PhotoMetadata.c"
	} else {
#line 1416 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 6418 "PhotoMetadata.c"
	}
#line 1418 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1419 "glib-2.0.vapi"
		len = string_length - offset;
#line 6424 "PhotoMetadata.c"
	}
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1422 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "glib-2.0.vapi"
	result = _tmp3_;
#line 1422 "glib-2.0.vapi"
	return result;
#line 6434 "PhotoMetadata.c"
}

static void
photo_metadata_internal_set_hierarchical_keywords (PhotoMetadata* self,
                                                   HierarchicalTagIndex* index)
{
	HierarchicalKeywordField** _tmp0_;
	gint _tmp0__length1;
	HierarchicalKeywordField** _tmp4_;
	gint _tmp4__length1;
#line 917 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 918 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 918 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 6451 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 918 "../src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp0_;
#line 918 "../src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp0__length1;
#line 918 "../src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < _tmp0__length1; current_field_it = current_field_it + 1) {
#line 6463 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_;
			HierarchicalKeywordField* current_field = NULL;
#line 918 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 918 "../src/photos/PhotoMetadata.vala"
			current_field = _tmp1_;
#line 6470 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp2_;
				const gchar* _tmp3_;
#line 919 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = current_field;
#line 919 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 919 "../src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp3_);
#line 918 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 6482 "PhotoMetadata.c"
			}
		}
	}
#line 921 "../src/photos/PhotoMetadata.vala"
	if (index == NULL) {
#line 922 "../src/photos/PhotoMetadata.vala"
		return;
#line 6490 "PhotoMetadata.c"
	}
#line 924 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 924 "../src/photos/PhotoMetadata.vala"
	_tmp4__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 6496 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** current_field_collection = NULL;
		gint current_field_collection_length1 = 0;
		gint _current_field_collection_size_ = 0;
		gint current_field_it = 0;
#line 924 "../src/photos/PhotoMetadata.vala"
		current_field_collection = _tmp4_;
#line 924 "../src/photos/PhotoMetadata.vala"
		current_field_collection_length1 = _tmp4__length1;
#line 924 "../src/photos/PhotoMetadata.vala"
		for (current_field_it = 0; current_field_it < _tmp4__length1; current_field_it = current_field_it + 1) {
#line 6508 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp5_;
			HierarchicalKeywordField* current_field = NULL;
#line 924 "../src/photos/PhotoMetadata.vala"
			_tmp5_ = _hierarchical_keyword_field_ref0 (current_field_collection[current_field_it]);
#line 924 "../src/photos/PhotoMetadata.vala"
			current_field = _tmp5_;
#line 6515 "PhotoMetadata.c"
			{
				HierarchicalKeywordField* _tmp6_;
				GeeSet* writeable_set = NULL;
				GeeTreeSet* _tmp7_;
				HierarchicalKeywordField* _tmp24_;
				const gchar* _tmp25_;
				GeeSet* _tmp26_;
#line 925 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = current_field;
#line 925 "../src/photos/PhotoMetadata.vala"
				if (!_tmp6_->is_writeable) {
#line 926 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (current_field);
#line 926 "../src/photos/PhotoMetadata.vala"
					continue;
#line 6531 "PhotoMetadata.c"
				}
#line 928 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 928 "../src/photos/PhotoMetadata.vala"
				writeable_set = (GeeSet*) _tmp7_;
#line 6537 "PhotoMetadata.c"
				{
					GeeIterator* _current_path_it = NULL;
					GeeCollection* _tmp8_;
					GeeCollection* _tmp9_;
					GeeIterator* _tmp10_;
					GeeIterator* _tmp11_;
#line 930 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = hierarchical_tag_index_get_all_paths (index);
#line 930 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = _tmp8_;
#line 930 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 930 "../src/photos/PhotoMetadata.vala"
					_tmp11_ = _tmp10_;
#line 930 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_tmp9_);
#line 930 "../src/photos/PhotoMetadata.vala"
					_current_path_it = _tmp11_;
#line 930 "../src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 6558 "PhotoMetadata.c"
						GeeIterator* _tmp12_;
						gchar* current_path = NULL;
						GeeIterator* _tmp13_;
						gpointer _tmp14_;
						gchar* writeable_path = NULL;
						const gchar* _tmp15_;
						HierarchicalKeywordField* _tmp16_;
						const gchar* _tmp17_;
						gchar* _tmp18_;
						HierarchicalKeywordField* _tmp19_;
						GeeSet* _tmp22_;
						const gchar* _tmp23_;
#line 930 "../src/photos/PhotoMetadata.vala"
						_tmp12_ = _current_path_it;
#line 930 "../src/photos/PhotoMetadata.vala"
						if (!gee_iterator_next (_tmp12_)) {
#line 930 "../src/photos/PhotoMetadata.vala"
							break;
#line 6577 "PhotoMetadata.c"
						}
#line 930 "../src/photos/PhotoMetadata.vala"
						_tmp13_ = _current_path_it;
#line 930 "../src/photos/PhotoMetadata.vala"
						_tmp14_ = gee_iterator_get (_tmp13_);
#line 930 "../src/photos/PhotoMetadata.vala"
						current_path = (gchar*) _tmp14_;
#line 931 "../src/photos/PhotoMetadata.vala"
						_tmp15_ = current_path;
#line 931 "../src/photos/PhotoMetadata.vala"
						_tmp16_ = current_field;
#line 931 "../src/photos/PhotoMetadata.vala"
						_tmp17_ = _tmp16_->path_separator;
#line 931 "../src/photos/PhotoMetadata.vala"
						_tmp18_ = string_replace (_tmp15_, TAG_PATH_SEPARATOR_STRING, _tmp17_);
#line 931 "../src/photos/PhotoMetadata.vala"
						writeable_path = _tmp18_;
#line 933 "../src/photos/PhotoMetadata.vala"
						_tmp19_ = current_field;
#line 933 "../src/photos/PhotoMetadata.vala"
						if (!_tmp19_->wants_leading_separator) {
#line 6599 "PhotoMetadata.c"
							const gchar* _tmp20_;
							gchar* _tmp21_;
#line 934 "../src/photos/PhotoMetadata.vala"
							_tmp20_ = writeable_path;
#line 934 "../src/photos/PhotoMetadata.vala"
							_tmp21_ = string_substring (_tmp20_, (glong) 1, (glong) -1);
#line 934 "../src/photos/PhotoMetadata.vala"
							_g_free0 (writeable_path);
#line 934 "../src/photos/PhotoMetadata.vala"
							writeable_path = _tmp21_;
#line 6610 "PhotoMetadata.c"
						}
#line 936 "../src/photos/PhotoMetadata.vala"
						_tmp22_ = writeable_set;
#line 936 "../src/photos/PhotoMetadata.vala"
						_tmp23_ = writeable_path;
#line 936 "../src/photos/PhotoMetadata.vala"
						gee_collection_add ((GeeCollection*) _tmp22_, _tmp23_);
#line 930 "../src/photos/PhotoMetadata.vala"
						_g_free0 (writeable_path);
#line 930 "../src/photos/PhotoMetadata.vala"
						_g_free0 (current_path);
#line 6622 "PhotoMetadata.c"
					}
#line 930 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_path_it);
#line 6626 "PhotoMetadata.c"
				}
#line 939 "../src/photos/PhotoMetadata.vala"
				_tmp24_ = current_field;
#line 939 "../src/photos/PhotoMetadata.vala"
				_tmp25_ = _tmp24_->field_name;
#line 939 "../src/photos/PhotoMetadata.vala"
				_tmp26_ = writeable_set;
#line 939 "../src/photos/PhotoMetadata.vala"
				photo_metadata_set_string_multiple (self, _tmp25_, (GeeCollection*) _tmp26_);
#line 924 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (writeable_set);
#line 924 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (current_field);
#line 6640 "PhotoMetadata.c"
			}
		}
	}
}

void
photo_metadata_set_keywords (PhotoMetadata* self,
                             GeeCollection* keywords,
                             PhotoMetadataSetOption option)
{
	HierarchicalTagIndex* htag_index = NULL;
	HierarchicalTagIndex* _tmp0_;
	GeeSet* flat_keywords = NULL;
	GeeTreeSet* _tmp1_;
#line 943 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 944 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = hierarchical_tag_index_new ();
#line 944 "../src/photos/PhotoMetadata.vala"
	htag_index = _tmp0_;
#line 945 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 945 "../src/photos/PhotoMetadata.vala"
	flat_keywords = (GeeSet*) _tmp1_;
#line 947 "../src/photos/PhotoMetadata.vala"
	if (keywords != NULL) {
#line 6667 "PhotoMetadata.c"
		GeeSet* _tmp19_;
		HierarchicalTagIndex* _tmp20_;
		GeeCollection* _tmp21_;
		GeeCollection* _tmp22_;
		{
			GeeIterator* _keyword_it = NULL;
			GeeIterator* _tmp2_;
#line 948 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = gee_iterable_iterator ((GeeIterable*) keywords);
#line 948 "../src/photos/PhotoMetadata.vala"
			_keyword_it = _tmp2_;
#line 948 "../src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 6681 "PhotoMetadata.c"
				GeeIterator* _tmp3_;
				gchar* keyword = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				const gchar* _tmp6_;
#line 948 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _keyword_it;
#line 948 "../src/photos/PhotoMetadata.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 948 "../src/photos/PhotoMetadata.vala"
					break;
#line 6693 "PhotoMetadata.c"
				}
#line 948 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = _keyword_it;
#line 948 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 948 "../src/photos/PhotoMetadata.vala"
				keyword = (gchar*) _tmp5_;
#line 949 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = keyword;
#line 949 "../src/photos/PhotoMetadata.vala"
				if (g_str_has_prefix (_tmp6_, TAG_PATH_SEPARATOR_STRING)) {
#line 6705 "PhotoMetadata.c"
					GeeCollection* path_components = NULL;
					const gchar* _tmp7_;
					GeeList* _tmp8_;
#line 950 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = keyword;
#line 950 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = hierarchical_tag_utilities_enumerate_path_components (_tmp7_);
#line 950 "../src/photos/PhotoMetadata.vala"
					path_components = (GeeCollection*) _tmp8_;
#line 6715 "PhotoMetadata.c"
					{
						GeeIterator* _component_it = NULL;
						GeeCollection* _tmp9_;
						GeeIterator* _tmp10_;
#line 952 "../src/photos/PhotoMetadata.vala"
						_tmp9_ = path_components;
#line 952 "../src/photos/PhotoMetadata.vala"
						_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 952 "../src/photos/PhotoMetadata.vala"
						_component_it = _tmp10_;
#line 952 "../src/photos/PhotoMetadata.vala"
						while (TRUE) {
#line 6728 "PhotoMetadata.c"
							GeeIterator* _tmp11_;
							gchar* component = NULL;
							GeeIterator* _tmp12_;
							gpointer _tmp13_;
							HierarchicalTagIndex* _tmp14_;
							const gchar* _tmp15_;
							const gchar* _tmp16_;
#line 952 "../src/photos/PhotoMetadata.vala"
							_tmp11_ = _component_it;
#line 952 "../src/photos/PhotoMetadata.vala"
							if (!gee_iterator_next (_tmp11_)) {
#line 952 "../src/photos/PhotoMetadata.vala"
								break;
#line 6742 "PhotoMetadata.c"
							}
#line 952 "../src/photos/PhotoMetadata.vala"
							_tmp12_ = _component_it;
#line 952 "../src/photos/PhotoMetadata.vala"
							_tmp13_ = gee_iterator_get (_tmp12_);
#line 952 "../src/photos/PhotoMetadata.vala"
							component = (gchar*) _tmp13_;
#line 953 "../src/photos/PhotoMetadata.vala"
							_tmp14_ = htag_index;
#line 953 "../src/photos/PhotoMetadata.vala"
							_tmp15_ = component;
#line 953 "../src/photos/PhotoMetadata.vala"
							_tmp16_ = keyword;
#line 953 "../src/photos/PhotoMetadata.vala"
							hierarchical_tag_index_add_path (_tmp14_, _tmp15_, _tmp16_);
#line 952 "../src/photos/PhotoMetadata.vala"
							_g_free0 (component);
#line 6760 "PhotoMetadata.c"
						}
#line 952 "../src/photos/PhotoMetadata.vala"
						_g_object_unref0 (_component_it);
#line 6764 "PhotoMetadata.c"
					}
#line 949 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (path_components);
#line 6768 "PhotoMetadata.c"
				} else {
					GeeSet* _tmp17_;
					const gchar* _tmp18_;
#line 955 "../src/photos/PhotoMetadata.vala"
					_tmp17_ = flat_keywords;
#line 955 "../src/photos/PhotoMetadata.vala"
					_tmp18_ = keyword;
#line 955 "../src/photos/PhotoMetadata.vala"
					gee_collection_add ((GeeCollection*) _tmp17_, _tmp18_);
#line 6778 "PhotoMetadata.c"
				}
#line 948 "../src/photos/PhotoMetadata.vala"
				_g_free0 (keyword);
#line 6782 "PhotoMetadata.c"
			}
#line 948 "../src/photos/PhotoMetadata.vala"
			_g_object_unref0 (_keyword_it);
#line 6786 "PhotoMetadata.c"
		}
#line 959 "../src/photos/PhotoMetadata.vala"
		_tmp19_ = flat_keywords;
#line 959 "../src/photos/PhotoMetadata.vala"
		_tmp20_ = htag_index;
#line 959 "../src/photos/PhotoMetadata.vala"
		_tmp21_ = hierarchical_tag_index_get_all_tags (_tmp20_);
#line 959 "../src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp21_;
#line 959 "../src/photos/PhotoMetadata.vala"
		gee_collection_add_all ((GeeCollection*) _tmp19_, _tmp22_);
#line 959 "../src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp22_);
#line 6800 "PhotoMetadata.c"
	}
#line 962 "../src/photos/PhotoMetadata.vala"
	if (keywords != NULL) {
#line 6804 "PhotoMetadata.c"
		gchar** _tmp23_;
		gint _tmp23__length1;
		GeeSet* _tmp24_;
		HierarchicalTagIndex* _tmp25_;
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp23_ = photo_metadata_KEYWORD_TAGS;
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp23__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 963 "../src/photos/PhotoMetadata.vala"
		_tmp24_ = flat_keywords;
#line 963 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_string_multiple (self, _tmp23_, (gint) _tmp23__length1, (GeeCollection*) _tmp24_, option);
#line 964 "../src/photos/PhotoMetadata.vala"
		_tmp25_ = htag_index;
#line 964 "../src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, _tmp25_);
#line 6821 "PhotoMetadata.c"
	} else {
		gchar** _tmp26_;
		gint _tmp26__length1;
#line 966 "../src/photos/PhotoMetadata.vala"
		_tmp26_ = photo_metadata_KEYWORD_TAGS;
#line 966 "../src/photos/PhotoMetadata.vala"
		_tmp26__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 966 "../src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp26_, (gint) _tmp26__length1);
#line 967 "../src/photos/PhotoMetadata.vala"
		photo_metadata_internal_set_hierarchical_keywords (self, NULL);
#line 6833 "PhotoMetadata.c"
	}
#line 943 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (flat_keywords);
#line 943 "../src/photos/PhotoMetadata.vala"
	_hierarchical_tag_index_unref0 (htag_index);
#line 6839 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_hierarchical_keywords (PhotoMetadata* self)
{
	gboolean result = FALSE;
	HierarchicalKeywordField** _tmp0_;
	gint _tmp0__length1;
#line 971 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 972 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 972 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 6854 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 972 "../src/photos/PhotoMetadata.vala"
		field_collection = _tmp0_;
#line 972 "../src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp0__length1;
#line 972 "../src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < _tmp0__length1; field_it = field_it + 1) {
#line 6866 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp1_;
			HierarchicalKeywordField* field = NULL;
#line 972 "../src/photos/PhotoMetadata.vala"
			_tmp1_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 972 "../src/photos/PhotoMetadata.vala"
			field = _tmp1_;
#line 6873 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				HierarchicalKeywordField* _tmp2_;
				const gchar* _tmp3_;
				GeeList* _tmp4_;
				gboolean _tmp5_ = FALSE;
				GeeCollection* _tmp6_;
#line 973 "../src/photos/PhotoMetadata.vala"
				_tmp2_ = field;
#line 973 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_->field_name;
#line 973 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_string_multiple (self, _tmp3_);
#line 973 "../src/photos/PhotoMetadata.vala"
				values = (GeeCollection*) _tmp4_;
#line 975 "../src/photos/PhotoMetadata.vala"
				_tmp6_ = values;
#line 975 "../src/photos/PhotoMetadata.vala"
				if (_tmp6_ != NULL) {
#line 6893 "PhotoMetadata.c"
					GeeCollection* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
#line 975 "../src/photos/PhotoMetadata.vala"
					_tmp7_ = values;
#line 975 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = gee_collection_get_size (_tmp7_);
#line 975 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = _tmp8_;
#line 975 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = _tmp9_ > 0;
#line 6905 "PhotoMetadata.c"
				} else {
#line 975 "../src/photos/PhotoMetadata.vala"
					_tmp5_ = FALSE;
#line 6909 "PhotoMetadata.c"
				}
#line 975 "../src/photos/PhotoMetadata.vala"
				if (_tmp5_) {
#line 976 "../src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 976 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 976 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 976 "../src/photos/PhotoMetadata.vala"
					return result;
#line 6921 "PhotoMetadata.c"
				}
#line 972 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 972 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 6927 "PhotoMetadata.c"
			}
		}
	}
#line 979 "../src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 979 "../src/photos/PhotoMetadata.vala"
	return result;
#line 6935 "PhotoMetadata.c"
}

GeeSet*
photo_metadata_get_hierarchical_keywords (PhotoMetadata* self)
{
	GeeSet* result = NULL;
	GeeSet* h_keywords = NULL;
	GeeSet* _tmp0_;
	HierarchicalKeywordField** _tmp1_;
	gint _tmp1__length1;
#line 982 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 983 "../src/photos/PhotoMetadata.vala"
	_vala_assert (photo_metadata_has_hierarchical_keywords (self), "has_hierarchical_keywords ()");
#line 985 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_create_string_set (self, NULL, NULL, NULL);
#line 985 "../src/photos/PhotoMetadata.vala"
	h_keywords = _tmp0_;
#line 987 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_HIERARCHICAL_KEYWORD_TAGS;
#line 987 "../src/photos/PhotoMetadata.vala"
	_tmp1__length1 = photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1;
#line 6958 "PhotoMetadata.c"
	{
		HierarchicalKeywordField** field_collection = NULL;
		gint field_collection_length1 = 0;
		gint _field_collection_size_ = 0;
		gint field_it = 0;
#line 987 "../src/photos/PhotoMetadata.vala"
		field_collection = _tmp1_;
#line 987 "../src/photos/PhotoMetadata.vala"
		field_collection_length1 = _tmp1__length1;
#line 987 "../src/photos/PhotoMetadata.vala"
		for (field_it = 0; field_it < _tmp1__length1; field_it = field_it + 1) {
#line 6970 "PhotoMetadata.c"
			HierarchicalKeywordField* _tmp2_;
			HierarchicalKeywordField* field = NULL;
#line 987 "../src/photos/PhotoMetadata.vala"
			_tmp2_ = _hierarchical_keyword_field_ref0 (field_collection[field_it]);
#line 987 "../src/photos/PhotoMetadata.vala"
			field = _tmp2_;
#line 6977 "PhotoMetadata.c"
			{
				GeeCollection* values = NULL;
				HierarchicalKeywordField* _tmp3_;
				const gchar* _tmp4_;
				GeeList* _tmp5_;
				gboolean _tmp6_ = FALSE;
				GeeCollection* _tmp7_;
#line 988 "../src/photos/PhotoMetadata.vala"
				_tmp3_ = field;
#line 988 "../src/photos/PhotoMetadata.vala"
				_tmp4_ = _tmp3_->field_name;
#line 988 "../src/photos/PhotoMetadata.vala"
				_tmp5_ = photo_metadata_get_string_multiple (self, _tmp4_);
#line 988 "../src/photos/PhotoMetadata.vala"
				values = (GeeCollection*) _tmp5_;
#line 990 "../src/photos/PhotoMetadata.vala"
				_tmp7_ = values;
#line 990 "../src/photos/PhotoMetadata.vala"
				if (_tmp7_ == NULL) {
#line 990 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = TRUE;
#line 6999 "PhotoMetadata.c"
				} else {
					GeeCollection* _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
#line 990 "../src/photos/PhotoMetadata.vala"
					_tmp8_ = values;
#line 990 "../src/photos/PhotoMetadata.vala"
					_tmp9_ = gee_collection_get_size (_tmp8_);
#line 990 "../src/photos/PhotoMetadata.vala"
					_tmp10_ = _tmp9_;
#line 990 "../src/photos/PhotoMetadata.vala"
					_tmp6_ = _tmp10_ < 1;
#line 7012 "PhotoMetadata.c"
				}
#line 990 "../src/photos/PhotoMetadata.vala"
				if (_tmp6_) {
#line 991 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (values);
#line 991 "../src/photos/PhotoMetadata.vala"
					_hierarchical_keyword_field_unref0 (field);
#line 991 "../src/photos/PhotoMetadata.vala"
					continue;
#line 7022 "PhotoMetadata.c"
				}
				{
					GeeIterator* _current_value_it = NULL;
					GeeCollection* _tmp11_;
					GeeIterator* _tmp12_;
#line 993 "../src/photos/PhotoMetadata.vala"
					_tmp11_ = values;
#line 993 "../src/photos/PhotoMetadata.vala"
					_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 993 "../src/photos/PhotoMetadata.vala"
					_current_value_it = _tmp12_;
#line 993 "../src/photos/PhotoMetadata.vala"
					while (TRUE) {
#line 7036 "PhotoMetadata.c"
						GeeIterator* _tmp13_;
						gchar* current_value = NULL;
						GeeIterator* _tmp14_;
						gpointer _tmp15_;
						gchar* canonicalized = NULL;
						const gchar* _tmp16_;
						HierarchicalKeywordField* _tmp17_;
						const gchar* _tmp18_;
						gchar* _tmp19_;
						const gchar* _tmp20_;
#line 993 "../src/photos/PhotoMetadata.vala"
						_tmp13_ = _current_value_it;
#line 993 "../src/photos/PhotoMetadata.vala"
						if (!gee_iterator_next (_tmp13_)) {
#line 993 "../src/photos/PhotoMetadata.vala"
							break;
#line 7053 "PhotoMetadata.c"
						}
#line 993 "../src/photos/PhotoMetadata.vala"
						_tmp14_ = _current_value_it;
#line 993 "../src/photos/PhotoMetadata.vala"
						_tmp15_ = gee_iterator_get (_tmp14_);
#line 993 "../src/photos/PhotoMetadata.vala"
						current_value = (gchar*) _tmp15_;
#line 994 "../src/photos/PhotoMetadata.vala"
						_tmp16_ = current_value;
#line 994 "../src/photos/PhotoMetadata.vala"
						_tmp17_ = field;
#line 994 "../src/photos/PhotoMetadata.vala"
						_tmp18_ = _tmp17_->path_separator;
#line 994 "../src/photos/PhotoMetadata.vala"
						_tmp19_ = hierarchical_tag_utilities_canonicalize (_tmp16_, _tmp18_);
#line 994 "../src/photos/PhotoMetadata.vala"
						canonicalized = _tmp19_;
#line 997 "../src/photos/PhotoMetadata.vala"
						_tmp20_ = canonicalized;
#line 997 "../src/photos/PhotoMetadata.vala"
						if (_tmp20_ != NULL) {
#line 7075 "PhotoMetadata.c"
							GeeSet* _tmp21_;
							const gchar* _tmp22_;
#line 998 "../src/photos/PhotoMetadata.vala"
							_tmp21_ = h_keywords;
#line 998 "../src/photos/PhotoMetadata.vala"
							_tmp22_ = canonicalized;
#line 998 "../src/photos/PhotoMetadata.vala"
							gee_collection_add ((GeeCollection*) _tmp21_, _tmp22_);
#line 7084 "PhotoMetadata.c"
						}
#line 993 "../src/photos/PhotoMetadata.vala"
						_g_free0 (canonicalized);
#line 993 "../src/photos/PhotoMetadata.vala"
						_g_free0 (current_value);
#line 7090 "PhotoMetadata.c"
					}
#line 993 "../src/photos/PhotoMetadata.vala"
					_g_object_unref0 (_current_value_it);
#line 7094 "PhotoMetadata.c"
				}
#line 987 "../src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 987 "../src/photos/PhotoMetadata.vala"
				_hierarchical_keyword_field_unref0 (field);
#line 7100 "PhotoMetadata.c"
			}
		}
	}
#line 1002 "../src/photos/PhotoMetadata.vala"
	result = h_keywords;
#line 1002 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7108 "PhotoMetadata.c"
}

gboolean
photo_metadata_has_orientation (PhotoMetadata* self)
{
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_;
#line 1005 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1006 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1006 "../src/photos/PhotoMetadata.vala"
	result = gexiv2_metadata_get_orientation (_tmp0_) == GEXIV2_ORIENTATION_UNSPECIFIED;
#line 1006 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7124 "PhotoMetadata.c"
}

Orientation
photo_metadata_get_orientation (PhotoMetadata* self)
{
	Orientation result = 0;
	GExiv2Orientation orientation = 0;
	GExiv2Metadata* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GExiv2Orientation _tmp3_;
#line 1010 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1013 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1013 "../src/photos/PhotoMetadata.vala"
	orientation = gexiv2_metadata_get_orientation (_tmp0_);
#line 1014 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = orientation;
#line 1014 "../src/photos/PhotoMetadata.vala"
	if (_tmp3_ == GEXIV2_ORIENTATION_UNSPECIFIED) {
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 7148 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp4_;
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = orientation;
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = _tmp4_ < ORIENTATION_MIN;
#line 7155 "PhotoMetadata.c"
	}
#line 1014 "../src/photos/PhotoMetadata.vala"
	if (_tmp2_) {
#line 1014 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = TRUE;
#line 7161 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp5_;
#line 1015 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = orientation;
#line 1015 "../src/photos/PhotoMetadata.vala"
		_tmp1_ = _tmp5_ > ORIENTATION_MAX;
#line 7168 "PhotoMetadata.c"
	}
#line 1014 "../src/photos/PhotoMetadata.vala"
	if (_tmp1_) {
#line 1016 "../src/photos/PhotoMetadata.vala"
		result = ORIENTATION_TOP_LEFT;
#line 1016 "../src/photos/PhotoMetadata.vala"
		return result;
#line 7176 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp6_;
#line 1018 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = orientation;
#line 1018 "../src/photos/PhotoMetadata.vala"
		result = (Orientation) _tmp6_;
#line 1018 "../src/photos/PhotoMetadata.vala"
		return result;
#line 7185 "PhotoMetadata.c"
	}
}

void
photo_metadata_set_orientation (PhotoMetadata* self,
                                Orientation orientation)
{
	GExiv2Metadata* _tmp0_;
#line 1021 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 1023 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1023 "../src/photos/PhotoMetadata.vala"
	gexiv2_metadata_set_orientation (_tmp0_, (GExiv2Orientation) orientation);
#line 7200 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_gps (PhotoMetadata* self,
                        gdouble* longitude,
                        gchar* * long_ref,
                        gdouble* latitude,
                        gchar* * lat_ref,
                        gdouble* altitude)
{
	gdouble _vala_longitude = 0.0;
	gchar* _vala_long_ref = NULL;
	gdouble _vala_latitude = 0.0;
	gchar* _vala_lat_ref = NULL;
	gdouble _vala_altitude = 0.0;
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gboolean _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 1026 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1028 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 1028 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_gps_info (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 1028 "../src/photos/PhotoMetadata.vala"
	_vala_longitude = _tmp1_;
#line 1028 "../src/photos/PhotoMetadata.vala"
	_vala_latitude = _tmp2_;
#line 1028 "../src/photos/PhotoMetadata.vala"
	_vala_altitude = _tmp3_;
#line 1028 "../src/photos/PhotoMetadata.vala"
	if (!_tmp4_) {
#line 1029 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 1029 "../src/photos/PhotoMetadata.vala"
		_vala_long_ref = NULL;
#line 1030 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 1030 "../src/photos/PhotoMetadata.vala"
		_vala_lat_ref = NULL;
#line 1032 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1032 "../src/photos/PhotoMetadata.vala"
		if (longitude) {
#line 1032 "../src/photos/PhotoMetadata.vala"
			*longitude = _vala_longitude;
#line 7252 "PhotoMetadata.c"
		}
#line 1032 "../src/photos/PhotoMetadata.vala"
		if (long_ref) {
#line 1032 "../src/photos/PhotoMetadata.vala"
			*long_ref = _vala_long_ref;
#line 7258 "PhotoMetadata.c"
		} else {
#line 1032 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_long_ref);
#line 7262 "PhotoMetadata.c"
		}
#line 1032 "../src/photos/PhotoMetadata.vala"
		if (latitude) {
#line 1032 "../src/photos/PhotoMetadata.vala"
			*latitude = _vala_latitude;
#line 7268 "PhotoMetadata.c"
		}
#line 1032 "../src/photos/PhotoMetadata.vala"
		if (lat_ref) {
#line 1032 "../src/photos/PhotoMetadata.vala"
			*lat_ref = _vala_lat_ref;
#line 7274 "PhotoMetadata.c"
		} else {
#line 1032 "../src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_lat_ref);
#line 7278 "PhotoMetadata.c"
		}
#line 1032 "../src/photos/PhotoMetadata.vala"
		if (altitude) {
#line 1032 "../src/photos/PhotoMetadata.vala"
			*altitude = _vala_altitude;
#line 7284 "PhotoMetadata.c"
		}
#line 1032 "../src/photos/PhotoMetadata.vala"
		return result;
#line 7288 "PhotoMetadata.c"
	}
#line 1035 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1035 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_long_ref);
#line 1035 "../src/photos/PhotoMetadata.vala"
	_vala_long_ref = _tmp5_;
#line 1036 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1036 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_lat_ref);
#line 1036 "../src/photos/PhotoMetadata.vala"
	_vala_lat_ref = _tmp6_;
#line 1038 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 1038 "../src/photos/PhotoMetadata.vala"
	if (longitude) {
#line 1038 "../src/photos/PhotoMetadata.vala"
		*longitude = _vala_longitude;
#line 7308 "PhotoMetadata.c"
	}
#line 1038 "../src/photos/PhotoMetadata.vala"
	if (long_ref) {
#line 1038 "../src/photos/PhotoMetadata.vala"
		*long_ref = _vala_long_ref;
#line 7314 "PhotoMetadata.c"
	} else {
#line 1038 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 7318 "PhotoMetadata.c"
	}
#line 1038 "../src/photos/PhotoMetadata.vala"
	if (latitude) {
#line 1038 "../src/photos/PhotoMetadata.vala"
		*latitude = _vala_latitude;
#line 7324 "PhotoMetadata.c"
	}
#line 1038 "../src/photos/PhotoMetadata.vala"
	if (lat_ref) {
#line 1038 "../src/photos/PhotoMetadata.vala"
		*lat_ref = _vala_lat_ref;
#line 7330 "PhotoMetadata.c"
	} else {
#line 1038 "../src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 7334 "PhotoMetadata.c"
	}
#line 1038 "../src/photos/PhotoMetadata.vala"
	if (altitude) {
#line 1038 "../src/photos/PhotoMetadata.vala"
		*altitude = _vala_altitude;
#line 7340 "PhotoMetadata.c"
	}
#line 1038 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7344 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_exposure (PhotoMetadata* self,
                             MetadataRational* exposure)
{
	MetadataRational _vala_exposure = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
#line 1041 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1042 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1042 "../src/photos/PhotoMetadata.vala"
	_vala_exposure = _tmp0_;
#line 1042 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1042 "../src/photos/PhotoMetadata.vala"
	if (exposure) {
#line 1042 "../src/photos/PhotoMetadata.vala"
		*exposure = _vala_exposure;
#line 7367 "PhotoMetadata.c"
	}
#line 1042 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7371 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_exposure_string (PhotoMetadata* self)
{
	gchar* result = NULL;
	MetadataRational exposure_time = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gchar* _tmp2_;
#line 1045 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1047 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 1047 "../src/photos/PhotoMetadata.vala"
	exposure_time = _tmp0_;
#line 1047 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1048 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1048 "../src/photos/PhotoMetadata.vala"
		return result;
#line 7394 "PhotoMetadata.c"
	}
#line 1050 "../src/photos/PhotoMetadata.vala"
	if (!metadata_rational_is_valid (&exposure_time)) {
#line 1051 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1051 "../src/photos/PhotoMetadata.vala"
		return result;
#line 7402 "PhotoMetadata.c"
	}
#line 1053 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureTime", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1053 "../src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1053 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7410 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_iso (PhotoMetadata* self,
                        glong* iso)
{
	glong _vala_iso = 0L;
	gboolean result = FALSE;
	gboolean fetched_ok = FALSE;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1056 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1057 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.ISOSpeedRatings", &_tmp0_);
#line 1057 "../src/photos/PhotoMetadata.vala"
	_vala_iso = _tmp0_;
#line 1057 "../src/photos/PhotoMetadata.vala"
	fetched_ok = _tmp1_;
#line 1059 "../src/photos/PhotoMetadata.vala"
	if (fetched_ok == FALSE) {
#line 1060 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1060 "../src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1060 "../src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 7439 "PhotoMetadata.c"
		}
#line 1060 "../src/photos/PhotoMetadata.vala"
		return result;
#line 7443 "PhotoMetadata.c"
	}
#line 1064 "../src/photos/PhotoMetadata.vala"
	if (_vala_iso < ((glong) 6)) {
#line 1064 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 7449 "PhotoMetadata.c"
	} else {
#line 1064 "../src/photos/PhotoMetadata.vala"
		_tmp2_ = _vala_iso > ((glong) 409600);
#line 7453 "PhotoMetadata.c"
	}
#line 1064 "../src/photos/PhotoMetadata.vala"
	if (_tmp2_) {
#line 1065 "../src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 1065 "../src/photos/PhotoMetadata.vala"
		if (iso) {
#line 1065 "../src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 7463 "PhotoMetadata.c"
		}
#line 1065 "../src/photos/PhotoMetadata.vala"
		return result;
#line 7467 "PhotoMetadata.c"
	}
#line 1067 "../src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 1067 "../src/photos/PhotoMetadata.vala"
	if (iso) {
#line 1067 "../src/photos/PhotoMetadata.vala"
		*iso = _vala_iso;
#line 7475 "PhotoMetadata.c"
	}
#line 1067 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7479 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_iso_string (PhotoMetadata* self)
{
	gchar* result = NULL;
	glong iso = 0L;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
	gchar* _tmp2_;
#line 1070 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1072 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_iso (self, &_tmp0_);
#line 1072 "../src/photos/PhotoMetadata.vala"
	iso = _tmp0_;
#line 1072 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1073 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1073 "../src/photos/PhotoMetadata.vala"
		return result;
#line 7502 "PhotoMetadata.c"
	}
#line 1075 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ISOSpeedRatings", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1075 "../src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1075 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7510 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_aperture (PhotoMetadata* self,
                             MetadataRational* aperture)
{
	MetadataRational _vala_aperture = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
#line 1078 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1079 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FNumber", &_tmp0_);
#line 1079 "../src/photos/PhotoMetadata.vala"
	_vala_aperture = _tmp0_;
#line 1079 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1079 "../src/photos/PhotoMetadata.vala"
	if (aperture) {
#line 1079 "../src/photos/PhotoMetadata.vala"
		*aperture = _vala_aperture;
#line 7533 "PhotoMetadata.c"
	}
#line 1079 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7537 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_aperture_string (PhotoMetadata* self,
                                    gboolean pango_formatted)
{
	gchar* result = NULL;
	MetadataRational aperture = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
	gdouble aperture_value = 0.0;
	MetadataRational _tmp2_;
	MetadataRational _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 1082 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1084 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_aperture (self, &_tmp0_);
#line 1084 "../src/photos/PhotoMetadata.vala"
	aperture = _tmp0_;
#line 1084 "../src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 1085 "../src/photos/PhotoMetadata.vala"
		result = NULL;
#line 1085 "../src/photos/PhotoMetadata.vala"
		return result;
#line 7569 "PhotoMetadata.c"
	}
#line 1087 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = aperture;
#line 1087 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = aperture;
#line 1087 "../src/photos/PhotoMetadata.vala"
	aperture_value = ((gdouble) _tmp2_.numerator) / ((gdouble) _tmp3_.denominator);
#line 1088 "../src/photos/PhotoMetadata.vala"
	aperture_value = ((gint) (aperture_value * 10.0)) / 10.0;
#line 1090 "../src/photos/PhotoMetadata.vala"
	if (pango_formatted) {
#line 1090 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = "<i>f</i>/";
#line 7583 "PhotoMetadata.c"
	} else {
#line 1090 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = "f/";
#line 7587 "PhotoMetadata.c"
	}
#line 1091 "../src/photos/PhotoMetadata.vala"
	if (fmod (aperture_value, 1) == ((gdouble) 0)) {
#line 1091 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = "%.0f";
#line 7593 "PhotoMetadata.c"
	} else {
#line 1091 "../src/photos/PhotoMetadata.vala"
		_tmp5_ = "%.1f";
#line 7597 "PhotoMetadata.c"
	}
#line 1090 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = g_strdup_printf (_tmp5_, aperture_value);
#line 1090 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp6_;
#line 1090 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = g_strconcat (_tmp4_, _tmp7_, NULL);
#line 1090 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = _tmp8_;
#line 1090 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp7_);
#line 1090 "../src/photos/PhotoMetadata.vala"
	result = _tmp9_;
#line 1090 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7613 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_camera_make (PhotoMetadata* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1094 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1095 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Make", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1095 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1095 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7629 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_camera_model (PhotoMetadata* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1098 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1099 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Model", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1099 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1099 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7645 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_flash (PhotoMetadata* self,
                          glong* flash)
{
	glong _vala_flash = 0L;
	gboolean result = FALSE;
	glong _tmp0_ = 0L;
	gboolean _tmp1_;
#line 1102 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1104 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.Flash", &_tmp0_);
#line 1104 "../src/photos/PhotoMetadata.vala"
	_vala_flash = _tmp0_;
#line 1104 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1104 "../src/photos/PhotoMetadata.vala"
	if (flash) {
#line 1104 "../src/photos/PhotoMetadata.vala"
		*flash = _vala_flash;
#line 7668 "PhotoMetadata.c"
	}
#line 1104 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7672 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_flash_string (PhotoMetadata* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1107 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1109 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.Flash", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1109 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1109 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7688 "PhotoMetadata.c"
}

gboolean
photo_metadata_get_focal_length (PhotoMetadata* self,
                                 MetadataRational* focal_length)
{
	MetadataRational _vala_focal_length = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_;
#line 1112 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1113 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FocalLength", &_tmp0_);
#line 1113 "../src/photos/PhotoMetadata.vala"
	_vala_focal_length = _tmp0_;
#line 1113 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1113 "../src/photos/PhotoMetadata.vala"
	if (focal_length) {
#line 1113 "../src/photos/PhotoMetadata.vala"
		*focal_length = _vala_focal_length;
#line 7711 "PhotoMetadata.c"
	}
#line 1113 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7715 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_focal_length_string (PhotoMetadata* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1116 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1117 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.FocalLength", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1117 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1117 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7731 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_artist (PhotoMetadata* self)
{
	gchar* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
#line 1125 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1126 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_ARTIST_TAGS;
#line 1126 "../src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_ARTIST_TAGS_length1;
#line 1126 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string_interpreted (self, _tmp0_, (gint) _tmp0__length1);
#line 1126 "../src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 1126 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7753 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_copyright (PhotoMetadata* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1129 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1130 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Copyright", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1130 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1130 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7769 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_software (PhotoMetadata* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1133 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1134 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Software", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1134 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1134 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7785 "PhotoMetadata.c"
}

void
photo_metadata_set_software (PhotoMetadata* self,
                             const gchar* software,
                             const gchar* version)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1137 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 1137 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (software != NULL);
#line 1137 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (version != NULL);
#line 1139 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup_printf ("%s %s", software, version);
#line 1139 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_;
#line 1139 "../src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Exif.Image.Software", _tmp1_, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1139 "../src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp1_);
#line 1141 "../src/photos/PhotoMetadata.vala"
	if (photo_metadata_has_iptc (self)) {
#line 1142 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.Program", software, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1143 "../src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.ProgramVersion", version, PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 7815 "PhotoMetadata.c"
	}
}

void
photo_metadata_remove_software (PhotoMetadata* self)
{
#line 1147 "../src/photos/PhotoMetadata.vala"
	g_return_if_fail (self != NULL);
#line 1148 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Exif.Image.Software");
#line 1149 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.Program");
#line 1150 "../src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.ProgramVersion");
#line 7830 "PhotoMetadata.c"
}

gchar*
photo_metadata_get_exposure_bias (PhotoMetadata* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1153 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1154 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureBiasValue", PHOTO_METADATA_PREPARE_STRING_OPTIONS);
#line 1154 "../src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 1154 "../src/photos/PhotoMetadata.vala"
	return result;
#line 7846 "PhotoMetadata.c"
}

static gpointer
_media_metadata_ref0 (gpointer self)
{
#line 136 "../src/photos/PhotoMetadata.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 7854 "PhotoMetadata.c"
}

static PhotoMetadataInternalPhotoPreview*
photo_metadata_internal_photo_preview_construct (GType object_type,
                                                 PhotoMetadata* owner,
                                                 const gchar* name,
                                                 guint number,
                                                 GExiv2PreviewProperties* props)
{
	PhotoMetadataInternalPhotoPreview* self = NULL;
	Dimensions _tmp0_ = {0};
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoMetadata* _tmp3_;
#line 131 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 131 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 131 "../src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (props != NULL, NULL);
#line 133 "../src/photos/PhotoMetadata.vala"
	dimensions_init (&_tmp0_, (gint) gexiv2_preview_properties_get_width (props), (gint) gexiv2_preview_properties_get_height (props));
#line 133 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_preview_properties_get_mime_type (props);
#line 133 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_preview_properties_get_extension (props);
#line 133 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) photo_preview_construct (object_type, name, &_tmp0_, gexiv2_preview_properties_get_size (props), _tmp1_, _tmp2_);
#line 136 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _media_metadata_ref0 (owner);
#line 136 "../src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 136 "../src/photos/PhotoMetadata.vala"
	self->owner = _tmp3_;
#line 137 "../src/photos/PhotoMetadata.vala"
	self->number = number;
#line 131 "../src/photos/PhotoMetadata.vala"
	return self;
#line 7893 "PhotoMetadata.c"
}

static PhotoMetadataInternalPhotoPreview*
photo_metadata_internal_photo_preview_new (PhotoMetadata* owner,
                                           const gchar* name,
                                           guint number,
                                           GExiv2PreviewProperties* props)
{
#line 131 "../src/photos/PhotoMetadata.vala"
	return photo_metadata_internal_photo_preview_construct (PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, owner, name, number, props);
#line 7904 "PhotoMetadata.c"
}

static guint8*
_vala_array_dup21 (guint8* self,
                   int length)
{
#line 144 "../src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 7913 "PhotoMetadata.c"
}

static guint8*
photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base,
                                                    gint* result_length1,
                                                    GError** error)
{
	PhotoMetadataInternalPhotoPreview * self;
	guint8* result = NULL;
	GExiv2PreviewProperties** props = NULL;
	PhotoMetadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	GExiv2PreviewProperties** _tmp3_;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp4_ = FALSE;
	GExiv2PreviewProperties** _tmp5_;
	gint _tmp5__length1;
	PhotoMetadata* _tmp7_;
	GExiv2Metadata* _tmp8_;
	GExiv2PreviewProperties** _tmp9_;
	gint _tmp9__length1;
	GExiv2PreviewProperties* _tmp10_;
	GExiv2PreviewImage* _tmp11_;
	GExiv2PreviewImage* _tmp12_;
	guint32 _tmp13_ = 0;
	guint8* _tmp14_;
	guint8* _tmp15_;
	gint _tmp15__length1;
	guint8* _tmp16_;
	gint _tmp16__length1;
	guint8* _tmp17_;
	gint _tmp17__length1;
#line 140 "../src/photos/PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) base;
#line 141 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = self->owner;
#line 141 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_->priv->exiv2;
#line 141 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_ = gexiv2_metadata_get_preview_properties (_tmp1_);
#line 141 "../src/photos/PhotoMetadata.vala"
	props = _tmp3_;
#line 141 "../src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp2_);
#line 141 "../src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 142 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = props;
#line 142 "../src/photos/PhotoMetadata.vala"
	_tmp5__length1 = props_length1;
#line 142 "../src/photos/PhotoMetadata.vala"
	if (_tmp5_ != NULL) {
#line 7968 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp6_;
		gint _tmp6__length1;
#line 142 "../src/photos/PhotoMetadata.vala"
		_tmp6_ = props;
#line 142 "../src/photos/PhotoMetadata.vala"
		_tmp6__length1 = props_length1;
#line 142 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = ((guint) _tmp6__length1) > self->number;
#line 7977 "PhotoMetadata.c"
	} else {
#line 142 "../src/photos/PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 7981 "PhotoMetadata.c"
	}
#line 142 "../src/photos/PhotoMetadata.vala"
	_vala_assert (_tmp4_, "props != null  &&props.length > number");
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = self->owner;
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp7_->priv->exiv2;
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = props;
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp9__length1 = props_length1;
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = _tmp9_[self->number];
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = gexiv2_metadata_get_preview_image (_tmp8_, _tmp10_);
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = _tmp11_;
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = gexiv2_preview_image_get_data (_tmp12_, &_tmp13_);
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp15_ = (_tmp14_ != NULL) ? _vala_array_dup21 (_tmp14_, _tmp13_) : ((gpointer) _tmp14_);
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp15__length1 = _tmp13_;
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp16_ = _tmp15_;
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp16__length1 = _tmp15__length1;
#line 144 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_tmp12_);
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp17_ = _tmp16_;
#line 144 "../src/photos/PhotoMetadata.vala"
	_tmp17__length1 = _tmp16__length1;
#line 144 "../src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 144 "../src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp17__length1;
#line 8019 "PhotoMetadata.c"
	}
#line 144 "../src/photos/PhotoMetadata.vala"
	result = _tmp17_;
#line 144 "../src/photos/PhotoMetadata.vala"
	return result;
#line 8025 "PhotoMetadata.c"
}

static void
photo_metadata_internal_photo_preview_class_init (PhotoMetadataInternalPhotoPreviewClass * klass,
                                                  gpointer klass_data)
{
#line 127 "../src/photos/PhotoMetadata.vala"
	photo_metadata_internal_photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 127 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->finalize = photo_metadata_internal_photo_preview_finalize;
#line 127 "../src/photos/PhotoMetadata.vala"
	((PhotoPreviewClass *) klass)->flatten = (guint8* (*) (PhotoPreview*, gint*, GError**)) photo_metadata_internal_photo_preview_real_flatten;
#line 8038 "PhotoMetadata.c"
}

static void
photo_metadata_internal_photo_preview_instance_init (PhotoMetadataInternalPhotoPreview * self,
                                                     gpointer klass)
{
}

static void
photo_metadata_internal_photo_preview_finalize (PhotoPreview * obj)
{
	PhotoMetadataInternalPhotoPreview * self;
#line 127 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview);
#line 128 "../src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 127 "../src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (photo_metadata_internal_photo_preview_parent_class)->finalize (obj);
#line 8057 "PhotoMetadata.c"
}

static GType
photo_metadata_internal_photo_preview_get_type (void)
{
	static volatile gsize photo_metadata_internal_photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_internal_photo_preview_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataInternalPhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_internal_photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadataInternalPhotoPreview), 0, (GInstanceInitFunc) photo_metadata_internal_photo_preview_instance_init, NULL };
		GType photo_metadata_internal_photo_preview_type_id;
		photo_metadata_internal_photo_preview_type_id = g_type_register_static (TYPE_PHOTO_PREVIEW, "PhotoMetadataInternalPhotoPreview", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_internal_photo_preview_type_id__volatile, photo_metadata_internal_photo_preview_type_id);
	}
	return photo_metadata_internal_photo_preview_type_id__volatile;
}

static void
photo_metadata_class_init (PhotoMetadataClass * klass,
                           gpointer klass_data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar** _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar** _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar** _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar** _tmp31_;
	HierarchicalKeywordField* _tmp32_;
	HierarchicalKeywordField* _tmp33_;
	HierarchicalKeywordField* _tmp34_;
	HierarchicalKeywordField** _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar** _tmp38_;
#line 112 "../src/photos/PhotoMetadata.vala"
	photo_metadata_parent_class = g_type_class_peek_parent (klass);
#line 112 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->finalize = photo_metadata_finalize;
#line 112 "../src/photos/PhotoMetadata.vala"
	g_type_class_adjust_private_offset (klass, &PhotoMetadata_private_offset);
#line 112 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->read_from_file = (void (*) (MediaMetadata*, GFile*, GError**)) photo_metadata_real_read_from_file;
#line 112 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_creation_date_time = (MetadataDateTime* (*) (MediaMetadata*)) photo_metadata_real_get_creation_date_time;
#line 112 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_title = (gchar* (*) (MediaMetadata*)) photo_metadata_real_get_title;
#line 112 "../src/photos/PhotoMetadata.vala"
	((MediaMetadataClass *) klass)->get_comment = (gchar* (*) (MediaMetadata*)) photo_metadata_real_get_comment;
#line 705 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup ("Exif.Image.DateTime");
#line 705 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("Xmp.tiff.DateTime");
#line 705 "../src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup ("Xmp.xmp.ModifyDate");
#line 705 "../src/photos/PhotoMetadata.vala"
	_tmp3_ = g_new0 (gchar*, 3 + 1);
#line 705 "../src/photos/PhotoMetadata.vala"
	_tmp3_[0] = _tmp0_;
#line 705 "../src/photos/PhotoMetadata.vala"
	_tmp3_[1] = _tmp1_;
#line 705 "../src/photos/PhotoMetadata.vala"
	_tmp3_[2] = _tmp2_;
#line 705 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS = _tmp3_;
#line 705 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS_length1 = 3;
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp4_ = g_strdup ("Exif.Photo.DateTimeOriginal");
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp5_ = g_strdup ("Xmp.exif.DateTimeOriginal");
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp6_ = g_strdup ("Xmp.xmp.CreateDate");
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp8_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp9_ = g_strdup ("Exif.Image.DateTime");
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp10_ = g_new0 (gchar*, 6 + 1);
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp10_[0] = _tmp4_;
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp10_[1] = _tmp5_;
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp10_[2] = _tmp6_;
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp10_[3] = _tmp7_;
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp10_[4] = _tmp8_;
#line 723 "../src/photos/PhotoMetadata.vala"
	_tmp10_[5] = _tmp9_;
#line 723 "../src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS = _tmp10_;
#line 723 "../src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 6;
#line 744 "../src/photos/PhotoMetadata.vala"
	_tmp11_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 744 "../src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 744 "../src/photos/PhotoMetadata.vala"
	_tmp13_ = g_new0 (gchar*, 2 + 1);
#line 744 "../src/photos/PhotoMetadata.vala"
	_tmp13_[0] = _tmp11_;
#line 744 "../src/photos/PhotoMetadata.vala"
	_tmp13_[1] = _tmp12_;
#line 744 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS = _tmp13_;
#line 744 "../src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 2;
#line 769 "../src/photos/PhotoMetadata.vala"
	_tmp14_ = g_strdup ("Exif.Photo.PixelXDimension");
#line 769 "../src/photos/PhotoMetadata.vala"
	_tmp15_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 769 "../src/photos/PhotoMetadata.vala"
	_tmp16_ = g_strdup ("Xmp.tiff.ImageWidth");
#line 769 "../src/photos/PhotoMetadata.vala"
	_tmp17_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 769 "../src/photos/PhotoMetadata.vala"
	_tmp18_ = g_new0 (gchar*, 4 + 1);
#line 769 "../src/photos/PhotoMetadata.vala"
	_tmp18_[0] = _tmp14_;
#line 769 "../src/photos/PhotoMetadata.vala"
	_tmp18_[1] = _tmp15_;
#line 769 "../src/photos/PhotoMetadata.vala"
	_tmp18_[2] = _tmp16_;
#line 769 "../src/photos/PhotoMetadata.vala"
	_tmp18_[3] = _tmp17_;
#line 769 "../src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS = _tmp18_;
#line 769 "../src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS_length1 = 4;
#line 776 "../src/photos/PhotoMetadata.vala"
	_tmp19_ = g_strdup ("Exif.Photo.PixelYDimension");
#line 776 "../src/photos/PhotoMetadata.vala"
	_tmp20_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 776 "../src/photos/PhotoMetadata.vala"
	_tmp21_ = g_strdup ("Xmp.tiff.ImageHeight");
#line 776 "../src/photos/PhotoMetadata.vala"
	_tmp22_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 776 "../src/photos/PhotoMetadata.vala"
	_tmp23_ = g_new0 (gchar*, 4 + 1);
#line 776 "../src/photos/PhotoMetadata.vala"
	_tmp23_[0] = _tmp19_;
#line 776 "../src/photos/PhotoMetadata.vala"
	_tmp23_[1] = _tmp20_;
#line 776 "../src/photos/PhotoMetadata.vala"
	_tmp23_[2] = _tmp21_;
#line 776 "../src/photos/PhotoMetadata.vala"
	_tmp23_[3] = _tmp22_;
#line 776 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS = _tmp23_;
#line 776 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS_length1 = 4;
#line 835 "../src/photos/PhotoMetadata.vala"
	_tmp24_ = g_strdup ("Iptc.Application2.Caption");
#line 835 "../src/photos/PhotoMetadata.vala"
	_tmp25_ = g_strdup ("Xmp.dc.title");
#line 835 "../src/photos/PhotoMetadata.vala"
	_tmp26_ = g_strdup ("Iptc.Application2.Headline");
#line 835 "../src/photos/PhotoMetadata.vala"
	_tmp27_ = g_strdup ("Xmp.photoshop.Headline");
#line 835 "../src/photos/PhotoMetadata.vala"
	_tmp28_ = g_new0 (gchar*, 4 + 1);
#line 835 "../src/photos/PhotoMetadata.vala"
	_tmp28_[0] = _tmp24_;
#line 835 "../src/photos/PhotoMetadata.vala"
	_tmp28_[1] = _tmp25_;
#line 835 "../src/photos/PhotoMetadata.vala"
	_tmp28_[2] = _tmp26_;
#line 835 "../src/photos/PhotoMetadata.vala"
	_tmp28_[3] = _tmp27_;
#line 835 "../src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS = _tmp28_;
#line 835 "../src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS_length1 = 4;
#line 890 "../src/photos/PhotoMetadata.vala"
	_tmp29_ = g_strdup ("Xmp.dc.subject");
#line 890 "../src/photos/PhotoMetadata.vala"
	_tmp30_ = g_strdup ("Iptc.Application2.Keywords");
#line 890 "../src/photos/PhotoMetadata.vala"
	_tmp31_ = g_new0 (gchar*, 2 + 1);
#line 890 "../src/photos/PhotoMetadata.vala"
	_tmp31_[0] = _tmp29_;
#line 890 "../src/photos/PhotoMetadata.vala"
	_tmp31_[1] = _tmp30_;
#line 890 "../src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS = _tmp31_;
#line 890 "../src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS_length1 = 2;
#line 895 "../src/photos/PhotoMetadata.vala"
	_tmp32_ = hierarchical_keyword_field_new ("Xmp.lr.hierarchicalSubject", "|", FALSE, TRUE);
#line 895 "../src/photos/PhotoMetadata.vala"
	_tmp33_ = hierarchical_keyword_field_new ("Xmp.digiKam.TagsList", "/", FALSE, TRUE);
#line 895 "../src/photos/PhotoMetadata.vala"
	_tmp34_ = hierarchical_keyword_field_new ("Xmp.MicrosoftPhoto.LastKeywordXMP", "/", FALSE, TRUE);
#line 895 "../src/photos/PhotoMetadata.vala"
	_tmp35_ = g_new0 (HierarchicalKeywordField*, 3 + 1);
#line 895 "../src/photos/PhotoMetadata.vala"
	_tmp35_[0] = _tmp32_;
#line 895 "../src/photos/PhotoMetadata.vala"
	_tmp35_[1] = _tmp33_;
#line 895 "../src/photos/PhotoMetadata.vala"
	_tmp35_[2] = _tmp34_;
#line 895 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS = _tmp35_;
#line 895 "../src/photos/PhotoMetadata.vala"
	photo_metadata_HIERARCHICAL_KEYWORD_TAGS_length1 = 3;
#line 1120 "../src/photos/PhotoMetadata.vala"
	_tmp36_ = g_strdup ("Exif.Image.Artist");
#line 1120 "../src/photos/PhotoMetadata.vala"
	_tmp37_ = g_strdup ("Exif.Canon.OwnerName");
#line 1120 "../src/photos/PhotoMetadata.vala"
	_tmp38_ = g_new0 (gchar*, 2 + 1);
#line 1120 "../src/photos/PhotoMetadata.vala"
	_tmp38_[0] = _tmp36_;
#line 1120 "../src/photos/PhotoMetadata.vala"
	_tmp38_[1] = _tmp37_;
#line 1120 "../src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS = _tmp38_;
#line 1120 "../src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS_length1 = 2;
#line 8304 "PhotoMetadata.c"
}

static void
photo_metadata_instance_init (PhotoMetadata * self,
                              gpointer klass)
{
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
#line 112 "../src/photos/PhotoMetadata.vala"
	self->priv = photo_metadata_get_instance_private (self);
#line 148 "../src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 148 "../src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 149 "../src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 150 "../src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("<uninitialized>");
#line 150 "../src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp1_;
#line 8325 "PhotoMetadata.c"
}

static void
photo_metadata_finalize (MediaMetadata * obj)
{
	PhotoMetadata * self;
#line 112 "../src/photos/PhotoMetadata.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_METADATA, PhotoMetadata);
#line 148 "../src/photos/PhotoMetadata.vala"
	_g_object_unref0 (self->priv->exiv2);
#line 149 "../src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 150 "../src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 112 "../src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (photo_metadata_parent_class)->finalize (obj);
#line 8342 "PhotoMetadata.c"
}

GType
photo_metadata_get_type (void)
{
	static volatile gsize photo_metadata_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadata), 0, (GInstanceInitFunc) photo_metadata_instance_init, NULL };
		GType photo_metadata_type_id;
		photo_metadata_type_id = g_type_register_static (TYPE_MEDIA_METADATA, "PhotoMetadata", &g_define_type_info, 0);
		PhotoMetadata_private_offset = g_type_add_instance_private (photo_metadata_type_id, sizeof (PhotoMetadataPrivate));
		g_once_init_leave (&photo_metadata_type_id__volatile, photo_metadata_type_id);
	}
	return photo_metadata_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

